/** @file VBoxEvents.h
 * DO NOT EDIT! This is a generated file.
 * Generated from: src/VBox/Main/idl/VirtualBox.xidl (VirtualBox's interface definitions in XML)
 * Generator: src/VBox/Main/idl/comimpl.xsl
 */

/*
 * Copyright (C) 2010-2012 Oracle Corporation
 *
 * This file is part of VirtualBox Open Source Edition (OSE), as
 * available from http://www.virtualbox.org. This file is free software;
 * you can redistribute it and/or modify it under the terms of the GNU
 * General Public License (GPL) as published by the Free Software
 * Foundation, in version 2 as it comes in the "COPYING" file of the
 * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
 * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 */


#include "EventImpl.h"
// IMachineStateChangedEvent generation routine 
DECLINLINE(void) fireMachineStateChangedEvent(IEventSource* aSource, CBSTR a_machineId, MachineState_T a_state)
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnMachineStateChanged, a_machineId, a_state);
    evDesc.fire(/* do not wait for delivery */ 0);
}
// IMachineDataChangedEvent generation routine 
DECLINLINE(void) fireMachineDataChangedEvent(IEventSource* aSource, CBSTR a_machineId, BOOL a_temporary)
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnMachineDataChanged, a_machineId, a_temporary);
    evDesc.fire(/* do not wait for delivery */ 0);
}
// IMediumRegisteredEvent generation routine 
DECLINLINE(void) fireMediumRegisteredEvent(IEventSource* aSource, CBSTR a_mediumId, DeviceType_T a_mediumType, BOOL a_registered)
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnMediumRegistered, a_mediumId, a_mediumType, a_registered);
    evDesc.fire(/* do not wait for delivery */ 0);
}
// IMachineRegisteredEvent generation routine 
DECLINLINE(void) fireMachineRegisteredEvent(IEventSource* aSource, CBSTR a_machineId, BOOL a_registered)
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnMachineRegistered, a_machineId, a_registered);
    evDesc.fire(/* do not wait for delivery */ 0);
}
// ISessionStateChangedEvent generation routine 
DECLINLINE(void) fireSessionStateChangedEvent(IEventSource* aSource, CBSTR a_machineId, SessionState_T a_state)
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnSessionStateChanged, a_machineId, a_state);
    evDesc.fire(/* do not wait for delivery */ 0);
}
// IGuestPropertyChangedEvent generation routine 
DECLINLINE(void) fireGuestPropertyChangedEvent(IEventSource* aSource, CBSTR a_machineId, CBSTR a_name, CBSTR a_value, CBSTR a_flags)
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnGuestPropertyChanged, a_machineId, a_name, a_value, a_flags);
    evDesc.fire(/* do not wait for delivery */ 0);
}
// ISnapshotTakenEvent generation routine 
DECLINLINE(void) fireSnapshotTakenEvent(IEventSource* aSource, CBSTR a_machineId, CBSTR a_snapshotId)
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnSnapshotTaken, a_machineId, a_snapshotId);
    evDesc.fire(/* do not wait for delivery */ 0);
}
// ISnapshotDeletedEvent generation routine 
DECLINLINE(void) fireSnapshotDeletedEvent(IEventSource* aSource, CBSTR a_machineId, CBSTR a_snapshotId)
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnSnapshotDeleted, a_machineId, a_snapshotId);
    evDesc.fire(/* do not wait for delivery */ 0);
}
// ISnapshotChangedEvent generation routine 
DECLINLINE(void) fireSnapshotChangedEvent(IEventSource* aSource, CBSTR a_machineId, CBSTR a_snapshotId)
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnSnapshotChanged, a_machineId, a_snapshotId);
    evDesc.fire(/* do not wait for delivery */ 0);
}
// IMousePointerShapeChangedEvent generation routine 
DECLINLINE(void) fireMousePointerShapeChangedEvent(IEventSource* aSource, BOOL a_visible, BOOL a_alpha, ULONG a_xhot, ULONG a_yhot, ULONG a_width, ULONG a_height, ComSafeArrayIn(BYTE,a_shape))
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnMousePointerShapeChanged, a_visible, a_alpha, a_xhot, a_yhot, a_width, a_height, ComSafeArrayInArg(a_shape));
    evDesc.fire(/* do not wait for delivery */ 0);
}
// IMouseCapabilityChangedEvent generation routine 
DECLINLINE(void) fireMouseCapabilityChangedEvent(IEventSource* aSource, BOOL a_supportsAbsolute, BOOL a_supportsRelative, BOOL a_needsHostCursor)
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnMouseCapabilityChanged, a_supportsAbsolute, a_supportsRelative, a_needsHostCursor);
    evDesc.fire(/* do not wait for delivery */ 0);
}
// IKeyboardLedsChangedEvent generation routine 
DECLINLINE(void) fireKeyboardLedsChangedEvent(IEventSource* aSource, BOOL a_numLock, BOOL a_capsLock, BOOL a_scrollLock)
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnKeyboardLedsChanged, a_numLock, a_capsLock, a_scrollLock);
    evDesc.fire(/* do not wait for delivery */ 0);
}
// IStateChangedEvent generation routine 
DECLINLINE(void) fireStateChangedEvent(IEventSource* aSource, MachineState_T a_state)
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnStateChanged, a_state);
    evDesc.fire(/* do not wait for delivery */ 0);
}
// IAdditionsStateChangedEvent generation routine 
DECLINLINE(void) fireAdditionsStateChangedEvent(IEventSource* aSource)
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnAdditionsStateChanged);
    evDesc.fire(/* do not wait for delivery */ 0);
}
// INetworkAdapterChangedEvent generation routine 
DECLINLINE(void) fireNetworkAdapterChangedEvent(IEventSource* aSource, INetworkAdapter* a_networkAdapter)
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnNetworkAdapterChanged, a_networkAdapter);
    evDesc.fire(/* do not wait for delivery */ 0);
}
// ISerialPortChangedEvent generation routine 
DECLINLINE(void) fireSerialPortChangedEvent(IEventSource* aSource, ISerialPort* a_serialPort)
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnSerialPortChanged, a_serialPort);
    evDesc.fire(/* do not wait for delivery */ 0);
}
// IParallelPortChangedEvent generation routine 
DECLINLINE(void) fireParallelPortChangedEvent(IEventSource* aSource, IParallelPort* a_parallelPort)
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnParallelPortChanged, a_parallelPort);
    evDesc.fire(/* do not wait for delivery */ 0);
}
// IStorageControllerChangedEvent generation routine 
DECLINLINE(void) fireStorageControllerChangedEvent(IEventSource* aSource)
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnStorageControllerChanged);
    evDesc.fire(/* do not wait for delivery */ 0);
}
// IMediumChangedEvent generation routine 
DECLINLINE(void) fireMediumChangedEvent(IEventSource* aSource, IMediumAttachment* a_mediumAttachment)
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnMediumChanged, a_mediumAttachment);
    evDesc.fire(/* do not wait for delivery */ 0);
}
// IClipboardModeChangedEvent generation routine 
DECLINLINE(void) fireClipboardModeChangedEvent(IEventSource* aSource, ClipboardMode_T a_clipboardMode)
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnClipboardModeChanged, a_clipboardMode);
    evDesc.fire(/* do not wait for delivery */ 0);
}
// IDragAndDropModeChangedEvent generation routine 
DECLINLINE(void) fireDragAndDropModeChangedEvent(IEventSource* aSource, DragAndDropMode_T a_dragAndDropMode)
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnDragAndDropModeChanged, a_dragAndDropMode);
    evDesc.fire(/* do not wait for delivery */ 0);
}
// ICPUChangedEvent generation routine 
DECLINLINE(void) fireCPUChangedEvent(IEventSource* aSource, ULONG a_CPU, BOOL a_add)
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnCPUChanged, a_CPU, a_add);
    evDesc.fire(/* do not wait for delivery */ 0);
}
// ICPUExecutionCapChangedEvent generation routine 
DECLINLINE(void) fireCPUExecutionCapChangedEvent(IEventSource* aSource, ULONG a_executionCap)
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnCPUExecutionCapChanged, a_executionCap);
    evDesc.fire(/* do not wait for delivery */ 0);
}
// IGuestKeyboardEvent generation routine 
DECLINLINE(void) fireGuestKeyboardEvent(IEventSource* aSource, ComSafeArrayIn(LONG,a_scancodes))
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnGuestKeyboard, ComSafeArrayInArg(a_scancodes));
    evDesc.fire(/* do not wait for delivery */ 0);
}
// IGuestMouseEvent generation routine 
DECLINLINE(void) fireGuestMouseEvent(IEventSource* aSource, BOOL a_absolute, LONG a_x, LONG a_y, LONG a_z, LONG a_w, LONG a_buttons)
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnGuestMouse, a_absolute, a_x, a_y, a_z, a_w, a_buttons);
    evDesc.fire(/* do not wait for delivery */ 0);
}
// IVRDEServerChangedEvent generation routine 
DECLINLINE(void) fireVRDEServerChangedEvent(IEventSource* aSource)
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnVRDEServerChanged);
    evDesc.fire(/* do not wait for delivery */ 0);
}
// IVRDEServerInfoChangedEvent generation routine 
DECLINLINE(void) fireVRDEServerInfoChangedEvent(IEventSource* aSource)
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnVRDEServerInfoChanged);
    evDesc.fire(/* do not wait for delivery */ 0);
}
// IUSBControllerChangedEvent generation routine 
DECLINLINE(void) fireUSBControllerChangedEvent(IEventSource* aSource)
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnUSBControllerChanged);
    evDesc.fire(/* do not wait for delivery */ 0);
}
// IUSBDeviceStateChangedEvent generation routine 
DECLINLINE(void) fireUSBDeviceStateChangedEvent(IEventSource* aSource, IUSBDevice* a_device, BOOL a_attached, IVirtualBoxErrorInfo* a_error)
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnUSBDeviceStateChanged, a_device, a_attached, a_error);
    evDesc.fire(/* do not wait for delivery */ 0);
}
// ISharedFolderChangedEvent generation routine 
DECLINLINE(void) fireSharedFolderChangedEvent(IEventSource* aSource, Scope_T a_scope)
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnSharedFolderChanged, a_scope);
    evDesc.fire(/* do not wait for delivery */ 0);
}
// IRuntimeErrorEvent generation routine 
DECLINLINE(void) fireRuntimeErrorEvent(IEventSource* aSource, BOOL a_fatal, CBSTR a_id, CBSTR a_message)
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnRuntimeError, a_fatal, a_id, a_message);
    evDesc.fire(/* do not wait for delivery */ 0);
}
// IEventSourceChangedEvent generation routine 
DECLINLINE(void) fireEventSourceChangedEvent(IEventSource* aSource, IEventListener* a_listener, BOOL a_add)
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnEventSourceChanged, a_listener, a_add);
    evDesc.fire(/* do not wait for delivery */ 0);
}
// IExtraDataChangedEvent generation routine 
DECLINLINE(void) fireExtraDataChangedEvent(IEventSource* aSource, CBSTR a_machineId, CBSTR a_key, CBSTR a_value)
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnExtraDataChanged, a_machineId, a_key, a_value);
    evDesc.fire(/* do not wait for delivery */ 0);
}
// IExtraDataCanChangeEvent generation routine 
DECLINLINE(void) fireExtraDataCanChangeEvent(IEventSource* aSource, CBSTR a_machineId, CBSTR a_key, CBSTR a_value)
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnExtraDataCanChange, a_machineId, a_key, a_value);
    evDesc.fire(/* do not wait for delivery */ 0);
}
// ICanShowWindowEvent generation routine 
DECLINLINE(void) fireCanShowWindowEvent(IEventSource* aSource)
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnCanShowWindow);
    evDesc.fire(/* do not wait for delivery */ 0);
}
// IShowWindowEvent generation routine 
DECLINLINE(void) fireShowWindowEvent(IEventSource* aSource, LONG64 a_winId)
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnShowWindow, a_winId);
    evDesc.fire(/* do not wait for delivery */ 0);
}
// INATRedirectEvent generation routine 
DECLINLINE(void) fireNATRedirectEvent(IEventSource* aSource, CBSTR a_machineId, ULONG a_slot, BOOL a_remove, CBSTR a_name, NATProtocol_T a_proto, CBSTR a_hostIP, LONG a_hostPort, CBSTR a_guestIP, LONG a_guestPort)
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnNATRedirect, a_machineId, a_slot, a_remove, a_name, a_proto, a_hostIP, a_hostPort, a_guestIP, a_guestPort);
    evDesc.fire(/* do not wait for delivery */ 0);
}
// IHostPCIDevicePlugEvent generation routine 
DECLINLINE(void) fireHostPCIDevicePlugEvent(IEventSource* aSource, CBSTR a_machineId, BOOL a_plugged, BOOL a_success, IPCIDeviceAttachment* a_attachment, CBSTR a_message)
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnHostPCIDevicePlug, a_machineId, a_plugged, a_success, a_attachment, a_message);
    evDesc.fire(/* do not wait for delivery */ 0);
}
// IVBoxSVCAvailabilityChangedEvent generation routine 
DECLINLINE(void) fireVBoxSVCAvailabilityChangedEvent(IEventSource* aSource, BOOL a_available)
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnVBoxSVCAvailabilityChanged, a_available);
    evDesc.fire(/* do not wait for delivery */ 0);
}
// IBandwidthGroupChangedEvent generation routine 
DECLINLINE(void) fireBandwidthGroupChangedEvent(IEventSource* aSource, IBandwidthGroup* a_bandwidthGroup)
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnBandwidthGroupChanged, a_bandwidthGroup);
    evDesc.fire(/* do not wait for delivery */ 0);
}
// IGuestMonitorChangedEvent generation routine 
DECLINLINE(void) fireGuestMonitorChangedEvent(IEventSource* aSource, GuestMonitorChangedEventType_T a_changeType, ULONG a_screenId, ULONG a_originX, ULONG a_originY, ULONG a_width, ULONG a_height)
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnGuestMonitorChanged, a_changeType, a_screenId, a_originX, a_originY, a_width, a_height);
    evDesc.fire(/* do not wait for delivery */ 0);
}
// IStorageDeviceChangedEvent generation routine 
DECLINLINE(void) fireStorageDeviceChangedEvent(IEventSource* aSource, IMediumAttachment* a_storageDevice, BOOL a_removed)
{
    VBoxEventDesc evDesc;
    evDesc.init(aSource, VBoxEventType_OnStorageDeviceChanged, a_storageDevice, a_removed);
    evDesc.fire(/* do not wait for delivery */ 0);
}
