/* Copyright (c) 2001, Stanford University
	All rights reserved.

	See the file LICENSE.txt for information on redistributing this software. */
	
/* DO NOT EDIT!  THIS CODE IS AUTOGENERATED BY unpack.py */

#include "unpacker.h"
#include "cr_opcodes.h"
#include "cr_error.h"
#include "cr_mem.h"
#include "cr_spu.h"
#include "unpack_extend.h"
#include <stdio.h>
#include <memory.h>

#include <iprt/cdefs.h>

DECLEXPORT(const unsigned char *) cr_unpackData = NULL;
SPUDispatchTable cr_unpackDispatch;

static void crUnpackExtend(void);
static void crUnpackExtendDbg(void);

/*#define CR_UNPACK_DEBUG_OPCODES*/
/*#define CR_UNPACK_DEBUG_LAST_OPCODES*/

static void crUnpackAlphaFunc(void)
{
	GLenum func = READ_DATA( 0, GLenum );
	GLclampf ref = READ_DATA( 4, GLclampf );
	cr_unpackDispatch.AlphaFunc( func, ref );
	INCR_DATA_PTR( 8 );
}

static void crUnpackArrayElement(void)
{
	GLint i = READ_DATA( 0, GLint );
	cr_unpackDispatch.ArrayElement( i );
	INCR_DATA_PTR( 4 );
}

static void crUnpackBegin(void)
{
	GLenum mode = READ_DATA( 0, GLenum );
	cr_unpackDispatch.Begin( mode );
	INCR_DATA_PTR( 4 );
}

static void crUnpackBindTexture(void)
{
	GLenum target = READ_DATA( 0, GLenum );
	GLuint texture = READ_DATA( 4, GLuint );
	cr_unpackDispatch.BindTexture( target, texture );
	INCR_DATA_PTR( 8 );
}

static void crUnpackBlendFunc(void)
{
	GLenum sfactor = READ_DATA( 0, GLenum );
	GLenum dfactor = READ_DATA( 4, GLenum );
	cr_unpackDispatch.BlendFunc( sfactor, dfactor );
	INCR_DATA_PTR( 8 );
}

static void crUnpackCallList(void)
{
	GLuint list = READ_DATA( 0, GLuint );
	cr_unpackDispatch.CallList( list );
	INCR_DATA_PTR( 4 );
}

static void crUnpackClear(void)
{
	GLbitfield mask = READ_DATA( 0, GLbitfield );
	cr_unpackDispatch.Clear( mask );
	INCR_DATA_PTR( 4 );
}

static void crUnpackColor3b(void)
{
	cr_unpackDispatch.Color3bv((const GLbyte *) cr_unpackData);
	INCR_DATA_PTR( 4 );
}

static void crUnpackColor3d(void)
{
#ifdef CR_UNALIGNED_ACCESS_OKAY
	cr_unpackDispatch.Color3dv((const GLdouble *) cr_unpackData);
#else
	GLdouble v0 = READ_DOUBLE( 0 );
	GLdouble v1 = READ_DOUBLE( 8 );
	GLdouble v2 = READ_DOUBLE( 16 );
	cr_unpackDispatch.Color3d( v0 , v1 , v2 );
#endif
	INCR_DATA_PTR( 24 );
}

static void crUnpackColor3f(void)
{
	cr_unpackDispatch.Color3fv((const GLfloat *) cr_unpackData);
	INCR_DATA_PTR( 12 );
}

static void crUnpackColor3i(void)
{
	cr_unpackDispatch.Color3iv((const GLint *) cr_unpackData);
	INCR_DATA_PTR( 12 );
}

static void crUnpackColor3s(void)
{
	cr_unpackDispatch.Color3sv((const GLshort *) cr_unpackData);
	INCR_DATA_PTR( 8 );
}

static void crUnpackColor3ub(void)
{
	cr_unpackDispatch.Color3ubv((const GLubyte *) cr_unpackData);
	INCR_DATA_PTR( 4 );
}

static void crUnpackColor3ui(void)
{
	cr_unpackDispatch.Color3uiv((const GLuint *) cr_unpackData);
	INCR_DATA_PTR( 12 );
}

static void crUnpackColor3us(void)
{
	cr_unpackDispatch.Color3usv((const GLushort *) cr_unpackData);
	INCR_DATA_PTR( 8 );
}

static void crUnpackColor4b(void)
{
	cr_unpackDispatch.Color4bv((const GLbyte *) cr_unpackData);
	INCR_DATA_PTR( 4 );
}

static void crUnpackColor4d(void)
{
#ifdef CR_UNALIGNED_ACCESS_OKAY
	cr_unpackDispatch.Color4dv((const GLdouble *) cr_unpackData);
#else
	GLdouble v0 = READ_DOUBLE( 0 );
	GLdouble v1 = READ_DOUBLE( 8 );
	GLdouble v2 = READ_DOUBLE( 16 );
	GLdouble v3 = READ_DOUBLE( 24 );
	cr_unpackDispatch.Color4d( v0 , v1 , v2 , v3 );
#endif
	INCR_DATA_PTR( 32 );
}

static void crUnpackColor4f(void)
{
	cr_unpackDispatch.Color4fv((const GLfloat *) cr_unpackData);
	INCR_DATA_PTR( 16 );
}

static void crUnpackColor4i(void)
{
	cr_unpackDispatch.Color4iv((const GLint *) cr_unpackData);
	INCR_DATA_PTR( 16 );
}

static void crUnpackColor4s(void)
{
	cr_unpackDispatch.Color4sv((const GLshort *) cr_unpackData);
	INCR_DATA_PTR( 8 );
}

static void crUnpackColor4ub(void)
{
	cr_unpackDispatch.Color4ubv((const GLubyte *) cr_unpackData);
	INCR_DATA_PTR( 4 );
}

static void crUnpackColor4ui(void)
{
	cr_unpackDispatch.Color4uiv((const GLuint *) cr_unpackData);
	INCR_DATA_PTR( 16 );
}

static void crUnpackColor4us(void)
{
	cr_unpackDispatch.Color4usv((const GLushort *) cr_unpackData);
	INCR_DATA_PTR( 8 );
}

static void crUnpackColorMask(void)
{
	GLboolean red = READ_DATA( 0, GLboolean );
	GLboolean green = READ_DATA( 1, GLboolean );
	GLboolean blue = READ_DATA( 2, GLboolean );
	GLboolean alpha = READ_DATA( 3, GLboolean );
	cr_unpackDispatch.ColorMask( red, green, blue, alpha );
	INCR_DATA_PTR( 4 );
}

static void crUnpackColorMaterial(void)
{
	GLenum face = READ_DATA( 0, GLenum );
	GLenum mode = READ_DATA( 4, GLenum );
	cr_unpackDispatch.ColorMaterial( face, mode );
	INCR_DATA_PTR( 8 );
}

static void crUnpackCopyPixels(void)
{
	GLint x = READ_DATA( 0, GLint );
	GLint y = READ_DATA( 4, GLint );
	GLsizei width = READ_DATA( 8, GLsizei );
	GLsizei height = READ_DATA( 12, GLsizei );
	GLenum type = READ_DATA( 16, GLenum );
	cr_unpackDispatch.CopyPixels( x, y, width, height, type );
	INCR_DATA_PTR( 20 );
}

static void crUnpackCopyTexImage1D(void)
{
	GLenum target = READ_DATA( 0, GLenum );
	GLint level = READ_DATA( 4, GLint );
	GLenum internalFormat = READ_DATA( 8, GLenum );
	GLint x = READ_DATA( 12, GLint );
	GLint y = READ_DATA( 16, GLint );
	GLsizei width = READ_DATA( 20, GLsizei );
	GLint border = READ_DATA( 24, GLint );
	cr_unpackDispatch.CopyTexImage1D( target, level, internalFormat, x, y, width, border );
	INCR_DATA_PTR( 28 );
}

static void crUnpackCopyTexImage2D(void)
{
	GLenum target = READ_DATA( 0, GLenum );
	GLint level = READ_DATA( 4, GLint );
	GLenum internalFormat = READ_DATA( 8, GLenum );
	GLint x = READ_DATA( 12, GLint );
	GLint y = READ_DATA( 16, GLint );
	GLsizei width = READ_DATA( 20, GLsizei );
	GLsizei height = READ_DATA( 24, GLsizei );
	GLint border = READ_DATA( 28, GLint );
	cr_unpackDispatch.CopyTexImage2D( target, level, internalFormat, x, y, width, height, border );
	INCR_DATA_PTR( 32 );
}

static void crUnpackCopyTexSubImage1D(void)
{
	GLenum target = READ_DATA( 0, GLenum );
	GLint level = READ_DATA( 4, GLint );
	GLint xoffset = READ_DATA( 8, GLint );
	GLint x = READ_DATA( 12, GLint );
	GLint y = READ_DATA( 16, GLint );
	GLsizei width = READ_DATA( 20, GLsizei );
	cr_unpackDispatch.CopyTexSubImage1D( target, level, xoffset, x, y, width );
	INCR_DATA_PTR( 24 );
}

static void crUnpackCopyTexSubImage2D(void)
{
	GLenum target = READ_DATA( 0, GLenum );
	GLint level = READ_DATA( 4, GLint );
	GLint xoffset = READ_DATA( 8, GLint );
	GLint yoffset = READ_DATA( 12, GLint );
	GLint x = READ_DATA( 16, GLint );
	GLint y = READ_DATA( 20, GLint );
	GLsizei width = READ_DATA( 24, GLsizei );
	GLsizei height = READ_DATA( 28, GLsizei );
	cr_unpackDispatch.CopyTexSubImage2D( target, level, xoffset, yoffset, x, y, width, height );
	INCR_DATA_PTR( 32 );
}

static void crUnpackCopyTexSubImage3D(void)
{
	GLenum target = READ_DATA( 0, GLenum );
	GLint level = READ_DATA( 4, GLint );
	GLint xoffset = READ_DATA( 8, GLint );
	GLint yoffset = READ_DATA( 12, GLint );
	GLint zoffset = READ_DATA( 16, GLint );
	GLint x = READ_DATA( 20, GLint );
	GLint y = READ_DATA( 24, GLint );
	GLsizei width = READ_DATA( 28, GLsizei );
	GLsizei height = READ_DATA( 32, GLsizei );
	cr_unpackDispatch.CopyTexSubImage3D( target, level, xoffset, yoffset, zoffset, x, y, width, height );
	INCR_DATA_PTR( 36 );
}

static void crUnpackCullFace(void)
{
	GLenum mode = READ_DATA( 0, GLenum );
	cr_unpackDispatch.CullFace( mode );
	INCR_DATA_PTR( 4 );
}

static void crUnpackDepthFunc(void)
{
	GLenum func = READ_DATA( 0, GLenum );
	cr_unpackDispatch.DepthFunc( func );
	INCR_DATA_PTR( 4 );
}

static void crUnpackDepthMask(void)
{
	GLboolean flag = READ_DATA( 0, GLboolean );
	cr_unpackDispatch.DepthMask( flag );
	INCR_DATA_PTR( 4 );
}

static void crUnpackDepthRange(void)
{
	GLclampd zNear = READ_DOUBLE( 0 );
	GLclampd zFar = READ_DOUBLE( 8 );
	cr_unpackDispatch.DepthRange( zNear, zFar );
	INCR_DATA_PTR( 16 );
}

static void crUnpackDisable(void)
{
	GLenum cap = READ_DATA( 0, GLenum );
	cr_unpackDispatch.Disable( cap );
	INCR_DATA_PTR( 4 );
}

static void crUnpackDisableClientState(void)
{
	GLenum array = READ_DATA( 0, GLenum );
	cr_unpackDispatch.DisableClientState( array );
	INCR_DATA_PTR( 4 );
}

static void crUnpackDrawArrays(void)
{
	GLenum mode = READ_DATA( 0, GLenum );
	GLint first = READ_DATA( 4, GLint );
	GLsizei count = READ_DATA( 8, GLsizei );
	cr_unpackDispatch.DrawArrays( mode, first, count );
	INCR_DATA_PTR( 12 );
}

static void crUnpackEdgeFlag(void)
{
	cr_unpackDispatch.EdgeFlagv((const GLboolean *) cr_unpackData);
	INCR_DATA_PTR( 4 );
}

static void crUnpackEnable(void)
{
	GLenum cap = READ_DATA( 0, GLenum );
	cr_unpackDispatch.Enable( cap );
	INCR_DATA_PTR( 4 );
}

static void crUnpackEnableClientState(void)
{
	GLenum array = READ_DATA( 0, GLenum );
	cr_unpackDispatch.EnableClientState( array );
	INCR_DATA_PTR( 4 );
}

static void crUnpackEnd(void)
{
	cr_unpackDispatch.End(  );
	INCR_DATA_PTR_NO_ARGS( );
}

static void crUnpackEvalCoord1d(void)
{
#ifdef CR_UNALIGNED_ACCESS_OKAY
	cr_unpackDispatch.EvalCoord1dv((const GLdouble *) cr_unpackData);
#else
	GLdouble v0 = READ_DOUBLE( 0 );
	cr_unpackDispatch.EvalCoord1d( v0 );
#endif
	INCR_DATA_PTR( 8 );
}

static void crUnpackEvalCoord1f(void)
{
	cr_unpackDispatch.EvalCoord1fv((const GLfloat *) cr_unpackData);
	INCR_DATA_PTR( 4 );
}

static void crUnpackEvalCoord2d(void)
{
#ifdef CR_UNALIGNED_ACCESS_OKAY
	cr_unpackDispatch.EvalCoord2dv((const GLdouble *) cr_unpackData);
#else
	GLdouble v0 = READ_DOUBLE( 0 );
	GLdouble v1 = READ_DOUBLE( 8 );
	cr_unpackDispatch.EvalCoord2d( v0 , v1 );
#endif
	INCR_DATA_PTR( 16 );
}

static void crUnpackEvalCoord2f(void)
{
	cr_unpackDispatch.EvalCoord2fv((const GLfloat *) cr_unpackData);
	INCR_DATA_PTR( 8 );
}

static void crUnpackEvalMesh1(void)
{
	GLenum mode = READ_DATA( 0, GLenum );
	GLint i1 = READ_DATA( 4, GLint );
	GLint i2 = READ_DATA( 8, GLint );
	cr_unpackDispatch.EvalMesh1( mode, i1, i2 );
	INCR_DATA_PTR( 12 );
}

static void crUnpackEvalMesh2(void)
{
	GLenum mode = READ_DATA( 0, GLenum );
	GLint i1 = READ_DATA( 4, GLint );
	GLint i2 = READ_DATA( 8, GLint );
	GLint j1 = READ_DATA( 12, GLint );
	GLint j2 = READ_DATA( 16, GLint );
	cr_unpackDispatch.EvalMesh2( mode, i1, i2, j1, j2 );
	INCR_DATA_PTR( 20 );
}

static void crUnpackEvalPoint1(void)
{
	GLint i = READ_DATA( 0, GLint );
	cr_unpackDispatch.EvalPoint1( i );
	INCR_DATA_PTR( 4 );
}

static void crUnpackEvalPoint2(void)
{
	GLint i = READ_DATA( 0, GLint );
	GLint j = READ_DATA( 4, GLint );
	cr_unpackDispatch.EvalPoint2( i, j );
	INCR_DATA_PTR( 8 );
}

static void crUnpackFeedbackBuffer(void)
{
	GLsizei size = READ_DATA( 0, GLsizei );
	GLenum type = READ_DATA( 4, GLenum );
	crError( "FeedbackBuffer needs to be special cased!" );
	cr_unpackDispatch.FeedbackBuffer( size, type, NULL );
	INCR_DATA_PTR( 16 );
}

static void crUnpackFinish(void)
{
	cr_unpackDispatch.Finish(  );
	INCR_DATA_PTR_NO_ARGS( );
}

static void crUnpackFlush(void)
{
	cr_unpackDispatch.Flush(  );
	INCR_DATA_PTR_NO_ARGS( );
}

static void crUnpackFogCoorddEXT(void)
{
#ifdef CR_UNALIGNED_ACCESS_OKAY
	cr_unpackDispatch.FogCoorddvEXT((const GLdouble *) cr_unpackData);
#else
	GLdouble v0 = READ_DOUBLE( 0 );
	cr_unpackDispatch.FogCoorddEXT( v0 );
#endif
	INCR_DATA_PTR( 8 );
}

static void crUnpackFogCoordfEXT(void)
{
	cr_unpackDispatch.FogCoordfvEXT((const GLfloat *) cr_unpackData);
	INCR_DATA_PTR( 4 );
}

static void crUnpackFogf(void)
{
	GLenum pname = READ_DATA( 0, GLenum );
	GLfloat param = READ_DATA( 4, GLfloat );
	cr_unpackDispatch.Fogf( pname, param );
	INCR_DATA_PTR( 8 );
}

static void crUnpackFogi(void)
{
	GLenum pname = READ_DATA( 0, GLenum );
	GLint param = READ_DATA( 4, GLint );
	cr_unpackDispatch.Fogi( pname, param );
	INCR_DATA_PTR( 8 );
}

static void crUnpackFrontFace(void)
{
	GLenum mode = READ_DATA( 0, GLenum );
	cr_unpackDispatch.FrontFace( mode );
	INCR_DATA_PTR( 4 );
}

static void crUnpackFrustum(void)
{
	GLdouble left = READ_DOUBLE( 0 );
	GLdouble right = READ_DOUBLE( 8 );
	GLdouble bottom = READ_DOUBLE( 16 );
	GLdouble top = READ_DOUBLE( 24 );
	GLdouble zNear = READ_DOUBLE( 32 );
	GLdouble zFar = READ_DOUBLE( 40 );
	cr_unpackDispatch.Frustum( left, right, bottom, top, zNear, zFar );
	INCR_DATA_PTR( 48 );
}

static void crUnpackIndexMask(void)
{
	GLuint mask = READ_DATA( 0, GLuint );
	cr_unpackDispatch.IndexMask( mask );
	INCR_DATA_PTR( 4 );
}

static void crUnpackIndexd(void)
{
#ifdef CR_UNALIGNED_ACCESS_OKAY
	cr_unpackDispatch.Indexdv((const GLdouble *) cr_unpackData);
#else
	GLdouble v0 = READ_DOUBLE( 0 );
	cr_unpackDispatch.Indexd( v0 );
#endif
	INCR_DATA_PTR( 8 );
}

static void crUnpackIndexf(void)
{
	cr_unpackDispatch.Indexfv((const GLfloat *) cr_unpackData);
	INCR_DATA_PTR( 4 );
}

static void crUnpackIndexi(void)
{
	cr_unpackDispatch.Indexiv((const GLint *) cr_unpackData);
	INCR_DATA_PTR( 4 );
}

static void crUnpackIndexs(void)
{
	cr_unpackDispatch.Indexsv((const GLshort *) cr_unpackData);
	INCR_DATA_PTR( 4 );
}

static void crUnpackIndexub(void)
{
	cr_unpackDispatch.Indexubv((const GLubyte *) cr_unpackData);
	INCR_DATA_PTR( 4 );
}

static void crUnpackInitNames(void)
{
	cr_unpackDispatch.InitNames(  );
	INCR_DATA_PTR_NO_ARGS( );
}

static void crUnpackLightModelf(void)
{
	GLenum pname = READ_DATA( 0, GLenum );
	GLfloat param = READ_DATA( 4, GLfloat );
	cr_unpackDispatch.LightModelf( pname, param );
	INCR_DATA_PTR( 8 );
}

static void crUnpackLightModeli(void)
{
	GLenum pname = READ_DATA( 0, GLenum );
	GLint param = READ_DATA( 4, GLint );
	cr_unpackDispatch.LightModeli( pname, param );
	INCR_DATA_PTR( 8 );
}

static void crUnpackLightf(void)
{
	GLenum light = READ_DATA( 0, GLenum );
	GLenum pname = READ_DATA( 4, GLenum );
	GLfloat param = READ_DATA( 8, GLfloat );
	cr_unpackDispatch.Lightf( light, pname, param );
	INCR_DATA_PTR( 12 );
}

static void crUnpackLighti(void)
{
	GLenum light = READ_DATA( 0, GLenum );
	GLenum pname = READ_DATA( 4, GLenum );
	GLint param = READ_DATA( 8, GLint );
	cr_unpackDispatch.Lighti( light, pname, param );
	INCR_DATA_PTR( 12 );
}

static void crUnpackLineStipple(void)
{
	GLint factor = READ_DATA( 0, GLint );
	GLushort pattern = READ_DATA( 4, GLushort );
	cr_unpackDispatch.LineStipple( factor, pattern );
	INCR_DATA_PTR( 8 );
}

static void crUnpackLineWidth(void)
{
	GLfloat width = READ_DATA( 0, GLfloat );
	cr_unpackDispatch.LineWidth( width );
	INCR_DATA_PTR( 4 );
}

static void crUnpackLoadIdentity(void)
{
	cr_unpackDispatch.LoadIdentity(  );
	INCR_DATA_PTR_NO_ARGS( );
}

static void crUnpackLoadName(void)
{
	GLuint name = READ_DATA( 0, GLuint );
	cr_unpackDispatch.LoadName( name );
	INCR_DATA_PTR( 4 );
}

static void crUnpackMapGrid1d(void)
{
	GLint un = READ_DATA( 0, GLint );
	GLdouble u1 = READ_DOUBLE( 4 );
	GLdouble u2 = READ_DOUBLE( 12 );
	cr_unpackDispatch.MapGrid1d( un, u1, u2 );
	INCR_DATA_PTR( 20 );
}

static void crUnpackMapGrid1f(void)
{
	GLint un = READ_DATA( 0, GLint );
	GLfloat u1 = READ_DATA( 4, GLfloat );
	GLfloat u2 = READ_DATA( 8, GLfloat );
	cr_unpackDispatch.MapGrid1f( un, u1, u2 );
	INCR_DATA_PTR( 12 );
}

static void crUnpackMapGrid2d(void)
{
	GLint un = READ_DATA( 0, GLint );
	GLdouble u1 = READ_DOUBLE( 4 );
	GLdouble u2 = READ_DOUBLE( 12 );
	GLint vn = READ_DATA( 20, GLint );
	GLdouble v1 = READ_DOUBLE( 24 );
	GLdouble v2 = READ_DOUBLE( 32 );
	cr_unpackDispatch.MapGrid2d( un, u1, u2, vn, v1, v2 );
	INCR_DATA_PTR( 40 );
}

static void crUnpackMapGrid2f(void)
{
	GLint un = READ_DATA( 0, GLint );
	GLfloat u1 = READ_DATA( 4, GLfloat );
	GLfloat u2 = READ_DATA( 8, GLfloat );
	GLint vn = READ_DATA( 12, GLint );
	GLfloat v1 = READ_DATA( 16, GLfloat );
	GLfloat v2 = READ_DATA( 20, GLfloat );
	cr_unpackDispatch.MapGrid2f( un, u1, u2, vn, v1, v2 );
	INCR_DATA_PTR( 24 );
}

static void crUnpackMaterialf(void)
{
	GLenum face = READ_DATA( 0, GLenum );
	GLenum pname = READ_DATA( 4, GLenum );
	GLfloat param = READ_DATA( 8, GLfloat );
	cr_unpackDispatch.Materialf( face, pname, param );
	INCR_DATA_PTR( 12 );
}

static void crUnpackMateriali(void)
{
	GLenum face = READ_DATA( 0, GLenum );
	GLenum pname = READ_DATA( 4, GLenum );
	GLint param = READ_DATA( 8, GLint );
	cr_unpackDispatch.Materiali( face, pname, param );
	INCR_DATA_PTR( 12 );
}

static void crUnpackMatrixMode(void)
{
	GLenum mode = READ_DATA( 0, GLenum );
	cr_unpackDispatch.MatrixMode( mode );
	INCR_DATA_PTR( 4 );
}

static void crUnpackMultiTexCoord1dARB(void)
{
	GLenum texture = READ_DATA( 0, GLenum );
	GLdouble s = READ_DOUBLE( 4 );
	cr_unpackDispatch.MultiTexCoord1dARB( texture, s );
	INCR_DATA_PTR( 12 );
}

static void crUnpackMultiTexCoord1fARB(void)
{
	GLenum texture = READ_DATA( 0, GLenum );
	GLfloat s = READ_DATA( 4, GLfloat );
	cr_unpackDispatch.MultiTexCoord1fARB( texture, s );
	INCR_DATA_PTR( 8 );
}

static void crUnpackMultiTexCoord1iARB(void)
{
	GLenum texture = READ_DATA( 0, GLenum );
	GLint s = READ_DATA( 4, GLint );
	cr_unpackDispatch.MultiTexCoord1iARB( texture, s );
	INCR_DATA_PTR( 8 );
}

static void crUnpackMultiTexCoord1sARB(void)
{
	GLenum texture = READ_DATA( 0, GLenum );
	GLshort s = READ_DATA( 4, GLshort );
	cr_unpackDispatch.MultiTexCoord1sARB( texture, s );
	INCR_DATA_PTR( 8 );
}

static void crUnpackMultiTexCoord2dARB(void)
{
	GLenum texture = READ_DATA( 0, GLenum );
	GLdouble s = READ_DOUBLE( 4 );
	GLdouble t = READ_DOUBLE( 12 );
	cr_unpackDispatch.MultiTexCoord2dARB( texture, s, t );
	INCR_DATA_PTR( 20 );
}

static void crUnpackMultiTexCoord2fARB(void)
{
	GLenum texture = READ_DATA( 0, GLenum );
	GLfloat s = READ_DATA( 4, GLfloat );
	GLfloat t = READ_DATA( 8, GLfloat );
	cr_unpackDispatch.MultiTexCoord2fARB( texture, s, t );
	INCR_DATA_PTR( 12 );
}

static void crUnpackMultiTexCoord2iARB(void)
{
	GLenum texture = READ_DATA( 0, GLenum );
	GLint s = READ_DATA( 4, GLint );
	GLint t = READ_DATA( 8, GLint );
	cr_unpackDispatch.MultiTexCoord2iARB( texture, s, t );
	INCR_DATA_PTR( 12 );
}

static void crUnpackMultiTexCoord2sARB(void)
{
	GLenum texture = READ_DATA( 0, GLenum );
	GLshort s = READ_DATA( 4, GLshort );
	GLshort t = READ_DATA( 6, GLshort );
	cr_unpackDispatch.MultiTexCoord2sARB( texture, s, t );
	INCR_DATA_PTR( 8 );
}

static void crUnpackMultiTexCoord3dARB(void)
{
	GLenum texture = READ_DATA( 0, GLenum );
	GLdouble s = READ_DOUBLE( 4 );
	GLdouble t = READ_DOUBLE( 12 );
	GLdouble r = READ_DOUBLE( 20 );
	cr_unpackDispatch.MultiTexCoord3dARB( texture, s, t, r );
	INCR_DATA_PTR( 28 );
}

static void crUnpackMultiTexCoord3fARB(void)
{
	GLenum texture = READ_DATA( 0, GLenum );
	GLfloat s = READ_DATA( 4, GLfloat );
	GLfloat t = READ_DATA( 8, GLfloat );
	GLfloat r = READ_DATA( 12, GLfloat );
	cr_unpackDispatch.MultiTexCoord3fARB( texture, s, t, r );
	INCR_DATA_PTR( 16 );
}

static void crUnpackMultiTexCoord3iARB(void)
{
	GLenum texture = READ_DATA( 0, GLenum );
	GLint s = READ_DATA( 4, GLint );
	GLint t = READ_DATA( 8, GLint );
	GLint r = READ_DATA( 12, GLint );
	cr_unpackDispatch.MultiTexCoord3iARB( texture, s, t, r );
	INCR_DATA_PTR( 16 );
}

static void crUnpackMultiTexCoord3sARB(void)
{
	GLenum texture = READ_DATA( 0, GLenum );
	GLshort s = READ_DATA( 4, GLshort );
	GLshort t = READ_DATA( 6, GLshort );
	GLshort r = READ_DATA( 8, GLshort );
	cr_unpackDispatch.MultiTexCoord3sARB( texture, s, t, r );
	INCR_DATA_PTR( 12 );
}

static void crUnpackMultiTexCoord4dARB(void)
{
	GLenum texture = READ_DATA( 0, GLenum );
	GLdouble s = READ_DOUBLE( 4 );
	GLdouble t = READ_DOUBLE( 12 );
	GLdouble r = READ_DOUBLE( 20 );
	GLdouble q = READ_DOUBLE( 28 );
	cr_unpackDispatch.MultiTexCoord4dARB( texture, s, t, r, q );
	INCR_DATA_PTR( 36 );
}

static void crUnpackMultiTexCoord4fARB(void)
{
	GLenum texture = READ_DATA( 0, GLenum );
	GLfloat s = READ_DATA( 4, GLfloat );
	GLfloat t = READ_DATA( 8, GLfloat );
	GLfloat r = READ_DATA( 12, GLfloat );
	GLfloat q = READ_DATA( 16, GLfloat );
	cr_unpackDispatch.MultiTexCoord4fARB( texture, s, t, r, q );
	INCR_DATA_PTR( 20 );
}

static void crUnpackMultiTexCoord4iARB(void)
{
	GLenum texture = READ_DATA( 0, GLenum );
	GLint s = READ_DATA( 4, GLint );
	GLint t = READ_DATA( 8, GLint );
	GLint r = READ_DATA( 12, GLint );
	GLint q = READ_DATA( 16, GLint );
	cr_unpackDispatch.MultiTexCoord4iARB( texture, s, t, r, q );
	INCR_DATA_PTR( 20 );
}

static void crUnpackMultiTexCoord4sARB(void)
{
	GLenum texture = READ_DATA( 0, GLenum );
	GLshort s = READ_DATA( 4, GLshort );
	GLshort t = READ_DATA( 6, GLshort );
	GLshort r = READ_DATA( 8, GLshort );
	GLshort q = READ_DATA( 10, GLshort );
	cr_unpackDispatch.MultiTexCoord4sARB( texture, s, t, r, q );
	INCR_DATA_PTR( 12 );
}

static void crUnpackNormal3b(void)
{
	cr_unpackDispatch.Normal3bv((const GLbyte *) cr_unpackData);
	INCR_DATA_PTR( 4 );
}

static void crUnpackNormal3d(void)
{
#ifdef CR_UNALIGNED_ACCESS_OKAY
	cr_unpackDispatch.Normal3dv((const GLdouble *) cr_unpackData);
#else
	GLdouble v0 = READ_DOUBLE( 0 );
	GLdouble v1 = READ_DOUBLE( 8 );
	GLdouble v2 = READ_DOUBLE( 16 );
	cr_unpackDispatch.Normal3d( v0 , v1 , v2 );
#endif
	INCR_DATA_PTR( 24 );
}

static void crUnpackNormal3f(void)
{
	cr_unpackDispatch.Normal3fv((const GLfloat *) cr_unpackData);
	INCR_DATA_PTR( 12 );
}

static void crUnpackNormal3i(void)
{
	cr_unpackDispatch.Normal3iv((const GLint *) cr_unpackData);
	INCR_DATA_PTR( 12 );
}

static void crUnpackNormal3s(void)
{
	cr_unpackDispatch.Normal3sv((const GLshort *) cr_unpackData);
	INCR_DATA_PTR( 8 );
}

static void crUnpackOrtho(void)
{
	GLdouble left = READ_DOUBLE( 0 );
	GLdouble right = READ_DOUBLE( 8 );
	GLdouble bottom = READ_DOUBLE( 16 );
	GLdouble top = READ_DOUBLE( 24 );
	GLdouble zNear = READ_DOUBLE( 32 );
	GLdouble zFar = READ_DOUBLE( 40 );
	cr_unpackDispatch.Ortho( left, right, bottom, top, zNear, zFar );
	INCR_DATA_PTR( 48 );
}

static void crUnpackPassThrough(void)
{
	GLfloat token = READ_DATA( 0, GLfloat );
	cr_unpackDispatch.PassThrough( token );
	INCR_DATA_PTR( 4 );
}

static void crUnpackPixelStoref(void)
{
	GLenum pname = READ_DATA( 0, GLenum );
	GLfloat param = READ_DATA( 4, GLfloat );
	cr_unpackDispatch.PixelStoref( pname, param );
	INCR_DATA_PTR( 8 );
}

static void crUnpackPixelStorei(void)
{
	GLenum pname = READ_DATA( 0, GLenum );
	GLint param = READ_DATA( 4, GLint );
	cr_unpackDispatch.PixelStorei( pname, param );
	INCR_DATA_PTR( 8 );
}

static void crUnpackPixelTransferf(void)
{
	GLenum pname = READ_DATA( 0, GLenum );
	GLfloat param = READ_DATA( 4, GLfloat );
	cr_unpackDispatch.PixelTransferf( pname, param );
	INCR_DATA_PTR( 8 );
}

static void crUnpackPixelTransferi(void)
{
	GLenum pname = READ_DATA( 0, GLenum );
	GLint param = READ_DATA( 4, GLint );
	cr_unpackDispatch.PixelTransferi( pname, param );
	INCR_DATA_PTR( 8 );
}

static void crUnpackPixelZoom(void)
{
	GLfloat xfactor = READ_DATA( 0, GLfloat );
	GLfloat yfactor = READ_DATA( 4, GLfloat );
	cr_unpackDispatch.PixelZoom( xfactor, yfactor );
	INCR_DATA_PTR( 8 );
}

static void crUnpackPointSize(void)
{
	GLfloat size = READ_DATA( 0, GLfloat );
	cr_unpackDispatch.PointSize( size );
	INCR_DATA_PTR( 4 );
}

static void crUnpackPolygonMode(void)
{
	GLenum face = READ_DATA( 0, GLenum );
	GLenum mode = READ_DATA( 4, GLenum );
	cr_unpackDispatch.PolygonMode( face, mode );
	INCR_DATA_PTR( 8 );
}

static void crUnpackPolygonOffset(void)
{
	GLfloat factor = READ_DATA( 0, GLfloat );
	GLfloat units = READ_DATA( 4, GLfloat );
	cr_unpackDispatch.PolygonOffset( factor, units );
	INCR_DATA_PTR( 8 );
}

static void crUnpackPopMatrix(void)
{
	cr_unpackDispatch.PopMatrix(  );
	INCR_DATA_PTR_NO_ARGS( );
}

static void crUnpackPopName(void)
{
	cr_unpackDispatch.PopName(  );
	INCR_DATA_PTR_NO_ARGS( );
}

static void crUnpackPushMatrix(void)
{
	cr_unpackDispatch.PushMatrix(  );
	INCR_DATA_PTR_NO_ARGS( );
}

static void crUnpackPushName(void)
{
	GLuint name = READ_DATA( 0, GLuint );
	cr_unpackDispatch.PushName( name );
	INCR_DATA_PTR( 4 );
}

static void crUnpackRasterPos2d(void)
{
#ifdef CR_UNALIGNED_ACCESS_OKAY
	cr_unpackDispatch.RasterPos2dv((const GLdouble *) cr_unpackData);
#else
	GLdouble v0 = READ_DOUBLE( 0 );
	GLdouble v1 = READ_DOUBLE( 8 );
	cr_unpackDispatch.RasterPos2d( v0 , v1 );
#endif
	INCR_DATA_PTR( 16 );
}

static void crUnpackRasterPos2f(void)
{
	cr_unpackDispatch.RasterPos2fv((const GLfloat *) cr_unpackData);
	INCR_DATA_PTR( 8 );
}

static void crUnpackRasterPos2i(void)
{
	cr_unpackDispatch.RasterPos2iv((const GLint *) cr_unpackData);
	INCR_DATA_PTR( 8 );
}

static void crUnpackRasterPos2s(void)
{
	cr_unpackDispatch.RasterPos2sv((const GLshort *) cr_unpackData);
	INCR_DATA_PTR( 4 );
}

static void crUnpackRasterPos3d(void)
{
#ifdef CR_UNALIGNED_ACCESS_OKAY
	cr_unpackDispatch.RasterPos3dv((const GLdouble *) cr_unpackData);
#else
	GLdouble v0 = READ_DOUBLE( 0 );
	GLdouble v1 = READ_DOUBLE( 8 );
	GLdouble v2 = READ_DOUBLE( 16 );
	cr_unpackDispatch.RasterPos3d( v0 , v1 , v2 );
#endif
	INCR_DATA_PTR( 24 );
}

static void crUnpackRasterPos3f(void)
{
	cr_unpackDispatch.RasterPos3fv((const GLfloat *) cr_unpackData);
	INCR_DATA_PTR( 12 );
}

static void crUnpackRasterPos3i(void)
{
	cr_unpackDispatch.RasterPos3iv((const GLint *) cr_unpackData);
	INCR_DATA_PTR( 12 );
}

static void crUnpackRasterPos3s(void)
{
	cr_unpackDispatch.RasterPos3sv((const GLshort *) cr_unpackData);
	INCR_DATA_PTR( 8 );
}

static void crUnpackRasterPos4d(void)
{
#ifdef CR_UNALIGNED_ACCESS_OKAY
	cr_unpackDispatch.RasterPos4dv((const GLdouble *) cr_unpackData);
#else
	GLdouble v0 = READ_DOUBLE( 0 );
	GLdouble v1 = READ_DOUBLE( 8 );
	GLdouble v2 = READ_DOUBLE( 16 );
	GLdouble v3 = READ_DOUBLE( 24 );
	cr_unpackDispatch.RasterPos4d( v0 , v1 , v2 , v3 );
#endif
	INCR_DATA_PTR( 32 );
}

static void crUnpackRasterPos4f(void)
{
	cr_unpackDispatch.RasterPos4fv((const GLfloat *) cr_unpackData);
	INCR_DATA_PTR( 16 );
}

static void crUnpackRasterPos4i(void)
{
	cr_unpackDispatch.RasterPos4iv((const GLint *) cr_unpackData);
	INCR_DATA_PTR( 16 );
}

static void crUnpackRasterPos4s(void)
{
	cr_unpackDispatch.RasterPos4sv((const GLshort *) cr_unpackData);
	INCR_DATA_PTR( 8 );
}

static void crUnpackRectd(void)
{
	GLdouble x1 = READ_DOUBLE( 0 );
	GLdouble y1 = READ_DOUBLE( 8 );
	GLdouble x2 = READ_DOUBLE( 16 );
	GLdouble y2 = READ_DOUBLE( 24 );
	cr_unpackDispatch.Rectd( x1, y1, x2, y2 );
	INCR_DATA_PTR( 32 );
}

static void crUnpackRectf(void)
{
	GLfloat x1 = READ_DATA( 0, GLfloat );
	GLfloat y1 = READ_DATA( 4, GLfloat );
	GLfloat x2 = READ_DATA( 8, GLfloat );
	GLfloat y2 = READ_DATA( 12, GLfloat );
	cr_unpackDispatch.Rectf( x1, y1, x2, y2 );
	INCR_DATA_PTR( 16 );
}

static void crUnpackRecti(void)
{
	GLint x1 = READ_DATA( 0, GLint );
	GLint y1 = READ_DATA( 4, GLint );
	GLint x2 = READ_DATA( 8, GLint );
	GLint y2 = READ_DATA( 12, GLint );
	cr_unpackDispatch.Recti( x1, y1, x2, y2 );
	INCR_DATA_PTR( 16 );
}

static void crUnpackRects(void)
{
	GLshort x1 = READ_DATA( 0, GLshort );
	GLshort y1 = READ_DATA( 2, GLshort );
	GLshort x2 = READ_DATA( 4, GLshort );
	GLshort y2 = READ_DATA( 6, GLshort );
	cr_unpackDispatch.Rects( x1, y1, x2, y2 );
	INCR_DATA_PTR( 8 );
}

static void crUnpackRotated(void)
{
	GLdouble angle = READ_DOUBLE( 0 );
	GLdouble x = READ_DOUBLE( 8 );
	GLdouble y = READ_DOUBLE( 16 );
	GLdouble z = READ_DOUBLE( 24 );
	cr_unpackDispatch.Rotated( angle, x, y, z );
	INCR_DATA_PTR( 32 );
}

static void crUnpackRotatef(void)
{
	GLfloat angle = READ_DATA( 0, GLfloat );
	GLfloat x = READ_DATA( 4, GLfloat );
	GLfloat y = READ_DATA( 8, GLfloat );
	GLfloat z = READ_DATA( 12, GLfloat );
	cr_unpackDispatch.Rotatef( angle, x, y, z );
	INCR_DATA_PTR( 16 );
}

static void crUnpackScaled(void)
{
	GLdouble x = READ_DOUBLE( 0 );
	GLdouble y = READ_DOUBLE( 8 );
	GLdouble z = READ_DOUBLE( 16 );
	cr_unpackDispatch.Scaled( x, y, z );
	INCR_DATA_PTR( 24 );
}

static void crUnpackScalef(void)
{
	GLfloat x = READ_DATA( 0, GLfloat );
	GLfloat y = READ_DATA( 4, GLfloat );
	GLfloat z = READ_DATA( 8, GLfloat );
	cr_unpackDispatch.Scalef( x, y, z );
	INCR_DATA_PTR( 12 );
}

static void crUnpackScissor(void)
{
	GLint x = READ_DATA( 0, GLint );
	GLint y = READ_DATA( 4, GLint );
	GLsizei width = READ_DATA( 8, GLsizei );
	GLsizei height = READ_DATA( 12, GLsizei );
	cr_unpackDispatch.Scissor( x, y, width, height );
	INCR_DATA_PTR( 16 );
}

static void crUnpackSecondaryColor3bEXT(void)
{
	cr_unpackDispatch.SecondaryColor3bvEXT((const GLbyte *) cr_unpackData);
	INCR_DATA_PTR( 4 );
}

static void crUnpackSecondaryColor3dEXT(void)
{
#ifdef CR_UNALIGNED_ACCESS_OKAY
	cr_unpackDispatch.SecondaryColor3dvEXT((const GLdouble *) cr_unpackData);
#else
	GLdouble v0 = READ_DOUBLE( 0 );
	GLdouble v1 = READ_DOUBLE( 8 );
	GLdouble v2 = READ_DOUBLE( 16 );
	cr_unpackDispatch.SecondaryColor3dEXT( v0 , v1 , v2 );
#endif
	INCR_DATA_PTR( 24 );
}

static void crUnpackSecondaryColor3fEXT(void)
{
	cr_unpackDispatch.SecondaryColor3fvEXT((const GLfloat *) cr_unpackData);
	INCR_DATA_PTR( 12 );
}

static void crUnpackSecondaryColor3iEXT(void)
{
	cr_unpackDispatch.SecondaryColor3ivEXT((const GLint *) cr_unpackData);
	INCR_DATA_PTR( 12 );
}

static void crUnpackSecondaryColor3sEXT(void)
{
	cr_unpackDispatch.SecondaryColor3svEXT((const GLshort *) cr_unpackData);
	INCR_DATA_PTR( 8 );
}

static void crUnpackSecondaryColor3ubEXT(void)
{
	cr_unpackDispatch.SecondaryColor3ubvEXT((const GLubyte *) cr_unpackData);
	INCR_DATA_PTR( 4 );
}

static void crUnpackSecondaryColor3uiEXT(void)
{
	cr_unpackDispatch.SecondaryColor3uivEXT((const GLuint *) cr_unpackData);
	INCR_DATA_PTR( 12 );
}

static void crUnpackSecondaryColor3usEXT(void)
{
	cr_unpackDispatch.SecondaryColor3usvEXT((const GLushort *) cr_unpackData);
	INCR_DATA_PTR( 8 );
}

static void crUnpackSelectBuffer(void)
{
	GLsizei size = READ_DATA( 0, GLsizei );
	crError( "SelectBuffer needs to be special cased!" );
	cr_unpackDispatch.SelectBuffer( size, NULL );
	INCR_DATA_PTR( 12 );
}

static void crUnpackShadeModel(void)
{
	GLenum mode = READ_DATA( 0, GLenum );
	cr_unpackDispatch.ShadeModel( mode );
	INCR_DATA_PTR( 4 );
}

static void crUnpackStencilFunc(void)
{
	GLenum func = READ_DATA( 0, GLenum );
	GLint ref = READ_DATA( 4, GLint );
	GLuint mask = READ_DATA( 8, GLuint );
	cr_unpackDispatch.StencilFunc( func, ref, mask );
	INCR_DATA_PTR( 12 );
}

static void crUnpackStencilMask(void)
{
	GLuint mask = READ_DATA( 0, GLuint );
	cr_unpackDispatch.StencilMask( mask );
	INCR_DATA_PTR( 4 );
}

static void crUnpackStencilOp(void)
{
	GLenum fail = READ_DATA( 0, GLenum );
	GLenum zfail = READ_DATA( 4, GLenum );
	GLenum zpass = READ_DATA( 8, GLenum );
	cr_unpackDispatch.StencilOp( fail, zfail, zpass );
	INCR_DATA_PTR( 12 );
}

static void crUnpackTexCoord1d(void)
{
#ifdef CR_UNALIGNED_ACCESS_OKAY
	cr_unpackDispatch.TexCoord1dv((const GLdouble *) cr_unpackData);
#else
	GLdouble v0 = READ_DOUBLE( 0 );
	cr_unpackDispatch.TexCoord1d( v0 );
#endif
	INCR_DATA_PTR( 8 );
}

static void crUnpackTexCoord1f(void)
{
	cr_unpackDispatch.TexCoord1fv((const GLfloat *) cr_unpackData);
	INCR_DATA_PTR( 4 );
}

static void crUnpackTexCoord1i(void)
{
	cr_unpackDispatch.TexCoord1iv((const GLint *) cr_unpackData);
	INCR_DATA_PTR( 4 );
}

static void crUnpackTexCoord1s(void)
{
	cr_unpackDispatch.TexCoord1sv((const GLshort *) cr_unpackData);
	INCR_DATA_PTR( 4 );
}

static void crUnpackTexCoord2d(void)
{
#ifdef CR_UNALIGNED_ACCESS_OKAY
	cr_unpackDispatch.TexCoord2dv((const GLdouble *) cr_unpackData);
#else
	GLdouble v0 = READ_DOUBLE( 0 );
	GLdouble v1 = READ_DOUBLE( 8 );
	cr_unpackDispatch.TexCoord2d( v0 , v1 );
#endif
	INCR_DATA_PTR( 16 );
}

static void crUnpackTexCoord2f(void)
{
	cr_unpackDispatch.TexCoord2fv((const GLfloat *) cr_unpackData);
	INCR_DATA_PTR( 8 );
}

static void crUnpackTexCoord2i(void)
{
	cr_unpackDispatch.TexCoord2iv((const GLint *) cr_unpackData);
	INCR_DATA_PTR( 8 );
}

static void crUnpackTexCoord2s(void)
{
	cr_unpackDispatch.TexCoord2sv((const GLshort *) cr_unpackData);
	INCR_DATA_PTR( 4 );
}

static void crUnpackTexCoord3d(void)
{
#ifdef CR_UNALIGNED_ACCESS_OKAY
	cr_unpackDispatch.TexCoord3dv((const GLdouble *) cr_unpackData);
#else
	GLdouble v0 = READ_DOUBLE( 0 );
	GLdouble v1 = READ_DOUBLE( 8 );
	GLdouble v2 = READ_DOUBLE( 16 );
	cr_unpackDispatch.TexCoord3d( v0 , v1 , v2 );
#endif
	INCR_DATA_PTR( 24 );
}

static void crUnpackTexCoord3f(void)
{
	cr_unpackDispatch.TexCoord3fv((const GLfloat *) cr_unpackData);
	INCR_DATA_PTR( 12 );
}

static void crUnpackTexCoord3i(void)
{
	cr_unpackDispatch.TexCoord3iv((const GLint *) cr_unpackData);
	INCR_DATA_PTR( 12 );
}

static void crUnpackTexCoord3s(void)
{
	cr_unpackDispatch.TexCoord3sv((const GLshort *) cr_unpackData);
	INCR_DATA_PTR( 8 );
}

static void crUnpackTexCoord4d(void)
{
#ifdef CR_UNALIGNED_ACCESS_OKAY
	cr_unpackDispatch.TexCoord4dv((const GLdouble *) cr_unpackData);
#else
	GLdouble v0 = READ_DOUBLE( 0 );
	GLdouble v1 = READ_DOUBLE( 8 );
	GLdouble v2 = READ_DOUBLE( 16 );
	GLdouble v3 = READ_DOUBLE( 24 );
	cr_unpackDispatch.TexCoord4d( v0 , v1 , v2 , v3 );
#endif
	INCR_DATA_PTR( 32 );
}

static void crUnpackTexCoord4f(void)
{
	cr_unpackDispatch.TexCoord4fv((const GLfloat *) cr_unpackData);
	INCR_DATA_PTR( 16 );
}

static void crUnpackTexCoord4i(void)
{
	cr_unpackDispatch.TexCoord4iv((const GLint *) cr_unpackData);
	INCR_DATA_PTR( 16 );
}

static void crUnpackTexCoord4s(void)
{
	cr_unpackDispatch.TexCoord4sv((const GLshort *) cr_unpackData);
	INCR_DATA_PTR( 8 );
}

static void crUnpackTranslated(void)
{
	GLdouble x = READ_DOUBLE( 0 );
	GLdouble y = READ_DOUBLE( 8 );
	GLdouble z = READ_DOUBLE( 16 );
	cr_unpackDispatch.Translated( x, y, z );
	INCR_DATA_PTR( 24 );
}

static void crUnpackTranslatef(void)
{
	GLfloat x = READ_DATA( 0, GLfloat );
	GLfloat y = READ_DATA( 4, GLfloat );
	GLfloat z = READ_DATA( 8, GLfloat );
	cr_unpackDispatch.Translatef( x, y, z );
	INCR_DATA_PTR( 12 );
}

static void crUnpackVertex2d(void)
{
#ifdef CR_UNALIGNED_ACCESS_OKAY
	cr_unpackDispatch.Vertex2dv((const GLdouble *) cr_unpackData);
#else
	GLdouble v0 = READ_DOUBLE( 0 );
	GLdouble v1 = READ_DOUBLE( 8 );
	cr_unpackDispatch.Vertex2d( v0 , v1 );
#endif
	INCR_DATA_PTR( 16 );
}

static void crUnpackVertex2f(void)
{
	cr_unpackDispatch.Vertex2fv((const GLfloat *) cr_unpackData);
	INCR_DATA_PTR( 8 );
}

static void crUnpackVertex2i(void)
{
	cr_unpackDispatch.Vertex2iv((const GLint *) cr_unpackData);
	INCR_DATA_PTR( 8 );
}

static void crUnpackVertex2s(void)
{
	cr_unpackDispatch.Vertex2sv((const GLshort *) cr_unpackData);
	INCR_DATA_PTR( 4 );
}

static void crUnpackVertex3d(void)
{
#ifdef CR_UNALIGNED_ACCESS_OKAY
	cr_unpackDispatch.Vertex3dv((const GLdouble *) cr_unpackData);
#else
	GLdouble v0 = READ_DOUBLE( 0 );
	GLdouble v1 = READ_DOUBLE( 8 );
	GLdouble v2 = READ_DOUBLE( 16 );
	cr_unpackDispatch.Vertex3d( v0 , v1 , v2 );
#endif
	INCR_DATA_PTR( 24 );
}

static void crUnpackVertex3f(void)
{
	cr_unpackDispatch.Vertex3fv((const GLfloat *) cr_unpackData);
	INCR_DATA_PTR( 12 );
}

static void crUnpackVertex3i(void)
{
	cr_unpackDispatch.Vertex3iv((const GLint *) cr_unpackData);
	INCR_DATA_PTR( 12 );
}

static void crUnpackVertex3s(void)
{
	cr_unpackDispatch.Vertex3sv((const GLshort *) cr_unpackData);
	INCR_DATA_PTR( 8 );
}

static void crUnpackVertex4d(void)
{
#ifdef CR_UNALIGNED_ACCESS_OKAY
	cr_unpackDispatch.Vertex4dv((const GLdouble *) cr_unpackData);
#else
	GLdouble v0 = READ_DOUBLE( 0 );
	GLdouble v1 = READ_DOUBLE( 8 );
	GLdouble v2 = READ_DOUBLE( 16 );
	GLdouble v3 = READ_DOUBLE( 24 );
	cr_unpackDispatch.Vertex4d( v0 , v1 , v2 , v3 );
#endif
	INCR_DATA_PTR( 32 );
}

static void crUnpackVertex4f(void)
{
	cr_unpackDispatch.Vertex4fv((const GLfloat *) cr_unpackData);
	INCR_DATA_PTR( 16 );
}

static void crUnpackVertex4i(void)
{
	cr_unpackDispatch.Vertex4iv((const GLint *) cr_unpackData);
	INCR_DATA_PTR( 16 );
}

static void crUnpackVertex4s(void)
{
	cr_unpackDispatch.Vertex4sv((const GLshort *) cr_unpackData);
	INCR_DATA_PTR( 8 );
}

static void crUnpackVertexAttrib1dARB(void)
{
	GLuint index = READ_DATA( 0, GLuint );
	GLdouble x = READ_DOUBLE( 4 );
	cr_unpackDispatch.VertexAttrib1dARB( index, x );
	INCR_DATA_PTR( 12 );
}

static void crUnpackVertexAttrib1fARB(void)
{
	GLuint index = READ_DATA( 0, GLuint );
	GLfloat x = READ_DATA( 4, GLfloat );
	cr_unpackDispatch.VertexAttrib1fARB( index, x );
	INCR_DATA_PTR( 8 );
}

static void crUnpackVertexAttrib1sARB(void)
{
	GLuint index = READ_DATA( 0, GLuint );
	GLshort x = READ_DATA( 4, GLshort );
	cr_unpackDispatch.VertexAttrib1sARB( index, x );
	INCR_DATA_PTR( 8 );
}

static void crUnpackVertexAttrib2dARB(void)
{
	GLuint index = READ_DATA( 0, GLuint );
	GLdouble x = READ_DOUBLE( 4 );
	GLdouble y = READ_DOUBLE( 12 );
	cr_unpackDispatch.VertexAttrib2dARB( index, x, y );
	INCR_DATA_PTR( 20 );
}

static void crUnpackVertexAttrib2fARB(void)
{
	GLuint index = READ_DATA( 0, GLuint );
	GLfloat x = READ_DATA( 4, GLfloat );
	GLfloat y = READ_DATA( 8, GLfloat );
	cr_unpackDispatch.VertexAttrib2fARB( index, x, y );
	INCR_DATA_PTR( 12 );
}

static void crUnpackVertexAttrib2sARB(void)
{
	GLuint index = READ_DATA( 0, GLuint );
	GLshort x = READ_DATA( 4, GLshort );
	GLshort y = READ_DATA( 6, GLshort );
	cr_unpackDispatch.VertexAttrib2sARB( index, x, y );
	INCR_DATA_PTR( 8 );
}

static void crUnpackVertexAttrib3dARB(void)
{
	GLuint index = READ_DATA( 0, GLuint );
	GLdouble x = READ_DOUBLE( 4 );
	GLdouble y = READ_DOUBLE( 12 );
	GLdouble z = READ_DOUBLE( 20 );
	cr_unpackDispatch.VertexAttrib3dARB( index, x, y, z );
	INCR_DATA_PTR( 28 );
}

static void crUnpackVertexAttrib3fARB(void)
{
	GLuint index = READ_DATA( 0, GLuint );
	GLfloat x = READ_DATA( 4, GLfloat );
	GLfloat y = READ_DATA( 8, GLfloat );
	GLfloat z = READ_DATA( 12, GLfloat );
	cr_unpackDispatch.VertexAttrib3fARB( index, x, y, z );
	INCR_DATA_PTR( 16 );
}

static void crUnpackVertexAttrib3sARB(void)
{
	GLuint index = READ_DATA( 0, GLuint );
	GLshort x = READ_DATA( 4, GLshort );
	GLshort y = READ_DATA( 6, GLshort );
	GLshort z = READ_DATA( 8, GLshort );
	cr_unpackDispatch.VertexAttrib3sARB( index, x, y, z );
	INCR_DATA_PTR( 12 );
}

static void crUnpackVertexAttrib4NubARB(void)
{
	GLuint index = READ_DATA( 0, GLuint );
	GLubyte x = READ_DATA( 4, GLubyte );
	GLubyte y = READ_DATA( 5, GLubyte );
	GLubyte z = READ_DATA( 6, GLubyte );
	GLubyte w = READ_DATA( 7, GLubyte );
	cr_unpackDispatch.VertexAttrib4NubARB( index, x, y, z, w );
	INCR_DATA_PTR( 8 );
}

static void crUnpackVertexAttrib4dARB(void)
{
	GLuint index = READ_DATA( 0, GLuint );
	GLdouble x = READ_DOUBLE( 4 );
	GLdouble y = READ_DOUBLE( 12 );
	GLdouble z = READ_DOUBLE( 20 );
	GLdouble w = READ_DOUBLE( 28 );
	cr_unpackDispatch.VertexAttrib4dARB( index, x, y, z, w );
	INCR_DATA_PTR( 36 );
}

static void crUnpackVertexAttrib4fARB(void)
{
	GLuint index = READ_DATA( 0, GLuint );
	GLfloat x = READ_DATA( 4, GLfloat );
	GLfloat y = READ_DATA( 8, GLfloat );
	GLfloat z = READ_DATA( 12, GLfloat );
	GLfloat w = READ_DATA( 16, GLfloat );
	cr_unpackDispatch.VertexAttrib4fARB( index, x, y, z, w );
	INCR_DATA_PTR( 20 );
}

static void crUnpackVertexAttrib4sARB(void)
{
	GLuint index = READ_DATA( 0, GLuint );
	GLshort x = READ_DATA( 4, GLshort );
	GLshort y = READ_DATA( 6, GLshort );
	GLshort z = READ_DATA( 8, GLshort );
	GLshort w = READ_DATA( 10, GLshort );
	cr_unpackDispatch.VertexAttrib4sARB( index, x, y, z, w );
	INCR_DATA_PTR( 12 );
}

static void crUnpackViewport(void)
{
	GLint x = READ_DATA( 0, GLint );
	GLint y = READ_DATA( 4, GLint );
	GLsizei width = READ_DATA( 8, GLsizei );
	GLsizei height = READ_DATA( 12, GLsizei );
	cr_unpackDispatch.Viewport( x, y, width, height );
	INCR_DATA_PTR( 16 );
}

 
typedef struct __dispatchNode {
    const unsigned char *unpackData;
    struct __dispatchNode *next;
} DispatchNode;

static DispatchNode *unpackStack = NULL;

static SPUDispatchTable *cr_lastDispatch = NULL;

void crUnpackPush(void)
{
    DispatchNode *node = (DispatchNode*)crAlloc( sizeof( *node ) );
    node->next = unpackStack;
    unpackStack = node;
    node->unpackData = cr_unpackData;
}

void crUnpackPop(void)
{
    DispatchNode *node = unpackStack;

    if (!node)
    {
        crError( "crUnpackPop called with an empty stack!" );
    }
    unpackStack = node->next;
    cr_unpackData = node->unpackData;
    crFree( node );
}

void crUnpack( const void *data, const void *opcodes, 
        unsigned int num_opcodes, SPUDispatchTable *table )
{
    unsigned int i;
    const unsigned char *unpack_opcodes;
    if (table != cr_lastDispatch)
    {
        crSPUCopyDispatchTable( &cr_unpackDispatch, table );
        cr_lastDispatch = table;
    }

    unpack_opcodes = (const unsigned char *)opcodes;
    cr_unpackData = (const unsigned char *)data;

#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
    crDebug("crUnpack: %d opcodes", num_opcodes);
#endif

    for (i = 0 ; i < num_opcodes ; i++)
    {
    
        CRDBGPTR_CHECKZ(writeback_ptr);
        CRDBGPTR_CHECKZ(return_ptr);
    
        /*crDebug("Unpacking opcode \%d", *unpack_opcodes);*/
        switch( *unpack_opcodes )
        {
			case CR_ALPHAFUNC_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_ALPHAFUNC_OPCODE");
#endif 
				crUnpackAlphaFunc(); 
				break;
			case CR_ARRAYELEMENT_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_ARRAYELEMENT_OPCODE");
#endif 
				crUnpackArrayElement(); 
				break;
			case CR_BEGIN_OPCODE:
				crUnpackBegin(); 
				break;
			case CR_BINDTEXTURE_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_BINDTEXTURE_OPCODE");
#endif 
				crUnpackBindTexture(); 
				break;
			case CR_BITMAP_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_BITMAP_OPCODE");
#endif 
				crUnpackBitmap(); 
				break;
			case CR_BLENDFUNC_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_BLENDFUNC_OPCODE");
#endif 
				crUnpackBlendFunc(); 
				break;
			case CR_BOUNDSINFOCR_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_BOUNDSINFOCR_OPCODE");
#endif 
				crUnpackBoundsInfoCR(); 
				break;
			case CR_CALLLIST_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_CALLLIST_OPCODE");
#endif 
				crUnpackCallList(); 
				break;
			case CR_CALLLISTS_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_CALLLISTS_OPCODE");
#endif 
				crUnpackCallLists(); 
				break;
			case CR_CLEAR_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_CLEAR_OPCODE");
#endif 
				crUnpackClear(); 
				break;
			case CR_CLIPPLANE_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_CLIPPLANE_OPCODE");
#endif 
				crUnpackClipPlane(); 
				break;
			case CR_COLOR3B_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COLOR3B_OPCODE");
#endif 
				crUnpackColor3b(); 
				break;
			case CR_COLOR3D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COLOR3D_OPCODE");
#endif 
				crUnpackColor3d(); 
				break;
			case CR_COLOR3F_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COLOR3F_OPCODE");
#endif 
				crUnpackColor3f(); 
				break;
			case CR_COLOR3I_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COLOR3I_OPCODE");
#endif 
				crUnpackColor3i(); 
				break;
			case CR_COLOR3S_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COLOR3S_OPCODE");
#endif 
				crUnpackColor3s(); 
				break;
			case CR_COLOR3UB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COLOR3UB_OPCODE");
#endif 
				crUnpackColor3ub(); 
				break;
			case CR_COLOR3UI_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COLOR3UI_OPCODE");
#endif 
				crUnpackColor3ui(); 
				break;
			case CR_COLOR3US_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COLOR3US_OPCODE");
#endif 
				crUnpackColor3us(); 
				break;
			case CR_COLOR4B_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COLOR4B_OPCODE");
#endif 
				crUnpackColor4b(); 
				break;
			case CR_COLOR4D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COLOR4D_OPCODE");
#endif 
				crUnpackColor4d(); 
				break;
			case CR_COLOR4F_OPCODE:
				crUnpackColor4f(); 
				break;
			case CR_COLOR4I_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COLOR4I_OPCODE");
#endif 
				crUnpackColor4i(); 
				break;
			case CR_COLOR4S_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COLOR4S_OPCODE");
#endif 
				crUnpackColor4s(); 
				break;
			case CR_COLOR4UB_OPCODE:
				crUnpackColor4ub(); 
				break;
			case CR_COLOR4UI_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COLOR4UI_OPCODE");
#endif 
				crUnpackColor4ui(); 
				break;
			case CR_COLOR4US_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COLOR4US_OPCODE");
#endif 
				crUnpackColor4us(); 
				break;
			case CR_COLORMASK_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COLORMASK_OPCODE");
#endif 
				crUnpackColorMask(); 
				break;
			case CR_COLORMATERIAL_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COLORMATERIAL_OPCODE");
#endif 
				crUnpackColorMaterial(); 
				break;
			case CR_COPYPIXELS_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COPYPIXELS_OPCODE");
#endif 
				crUnpackCopyPixels(); 
				break;
			case CR_COPYTEXIMAGE1D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COPYTEXIMAGE1D_OPCODE");
#endif 
				crUnpackCopyTexImage1D(); 
				break;
			case CR_COPYTEXIMAGE2D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COPYTEXIMAGE2D_OPCODE");
#endif 
				crUnpackCopyTexImage2D(); 
				break;
			case CR_COPYTEXSUBIMAGE1D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COPYTEXSUBIMAGE1D_OPCODE");
#endif 
				crUnpackCopyTexSubImage1D(); 
				break;
			case CR_COPYTEXSUBIMAGE2D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COPYTEXSUBIMAGE2D_OPCODE");
#endif 
				crUnpackCopyTexSubImage2D(); 
				break;
			case CR_COPYTEXSUBIMAGE3D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_COPYTEXSUBIMAGE3D_OPCODE");
#endif 
				crUnpackCopyTexSubImage3D(); 
				break;
			case CR_CULLFACE_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_CULLFACE_OPCODE");
#endif 
				crUnpackCullFace(); 
				break;
			case CR_DELETETEXTURES_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_DELETETEXTURES_OPCODE");
#endif 
				crUnpackDeleteTextures(); 
				break;
			case CR_DEPTHFUNC_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_DEPTHFUNC_OPCODE");
#endif 
				crUnpackDepthFunc(); 
				break;
			case CR_DEPTHMASK_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_DEPTHMASK_OPCODE");
#endif 
				crUnpackDepthMask(); 
				break;
			case CR_DEPTHRANGE_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_DEPTHRANGE_OPCODE");
#endif 
				crUnpackDepthRange(); 
				break;
			case CR_DISABLE_OPCODE:
				crUnpackDisable(); 
				break;
			case CR_DISABLECLIENTSTATE_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_DISABLECLIENTSTATE_OPCODE");
#endif 
				crUnpackDisableClientState(); 
				break;
			case CR_DRAWARRAYS_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_DRAWARRAYS_OPCODE");
#endif 
				crUnpackDrawArrays(); 
				break;
			case CR_DRAWPIXELS_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_DRAWPIXELS_OPCODE");
#endif 
				crUnpackDrawPixels(); 
				break;
			case CR_EDGEFLAG_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_EDGEFLAG_OPCODE");
#endif 
				crUnpackEdgeFlag(); 
				break;
			case CR_ENABLE_OPCODE:
				crUnpackEnable(); 
				break;
			case CR_ENABLECLIENTSTATE_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_ENABLECLIENTSTATE_OPCODE");
#endif 
				crUnpackEnableClientState(); 
				break;
			case CR_END_OPCODE:
				crUnpackEnd(); 
				break;
			case CR_EVALCOORD1D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_EVALCOORD1D_OPCODE");
#endif 
				crUnpackEvalCoord1d(); 
				break;
			case CR_EVALCOORD1F_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_EVALCOORD1F_OPCODE");
#endif 
				crUnpackEvalCoord1f(); 
				break;
			case CR_EVALCOORD2D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_EVALCOORD2D_OPCODE");
#endif 
				crUnpackEvalCoord2d(); 
				break;
			case CR_EVALCOORD2F_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_EVALCOORD2F_OPCODE");
#endif 
				crUnpackEvalCoord2f(); 
				break;
			case CR_EVALMESH1_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_EVALMESH1_OPCODE");
#endif 
				crUnpackEvalMesh1(); 
				break;
			case CR_EVALMESH2_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_EVALMESH2_OPCODE");
#endif 
				crUnpackEvalMesh2(); 
				break;
			case CR_EVALPOINT1_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_EVALPOINT1_OPCODE");
#endif 
				crUnpackEvalPoint1(); 
				break;
			case CR_EVALPOINT2_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_EVALPOINT2_OPCODE");
#endif 
				crUnpackEvalPoint2(); 
				break;
			case CR_FEEDBACKBUFFER_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_FEEDBACKBUFFER_OPCODE");
#endif 
				crUnpackFeedbackBuffer(); 
				break;
			case CR_FINISH_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_FINISH_OPCODE");
#endif 
				crUnpackFinish(); 
				break;
			case CR_FLUSH_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_FLUSH_OPCODE");
#endif 
				crUnpackFlush(); 
				break;
			case CR_FOGCOORDDEXT_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_FOGCOORDDEXT_OPCODE");
#endif 
				crUnpackFogCoorddEXT(); 
				break;
			case CR_FOGCOORDFEXT_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_FOGCOORDFEXT_OPCODE");
#endif 
				crUnpackFogCoordfEXT(); 
				break;
			case CR_FOGF_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_FOGF_OPCODE");
#endif 
				crUnpackFogf(); 
				break;
			case CR_FOGFV_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_FOGFV_OPCODE");
#endif 
				crUnpackFogfv(); 
				break;
			case CR_FOGI_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_FOGI_OPCODE");
#endif 
				crUnpackFogi(); 
				break;
			case CR_FOGIV_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_FOGIV_OPCODE");
#endif 
				crUnpackFogiv(); 
				break;
			case CR_FRONTFACE_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_FRONTFACE_OPCODE");
#endif 
				crUnpackFrontFace(); 
				break;
			case CR_FRUSTUM_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_FRUSTUM_OPCODE");
#endif 
				crUnpackFrustum(); 
				break;
			case CR_INDEXMASK_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_INDEXMASK_OPCODE");
#endif 
				crUnpackIndexMask(); 
				break;
			case CR_INDEXD_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_INDEXD_OPCODE");
#endif 
				crUnpackIndexd(); 
				break;
			case CR_INDEXF_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_INDEXF_OPCODE");
#endif 
				crUnpackIndexf(); 
				break;
			case CR_INDEXI_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_INDEXI_OPCODE");
#endif 
				crUnpackIndexi(); 
				break;
			case CR_INDEXS_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_INDEXS_OPCODE");
#endif 
				crUnpackIndexs(); 
				break;
			case CR_INDEXUB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_INDEXUB_OPCODE");
#endif 
				crUnpackIndexub(); 
				break;
			case CR_INITNAMES_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_INITNAMES_OPCODE");
#endif 
				crUnpackInitNames(); 
				break;
			case CR_LIGHTMODELF_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_LIGHTMODELF_OPCODE");
#endif 
				crUnpackLightModelf(); 
				break;
			case CR_LIGHTMODELFV_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_LIGHTMODELFV_OPCODE");
#endif 
				crUnpackLightModelfv(); 
				break;
			case CR_LIGHTMODELI_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_LIGHTMODELI_OPCODE");
#endif 
				crUnpackLightModeli(); 
				break;
			case CR_LIGHTMODELIV_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_LIGHTMODELIV_OPCODE");
#endif 
				crUnpackLightModeliv(); 
				break;
			case CR_LIGHTF_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_LIGHTF_OPCODE");
#endif 
				crUnpackLightf(); 
				break;
			case CR_LIGHTFV_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_LIGHTFV_OPCODE");
#endif 
				crUnpackLightfv(); 
				break;
			case CR_LIGHTI_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_LIGHTI_OPCODE");
#endif 
				crUnpackLighti(); 
				break;
			case CR_LIGHTIV_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_LIGHTIV_OPCODE");
#endif 
				crUnpackLightiv(); 
				break;
			case CR_LINESTIPPLE_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_LINESTIPPLE_OPCODE");
#endif 
				crUnpackLineStipple(); 
				break;
			case CR_LINEWIDTH_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_LINEWIDTH_OPCODE");
#endif 
				crUnpackLineWidth(); 
				break;
			case CR_LOADIDENTITY_OPCODE:
				crUnpackLoadIdentity(); 
				break;
			case CR_LOADMATRIXD_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_LOADMATRIXD_OPCODE");
#endif 
				crUnpackLoadMatrixd(); 
				break;
			case CR_LOADMATRIXF_OPCODE:
				crUnpackLoadMatrixf(); 
				break;
			case CR_LOADNAME_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_LOADNAME_OPCODE");
#endif 
				crUnpackLoadName(); 
				break;
			case CR_MAP1D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MAP1D_OPCODE");
#endif 
				crUnpackMap1d(); 
				break;
			case CR_MAP1F_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MAP1F_OPCODE");
#endif 
				crUnpackMap1f(); 
				break;
			case CR_MAP2D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MAP2D_OPCODE");
#endif 
				crUnpackMap2d(); 
				break;
			case CR_MAP2F_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MAP2F_OPCODE");
#endif 
				crUnpackMap2f(); 
				break;
			case CR_MAPGRID1D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MAPGRID1D_OPCODE");
#endif 
				crUnpackMapGrid1d(); 
				break;
			case CR_MAPGRID1F_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MAPGRID1F_OPCODE");
#endif 
				crUnpackMapGrid1f(); 
				break;
			case CR_MAPGRID2D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MAPGRID2D_OPCODE");
#endif 
				crUnpackMapGrid2d(); 
				break;
			case CR_MAPGRID2F_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MAPGRID2F_OPCODE");
#endif 
				crUnpackMapGrid2f(); 
				break;
			case CR_MATERIALF_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MATERIALF_OPCODE");
#endif 
				crUnpackMaterialf(); 
				break;
			case CR_MATERIALFV_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MATERIALFV_OPCODE");
#endif 
				crUnpackMaterialfv(); 
				break;
			case CR_MATERIALI_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MATERIALI_OPCODE");
#endif 
				crUnpackMateriali(); 
				break;
			case CR_MATERIALIV_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MATERIALIV_OPCODE");
#endif 
				crUnpackMaterialiv(); 
				break;
			case CR_MATRIXMODE_OPCODE:
				crUnpackMatrixMode(); 
				break;
			case CR_MULTMATRIXD_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MULTMATRIXD_OPCODE");
#endif 
				crUnpackMultMatrixd(); 
				break;
			case CR_MULTMATRIXF_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MULTMATRIXF_OPCODE");
#endif 
				crUnpackMultMatrixf(); 
				break;
			case CR_MULTITEXCOORD1DARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MULTITEXCOORD1DARB_OPCODE");
#endif 
				crUnpackMultiTexCoord1dARB(); 
				break;
			case CR_MULTITEXCOORD1FARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MULTITEXCOORD1FARB_OPCODE");
#endif 
				crUnpackMultiTexCoord1fARB(); 
				break;
			case CR_MULTITEXCOORD1IARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MULTITEXCOORD1IARB_OPCODE");
#endif 
				crUnpackMultiTexCoord1iARB(); 
				break;
			case CR_MULTITEXCOORD1SARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MULTITEXCOORD1SARB_OPCODE");
#endif 
				crUnpackMultiTexCoord1sARB(); 
				break;
			case CR_MULTITEXCOORD2DARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MULTITEXCOORD2DARB_OPCODE");
#endif 
				crUnpackMultiTexCoord2dARB(); 
				break;
			case CR_MULTITEXCOORD2FARB_OPCODE:
				crUnpackMultiTexCoord2fARB(); 
				break;
			case CR_MULTITEXCOORD2IARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MULTITEXCOORD2IARB_OPCODE");
#endif 
				crUnpackMultiTexCoord2iARB(); 
				break;
			case CR_MULTITEXCOORD2SARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MULTITEXCOORD2SARB_OPCODE");
#endif 
				crUnpackMultiTexCoord2sARB(); 
				break;
			case CR_MULTITEXCOORD3DARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MULTITEXCOORD3DARB_OPCODE");
#endif 
				crUnpackMultiTexCoord3dARB(); 
				break;
			case CR_MULTITEXCOORD3FARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MULTITEXCOORD3FARB_OPCODE");
#endif 
				crUnpackMultiTexCoord3fARB(); 
				break;
			case CR_MULTITEXCOORD3IARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MULTITEXCOORD3IARB_OPCODE");
#endif 
				crUnpackMultiTexCoord3iARB(); 
				break;
			case CR_MULTITEXCOORD3SARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MULTITEXCOORD3SARB_OPCODE");
#endif 
				crUnpackMultiTexCoord3sARB(); 
				break;
			case CR_MULTITEXCOORD4DARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MULTITEXCOORD4DARB_OPCODE");
#endif 
				crUnpackMultiTexCoord4dARB(); 
				break;
			case CR_MULTITEXCOORD4FARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MULTITEXCOORD4FARB_OPCODE");
#endif 
				crUnpackMultiTexCoord4fARB(); 
				break;
			case CR_MULTITEXCOORD4IARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MULTITEXCOORD4IARB_OPCODE");
#endif 
				crUnpackMultiTexCoord4iARB(); 
				break;
			case CR_MULTITEXCOORD4SARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_MULTITEXCOORD4SARB_OPCODE");
#endif 
				crUnpackMultiTexCoord4sARB(); 
				break;
			case CR_NORMAL3B_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_NORMAL3B_OPCODE");
#endif 
				crUnpackNormal3b(); 
				break;
			case CR_NORMAL3D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_NORMAL3D_OPCODE");
#endif 
				crUnpackNormal3d(); 
				break;
			case CR_NORMAL3F_OPCODE:
				crUnpackNormal3f(); 
				break;
			case CR_NORMAL3I_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_NORMAL3I_OPCODE");
#endif 
				crUnpackNormal3i(); 
				break;
			case CR_NORMAL3S_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_NORMAL3S_OPCODE");
#endif 
				crUnpackNormal3s(); 
				break;
			case CR_ORTHO_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_ORTHO_OPCODE");
#endif 
				crUnpackOrtho(); 
				break;
			case CR_PASSTHROUGH_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_PASSTHROUGH_OPCODE");
#endif 
				crUnpackPassThrough(); 
				break;
			case CR_PIXELMAPFV_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_PIXELMAPFV_OPCODE");
#endif 
				crUnpackPixelMapfv(); 
				break;
			case CR_PIXELMAPUIV_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_PIXELMAPUIV_OPCODE");
#endif 
				crUnpackPixelMapuiv(); 
				break;
			case CR_PIXELMAPUSV_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_PIXELMAPUSV_OPCODE");
#endif 
				crUnpackPixelMapusv(); 
				break;
			case CR_PIXELSTOREF_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_PIXELSTOREF_OPCODE");
#endif 
				crUnpackPixelStoref(); 
				break;
			case CR_PIXELSTOREI_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_PIXELSTOREI_OPCODE");
#endif 
				crUnpackPixelStorei(); 
				break;
			case CR_PIXELTRANSFERF_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_PIXELTRANSFERF_OPCODE");
#endif 
				crUnpackPixelTransferf(); 
				break;
			case CR_PIXELTRANSFERI_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_PIXELTRANSFERI_OPCODE");
#endif 
				crUnpackPixelTransferi(); 
				break;
			case CR_PIXELZOOM_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_PIXELZOOM_OPCODE");
#endif 
				crUnpackPixelZoom(); 
				break;
			case CR_POINTSIZE_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_POINTSIZE_OPCODE");
#endif 
				crUnpackPointSize(); 
				break;
			case CR_POLYGONMODE_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_POLYGONMODE_OPCODE");
#endif 
				crUnpackPolygonMode(); 
				break;
			case CR_POLYGONOFFSET_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_POLYGONOFFSET_OPCODE");
#endif 
				crUnpackPolygonOffset(); 
				break;
			case CR_POLYGONSTIPPLE_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_POLYGONSTIPPLE_OPCODE");
#endif 
				crUnpackPolygonStipple(); 
				break;
			case CR_POPMATRIX_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_POPMATRIX_OPCODE");
#endif 
				crUnpackPopMatrix(); 
				break;
			case CR_POPNAME_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_POPNAME_OPCODE");
#endif 
				crUnpackPopName(); 
				break;
			case CR_PRIORITIZETEXTURES_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_PRIORITIZETEXTURES_OPCODE");
#endif 
				crUnpackPrioritizeTextures(); 
				break;
			case CR_PUSHMATRIX_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_PUSHMATRIX_OPCODE");
#endif 
				crUnpackPushMatrix(); 
				break;
			case CR_PUSHNAME_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_PUSHNAME_OPCODE");
#endif 
				crUnpackPushName(); 
				break;
			case CR_RASTERPOS2D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_RASTERPOS2D_OPCODE");
#endif 
				crUnpackRasterPos2d(); 
				break;
			case CR_RASTERPOS2F_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_RASTERPOS2F_OPCODE");
#endif 
				crUnpackRasterPos2f(); 
				break;
			case CR_RASTERPOS2I_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_RASTERPOS2I_OPCODE");
#endif 
				crUnpackRasterPos2i(); 
				break;
			case CR_RASTERPOS2S_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_RASTERPOS2S_OPCODE");
#endif 
				crUnpackRasterPos2s(); 
				break;
			case CR_RASTERPOS3D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_RASTERPOS3D_OPCODE");
#endif 
				crUnpackRasterPos3d(); 
				break;
			case CR_RASTERPOS3F_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_RASTERPOS3F_OPCODE");
#endif 
				crUnpackRasterPos3f(); 
				break;
			case CR_RASTERPOS3I_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_RASTERPOS3I_OPCODE");
#endif 
				crUnpackRasterPos3i(); 
				break;
			case CR_RASTERPOS3S_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_RASTERPOS3S_OPCODE");
#endif 
				crUnpackRasterPos3s(); 
				break;
			case CR_RASTERPOS4D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_RASTERPOS4D_OPCODE");
#endif 
				crUnpackRasterPos4d(); 
				break;
			case CR_RASTERPOS4F_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_RASTERPOS4F_OPCODE");
#endif 
				crUnpackRasterPos4f(); 
				break;
			case CR_RASTERPOS4I_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_RASTERPOS4I_OPCODE");
#endif 
				crUnpackRasterPos4i(); 
				break;
			case CR_RASTERPOS4S_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_RASTERPOS4S_OPCODE");
#endif 
				crUnpackRasterPos4s(); 
				break;
			case CR_READPIXELS_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_READPIXELS_OPCODE");
#endif 
				crUnpackReadPixels(); 
				break;
			case CR_RECTD_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_RECTD_OPCODE");
#endif 
				crUnpackRectd(); 
				break;
			case CR_RECTF_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_RECTF_OPCODE");
#endif 
				crUnpackRectf(); 
				break;
			case CR_RECTI_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_RECTI_OPCODE");
#endif 
				crUnpackRecti(); 
				break;
			case CR_RECTS_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_RECTS_OPCODE");
#endif 
				crUnpackRects(); 
				break;
			case CR_ROTATED_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_ROTATED_OPCODE");
#endif 
				crUnpackRotated(); 
				break;
			case CR_ROTATEF_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_ROTATEF_OPCODE");
#endif 
				crUnpackRotatef(); 
				break;
			case CR_SCALED_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_SCALED_OPCODE");
#endif 
				crUnpackScaled(); 
				break;
			case CR_SCALEF_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_SCALEF_OPCODE");
#endif 
				crUnpackScalef(); 
				break;
			case CR_SCISSOR_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_SCISSOR_OPCODE");
#endif 
				crUnpackScissor(); 
				break;
			case CR_SECONDARYCOLOR3BEXT_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_SECONDARYCOLOR3BEXT_OPCODE");
#endif 
				crUnpackSecondaryColor3bEXT(); 
				break;
			case CR_SECONDARYCOLOR3DEXT_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_SECONDARYCOLOR3DEXT_OPCODE");
#endif 
				crUnpackSecondaryColor3dEXT(); 
				break;
			case CR_SECONDARYCOLOR3FEXT_OPCODE:
				crUnpackSecondaryColor3fEXT(); 
				break;
			case CR_SECONDARYCOLOR3IEXT_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_SECONDARYCOLOR3IEXT_OPCODE");
#endif 
				crUnpackSecondaryColor3iEXT(); 
				break;
			case CR_SECONDARYCOLOR3SEXT_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_SECONDARYCOLOR3SEXT_OPCODE");
#endif 
				crUnpackSecondaryColor3sEXT(); 
				break;
			case CR_SECONDARYCOLOR3UBEXT_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_SECONDARYCOLOR3UBEXT_OPCODE");
#endif 
				crUnpackSecondaryColor3ubEXT(); 
				break;
			case CR_SECONDARYCOLOR3UIEXT_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_SECONDARYCOLOR3UIEXT_OPCODE");
#endif 
				crUnpackSecondaryColor3uiEXT(); 
				break;
			case CR_SECONDARYCOLOR3USEXT_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_SECONDARYCOLOR3USEXT_OPCODE");
#endif 
				crUnpackSecondaryColor3usEXT(); 
				break;
			case CR_SELECTBUFFER_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_SELECTBUFFER_OPCODE");
#endif 
				crUnpackSelectBuffer(); 
				break;
			case CR_SHADEMODEL_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_SHADEMODEL_OPCODE");
#endif 
				crUnpackShadeModel(); 
				break;
			case CR_STENCILFUNC_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_STENCILFUNC_OPCODE");
#endif 
				crUnpackStencilFunc(); 
				break;
			case CR_STENCILMASK_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_STENCILMASK_OPCODE");
#endif 
				crUnpackStencilMask(); 
				break;
			case CR_STENCILOP_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_STENCILOP_OPCODE");
#endif 
				crUnpackStencilOp(); 
				break;
			case CR_TEXCOORD1D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXCOORD1D_OPCODE");
#endif 
				crUnpackTexCoord1d(); 
				break;
			case CR_TEXCOORD1F_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXCOORD1F_OPCODE");
#endif 
				crUnpackTexCoord1f(); 
				break;
			case CR_TEXCOORD1I_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXCOORD1I_OPCODE");
#endif 
				crUnpackTexCoord1i(); 
				break;
			case CR_TEXCOORD1S_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXCOORD1S_OPCODE");
#endif 
				crUnpackTexCoord1s(); 
				break;
			case CR_TEXCOORD2D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXCOORD2D_OPCODE");
#endif 
				crUnpackTexCoord2d(); 
				break;
			case CR_TEXCOORD2F_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXCOORD2F_OPCODE");
#endif 
				crUnpackTexCoord2f(); 
				break;
			case CR_TEXCOORD2I_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXCOORD2I_OPCODE");
#endif 
				crUnpackTexCoord2i(); 
				break;
			case CR_TEXCOORD2S_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXCOORD2S_OPCODE");
#endif 
				crUnpackTexCoord2s(); 
				break;
			case CR_TEXCOORD3D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXCOORD3D_OPCODE");
#endif 
				crUnpackTexCoord3d(); 
				break;
			case CR_TEXCOORD3F_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXCOORD3F_OPCODE");
#endif 
				crUnpackTexCoord3f(); 
				break;
			case CR_TEXCOORD3I_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXCOORD3I_OPCODE");
#endif 
				crUnpackTexCoord3i(); 
				break;
			case CR_TEXCOORD3S_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXCOORD3S_OPCODE");
#endif 
				crUnpackTexCoord3s(); 
				break;
			case CR_TEXCOORD4D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXCOORD4D_OPCODE");
#endif 
				crUnpackTexCoord4d(); 
				break;
			case CR_TEXCOORD4F_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXCOORD4F_OPCODE");
#endif 
				crUnpackTexCoord4f(); 
				break;
			case CR_TEXCOORD4I_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXCOORD4I_OPCODE");
#endif 
				crUnpackTexCoord4i(); 
				break;
			case CR_TEXCOORD4S_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXCOORD4S_OPCODE");
#endif 
				crUnpackTexCoord4s(); 
				break;
			case CR_TEXENVFV_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXENVFV_OPCODE");
#endif 
				crUnpackTexEnvfv(); 
				break;
			case CR_TEXENVIV_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXENVIV_OPCODE");
#endif 
				crUnpackTexEnviv(); 
				break;
			case CR_TEXGENDV_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXGENDV_OPCODE");
#endif 
				crUnpackTexGendv(); 
				break;
			case CR_TEXGENFV_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXGENFV_OPCODE");
#endif 
				crUnpackTexGenfv(); 
				break;
			case CR_TEXGENIV_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXGENIV_OPCODE");
#endif 
				crUnpackTexGeniv(); 
				break;
			case CR_TEXIMAGE1D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXIMAGE1D_OPCODE");
#endif 
				crUnpackTexImage1D(); 
				break;
			case CR_TEXIMAGE2D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXIMAGE2D_OPCODE");
#endif 
				crUnpackTexImage2D(); 
				break;
			case CR_TEXIMAGE3D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXIMAGE3D_OPCODE");
#endif 
				crUnpackTexImage3D(); 
				break;
			case CR_TEXIMAGE3DEXT_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXIMAGE3DEXT_OPCODE");
#endif 
				crUnpackTexImage3DEXT(); 
				break;
			case CR_TEXPARAMETERFV_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXPARAMETERFV_OPCODE");
#endif 
				crUnpackTexParameterfv(); 
				break;
			case CR_TEXPARAMETERIV_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXPARAMETERIV_OPCODE");
#endif 
				crUnpackTexParameteriv(); 
				break;
			case CR_TEXSUBIMAGE1D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXSUBIMAGE1D_OPCODE");
#endif 
				crUnpackTexSubImage1D(); 
				break;
			case CR_TEXSUBIMAGE2D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXSUBIMAGE2D_OPCODE");
#endif 
				crUnpackTexSubImage2D(); 
				break;
			case CR_TEXSUBIMAGE3D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TEXSUBIMAGE3D_OPCODE");
#endif 
				crUnpackTexSubImage3D(); 
				break;
			case CR_TRANSLATED_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TRANSLATED_OPCODE");
#endif 
				crUnpackTranslated(); 
				break;
			case CR_TRANSLATEF_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_TRANSLATEF_OPCODE");
#endif 
				crUnpackTranslatef(); 
				break;
			case CR_VERTEX2D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEX2D_OPCODE");
#endif 
				crUnpackVertex2d(); 
				break;
			case CR_VERTEX2F_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEX2F_OPCODE");
#endif 
				crUnpackVertex2f(); 
				break;
			case CR_VERTEX2I_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEX2I_OPCODE");
#endif 
				crUnpackVertex2i(); 
				break;
			case CR_VERTEX2S_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEX2S_OPCODE");
#endif 
				crUnpackVertex2s(); 
				break;
			case CR_VERTEX3D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEX3D_OPCODE");
#endif 
				crUnpackVertex3d(); 
				break;
			case CR_VERTEX3F_OPCODE:
				crUnpackVertex3f(); 
				break;
			case CR_VERTEX3I_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEX3I_OPCODE");
#endif 
				crUnpackVertex3i(); 
				break;
			case CR_VERTEX3S_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEX3S_OPCODE");
#endif 
				crUnpackVertex3s(); 
				break;
			case CR_VERTEX4D_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEX4D_OPCODE");
#endif 
				crUnpackVertex4d(); 
				break;
			case CR_VERTEX4F_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEX4F_OPCODE");
#endif 
				crUnpackVertex4f(); 
				break;
			case CR_VERTEX4I_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEX4I_OPCODE");
#endif 
				crUnpackVertex4i(); 
				break;
			case CR_VERTEX4S_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEX4S_OPCODE");
#endif 
				crUnpackVertex4s(); 
				break;
			case CR_VERTEXATTRIB1DARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB1DARB_OPCODE");
#endif 
				crUnpackVertexAttrib1dARB(); 
				break;
			case CR_VERTEXATTRIB1FARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB1FARB_OPCODE");
#endif 
				crUnpackVertexAttrib1fARB(); 
				break;
			case CR_VERTEXATTRIB1SARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB1SARB_OPCODE");
#endif 
				crUnpackVertexAttrib1sARB(); 
				break;
			case CR_VERTEXATTRIB2DARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB2DARB_OPCODE");
#endif 
				crUnpackVertexAttrib2dARB(); 
				break;
			case CR_VERTEXATTRIB2FARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB2FARB_OPCODE");
#endif 
				crUnpackVertexAttrib2fARB(); 
				break;
			case CR_VERTEXATTRIB2SARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB2SARB_OPCODE");
#endif 
				crUnpackVertexAttrib2sARB(); 
				break;
			case CR_VERTEXATTRIB3DARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB3DARB_OPCODE");
#endif 
				crUnpackVertexAttrib3dARB(); 
				break;
			case CR_VERTEXATTRIB3FARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB3FARB_OPCODE");
#endif 
				crUnpackVertexAttrib3fARB(); 
				break;
			case CR_VERTEXATTRIB3SARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB3SARB_OPCODE");
#endif 
				crUnpackVertexAttrib3sARB(); 
				break;
			case CR_VERTEXATTRIB4NBVARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB4NBVARB_OPCODE");
#endif 
				crUnpackVertexAttrib4NbvARB(); 
				break;
			case CR_VERTEXATTRIB4NIVARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB4NIVARB_OPCODE");
#endif 
				crUnpackVertexAttrib4NivARB(); 
				break;
			case CR_VERTEXATTRIB4NSVARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB4NSVARB_OPCODE");
#endif 
				crUnpackVertexAttrib4NsvARB(); 
				break;
			case CR_VERTEXATTRIB4NUBARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB4NUBARB_OPCODE");
#endif 
				crUnpackVertexAttrib4NubARB(); 
				break;
			case CR_VERTEXATTRIB4NUBVARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB4NUBVARB_OPCODE");
#endif 
				crUnpackVertexAttrib4NubvARB(); 
				break;
			case CR_VERTEXATTRIB4NUIVARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB4NUIVARB_OPCODE");
#endif 
				crUnpackVertexAttrib4NuivARB(); 
				break;
			case CR_VERTEXATTRIB4NUSVARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB4NUSVARB_OPCODE");
#endif 
				crUnpackVertexAttrib4NusvARB(); 
				break;
			case CR_VERTEXATTRIB4BVARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB4BVARB_OPCODE");
#endif 
				crUnpackVertexAttrib4bvARB(); 
				break;
			case CR_VERTEXATTRIB4DARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB4DARB_OPCODE");
#endif 
				crUnpackVertexAttrib4dARB(); 
				break;
			case CR_VERTEXATTRIB4FARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB4FARB_OPCODE");
#endif 
				crUnpackVertexAttrib4fARB(); 
				break;
			case CR_VERTEXATTRIB4IVARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB4IVARB_OPCODE");
#endif 
				crUnpackVertexAttrib4ivARB(); 
				break;
			case CR_VERTEXATTRIB4SARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB4SARB_OPCODE");
#endif 
				crUnpackVertexAttrib4sARB(); 
				break;
			case CR_VERTEXATTRIB4UBVARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB4UBVARB_OPCODE");
#endif 
				crUnpackVertexAttrib4ubvARB(); 
				break;
			case CR_VERTEXATTRIB4UIVARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB4UIVARB_OPCODE");
#endif 
				crUnpackVertexAttrib4uivARB(); 
				break;
			case CR_VERTEXATTRIB4USVARB_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VERTEXATTRIB4USVARB_OPCODE");
#endif 
				crUnpackVertexAttrib4usvARB(); 
				break;
			case CR_VIEWPORT_OPCODE:

#ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                if (i==(num_opcodes-1))
#endif
#if defined(CR_UNPACK_DEBUG_OPCODES) || defined(CR_UNPACK_DEBUG_LAST_OPCODES)
                crDebug("Unpack: CR_VIEWPORT_OPCODE");
#endif 
				crUnpackViewport(); 
				break;
       
            case CR_EXTEND_OPCODE:
                #ifdef CR_UNPACK_DEBUG_OPCODES 
                    crUnpackExtendDbg();
                #else
                # ifdef CR_UNPACK_DEBUG_LAST_OPCODES
                    if (i==(num_opcodes-1)) crUnpackExtendDbg();
                    else
                # endif
                    crUnpackExtend();
                #endif
                break;
            default:
                crError( "Unknown opcode: %d", *unpack_opcodes );
                break;
        }
        
        CRDBGPTR_CHECKZ(writeback_ptr);
        CRDBGPTR_CHECKZ(return_ptr);
        
        unpack_opcodes--;
    }
}
static void crUnpackExtendAccum(void)
{
	GLenum op = READ_DATA( 8, GLenum );
	GLfloat value = READ_DATA( 12, GLfloat );
	cr_unpackDispatch.Accum( op, value );
}

static void crUnpackExtendActiveStencilFaceEXT(void)
{
	GLenum face = READ_DATA( 8, GLenum );
	cr_unpackDispatch.ActiveStencilFaceEXT( face );
}

static void crUnpackExtendActiveTextureARB(void)
{
	GLenum texture = READ_DATA( 8, GLenum );
	cr_unpackDispatch.ActiveTextureARB( texture );
}

static void crUnpackExtendAttachShader(void)
{
	GLuint program = READ_DATA( 8, GLuint );
	GLuint shader = READ_DATA( 12, GLuint );
	cr_unpackDispatch.AttachShader( program, shader );
}

static void crUnpackExtendBarrierCreateCR(void)
{
	GLuint name = READ_DATA( 8, GLuint );
	GLuint count = READ_DATA( 12, GLuint );
	cr_unpackDispatch.BarrierCreateCR( name, count );
}

static void crUnpackExtendBarrierDestroyCR(void)
{
	GLuint name = READ_DATA( 8, GLuint );
	cr_unpackDispatch.BarrierDestroyCR( name );
}

static void crUnpackExtendBarrierExecCR(void)
{
	GLuint name = READ_DATA( 8, GLuint );
	cr_unpackDispatch.BarrierExecCR( name );
}

static void crUnpackExtendBeginQueryARB(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLuint id = READ_DATA( 12, GLuint );
	cr_unpackDispatch.BeginQueryARB( target, id );
}

static void crUnpackExtendBindBufferARB(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLuint buffer = READ_DATA( 12, GLuint );
	cr_unpackDispatch.BindBufferARB( target, buffer );
}

static void crUnpackExtendBindFramebufferEXT(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLuint framebuffer = READ_DATA( 12, GLuint );
	cr_unpackDispatch.BindFramebufferEXT( target, framebuffer );
}

static void crUnpackExtendBindProgramARB(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLuint program = READ_DATA( 12, GLuint );
	cr_unpackDispatch.BindProgramARB( target, program );
}

static void crUnpackExtendBindProgramNV(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLuint id = READ_DATA( 12, GLuint );
	cr_unpackDispatch.BindProgramNV( target, id );
}

static void crUnpackExtendBindRenderbufferEXT(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLuint renderbuffer = READ_DATA( 12, GLuint );
	cr_unpackDispatch.BindRenderbufferEXT( target, renderbuffer );
}

static void crUnpackExtendBlendColorEXT(void)
{
	GLclampf red = READ_DATA( 8, GLclampf );
	GLclampf green = READ_DATA( 12, GLclampf );
	GLclampf blue = READ_DATA( 16, GLclampf );
	GLclampf alpha = READ_DATA( 20, GLclampf );
	cr_unpackDispatch.BlendColorEXT( red, green, blue, alpha );
}

static void crUnpackExtendBlendEquationEXT(void)
{
	GLenum mode = READ_DATA( 8, GLenum );
	cr_unpackDispatch.BlendEquationEXT( mode );
}

static void crUnpackExtendBlendEquationSeparate(void)
{
	GLenum modeRGB = READ_DATA( 8, GLenum );
	GLenum modeAlpha = READ_DATA( 12, GLenum );
	cr_unpackDispatch.BlendEquationSeparate( modeRGB, modeAlpha );
}

static void crUnpackExtendBlendFuncSeparateEXT(void)
{
	GLenum sfactorRGB = READ_DATA( 8, GLenum );
	GLenum dfactorRGB = READ_DATA( 12, GLenum );
	GLenum sfactorA = READ_DATA( 16, GLenum );
	GLenum dfactorA = READ_DATA( 20, GLenum );
	cr_unpackDispatch.BlendFuncSeparateEXT( sfactorRGB, dfactorRGB, sfactorA, dfactorA );
}

static void crUnpackExtendBlitFramebufferEXT(void)
{
	GLint srcX0 = READ_DATA( 8, GLint );
	GLint srcY0 = READ_DATA( 12, GLint );
	GLint srcX1 = READ_DATA( 16, GLint );
	GLint srcY1 = READ_DATA( 20, GLint );
	GLint dstX0 = READ_DATA( 24, GLint );
	GLint dstY0 = READ_DATA( 28, GLint );
	GLint dstX1 = READ_DATA( 32, GLint );
	GLint dstY1 = READ_DATA( 36, GLint );
	GLbitfield mask = READ_DATA( 40, GLbitfield );
	GLenum filter = READ_DATA( 44, GLenum );
	cr_unpackDispatch.BlitFramebufferEXT( srcX0, srcY0, srcX1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter );
}

static void crUnpackExtendCheckFramebufferStatusEXT(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	SET_RETURN_PTR( 12 );
	SET_WRITEBACK_PTR( 20 );
	(void) cr_unpackDispatch.CheckFramebufferStatusEXT( target );
}

static void crUnpackExtendChromiumParameterfCR(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLfloat value = READ_DATA( 12, GLfloat );
	cr_unpackDispatch.ChromiumParameterfCR( target, value );
}

static void crUnpackExtendChromiumParameteriCR(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLint value = READ_DATA( 12, GLint );
	cr_unpackDispatch.ChromiumParameteriCR( target, value );
}

static void crUnpackExtendClearAccum(void)
{
	GLfloat red = READ_DATA( 8, GLfloat );
	GLfloat green = READ_DATA( 12, GLfloat );
	GLfloat blue = READ_DATA( 16, GLfloat );
	GLfloat alpha = READ_DATA( 20, GLfloat );
	cr_unpackDispatch.ClearAccum( red, green, blue, alpha );
}

static void crUnpackExtendClearColor(void)
{
	GLclampf red = READ_DATA( 8, GLclampf );
	GLclampf green = READ_DATA( 12, GLclampf );
	GLclampf blue = READ_DATA( 16, GLclampf );
	GLclampf alpha = READ_DATA( 20, GLclampf );
	cr_unpackDispatch.ClearColor( red, green, blue, alpha );
}

static void crUnpackExtendClearDepth(void)
{
	GLclampd depth = READ_DOUBLE( 8 );
	cr_unpackDispatch.ClearDepth( depth );
}

static void crUnpackExtendClearIndex(void)
{
	GLfloat c = READ_DATA( 8, GLfloat );
	cr_unpackDispatch.ClearIndex( c );
}

static void crUnpackExtendClearStencil(void)
{
	GLint s = READ_DATA( 8, GLint );
	cr_unpackDispatch.ClearStencil( s );
}

static void crUnpackExtendClientActiveTextureARB(void)
{
	GLenum texture = READ_DATA( 8, GLenum );
	cr_unpackDispatch.ClientActiveTextureARB( texture );
}

static void crUnpackExtendCombinerInputNV(void)
{
	GLenum stage = READ_DATA( 8, GLenum );
	GLenum portion = READ_DATA( 12, GLenum );
	GLenum variable = READ_DATA( 16, GLenum );
	GLenum input = READ_DATA( 20, GLenum );
	GLenum mapping = READ_DATA( 24, GLenum );
	GLenum componentUsage = READ_DATA( 28, GLenum );
	cr_unpackDispatch.CombinerInputNV( stage, portion, variable, input, mapping, componentUsage );
}

static void crUnpackExtendCombinerOutputNV(void)
{
	GLenum stage = READ_DATA( 8, GLenum );
	GLenum portion = READ_DATA( 12, GLenum );
	GLenum abOutput = READ_DATA( 16, GLenum );
	GLenum cdOutput = READ_DATA( 20, GLenum );
	GLenum sumOutput = READ_DATA( 24, GLenum );
	GLenum scale = READ_DATA( 28, GLenum );
	GLenum bias = READ_DATA( 32, GLenum );
	GLboolean abDotProduct = READ_DATA( 36, GLboolean );
	GLboolean cdDotProduct = READ_DATA( 37, GLboolean );
	GLboolean muxSum = READ_DATA( 38, GLboolean );
	cr_unpackDispatch.CombinerOutputNV( stage, portion, abOutput, cdOutput, sumOutput, scale, bias, abDotProduct, cdDotProduct, muxSum );
}

static void crUnpackExtendCombinerParameterfNV(void)
{
	GLenum pname = READ_DATA( 8, GLenum );
	GLfloat param = READ_DATA( 12, GLfloat );
	cr_unpackDispatch.CombinerParameterfNV( pname, param );
}

static void crUnpackExtendCombinerParameteriNV(void)
{
	GLenum pname = READ_DATA( 8, GLenum );
	GLint param = READ_DATA( 12, GLint );
	cr_unpackDispatch.CombinerParameteriNV( pname, param );
}

static void crUnpackExtendCompileShader(void)
{
	GLuint shader = READ_DATA( 8, GLuint );
	cr_unpackDispatch.CompileShader( shader );
}

static void crUnpackExtendCreateProgram(void)
{
	SET_RETURN_PTR( 8 );
	SET_WRITEBACK_PTR( 16 );
	(void) cr_unpackDispatch.CreateProgram(  );
}

static void crUnpackExtendCreateShader(void)
{
	GLenum type = READ_DATA( 8, GLenum );
	SET_RETURN_PTR( 12 );
	SET_WRITEBACK_PTR( 20 );
	(void) cr_unpackDispatch.CreateShader( type );
}

static void crUnpackExtendDeleteLists(void)
{
	GLuint list = READ_DATA( 8, GLuint );
	GLsizei range = READ_DATA( 12, GLsizei );
	cr_unpackDispatch.DeleteLists( list, range );
}

static void crUnpackExtendDeleteObjectARB(void)
{
	VBoxGLhandleARB obj = READ_DATA( 8, VBoxGLhandleARB );
	cr_unpackDispatch.DeleteObjectARB( obj );
}

static void crUnpackExtendDeleteProgram(void)
{
	GLuint program = READ_DATA( 8, GLuint );
	cr_unpackDispatch.DeleteProgram( program );
}

static void crUnpackExtendDeleteShader(void)
{
	GLuint shader = READ_DATA( 8, GLuint );
	cr_unpackDispatch.DeleteShader( shader );
}

static void crUnpackExtendDestroyContext(void)
{
	GLint ctx = READ_DATA( 8, GLint );
	cr_unpackDispatch.DestroyContext( ctx );
}

static void crUnpackExtendDetachShader(void)
{
	GLuint program = READ_DATA( 8, GLuint );
	GLuint shader = READ_DATA( 12, GLuint );
	cr_unpackDispatch.DetachShader( program, shader );
}

static void crUnpackExtendDisableVertexAttribArrayARB(void)
{
	GLuint index = READ_DATA( 8, GLuint );
	cr_unpackDispatch.DisableVertexAttribArrayARB( index );
}

static void crUnpackExtendDrawBuffer(void)
{
	GLenum mode = READ_DATA( 8, GLenum );
	cr_unpackDispatch.DrawBuffer( mode );
}

static void crUnpackExtendEnableVertexAttribArrayARB(void)
{
	GLuint index = READ_DATA( 8, GLuint );
	cr_unpackDispatch.EnableVertexAttribArrayARB( index );
}

static void crUnpackExtendEndList(void)
{
	cr_unpackDispatch.EndList(  );
}

static void crUnpackExtendEndQueryARB(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	cr_unpackDispatch.EndQueryARB( target );
}

static void crUnpackExtendFinalCombinerInputNV(void)
{
	GLenum variable = READ_DATA( 8, GLenum );
	GLenum input = READ_DATA( 12, GLenum );
	GLenum mapping = READ_DATA( 16, GLenum );
	GLenum componentUsage = READ_DATA( 20, GLenum );
	cr_unpackDispatch.FinalCombinerInputNV( variable, input, mapping, componentUsage );
}

static void crUnpackExtendFinishFenceNV(void)
{
	GLuint fence = READ_DATA( 8, GLuint );
	cr_unpackDispatch.FinishFenceNV( fence );
}

static void crUnpackExtendFlushVertexArrayRangeNV(void)
{
	cr_unpackDispatch.FlushVertexArrayRangeNV(  );
}

static void crUnpackExtendFramebufferRenderbufferEXT(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLenum attachment = READ_DATA( 12, GLenum );
	GLenum renderbuffertarget = READ_DATA( 16, GLenum );
	GLuint renderbuffer = READ_DATA( 20, GLuint );
	cr_unpackDispatch.FramebufferRenderbufferEXT( target, attachment, renderbuffertarget, renderbuffer );
}

static void crUnpackExtendFramebufferTexture1DEXT(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLenum attachment = READ_DATA( 12, GLenum );
	GLenum textarget = READ_DATA( 16, GLenum );
	GLuint texture = READ_DATA( 20, GLuint );
	GLint level = READ_DATA( 24, GLint );
	cr_unpackDispatch.FramebufferTexture1DEXT( target, attachment, textarget, texture, level );
}

static void crUnpackExtendFramebufferTexture2DEXT(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLenum attachment = READ_DATA( 12, GLenum );
	GLenum textarget = READ_DATA( 16, GLenum );
	GLuint texture = READ_DATA( 20, GLuint );
	GLint level = READ_DATA( 24, GLint );
	cr_unpackDispatch.FramebufferTexture2DEXT( target, attachment, textarget, texture, level );
}

static void crUnpackExtendFramebufferTexture3DEXT(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLenum attachment = READ_DATA( 12, GLenum );
	GLenum textarget = READ_DATA( 16, GLenum );
	GLuint texture = READ_DATA( 20, GLuint );
	GLint level = READ_DATA( 24, GLint );
	GLint zoffset = READ_DATA( 28, GLint );
	cr_unpackDispatch.FramebufferTexture3DEXT( target, attachment, textarget, texture, level, zoffset );
}

static void crUnpackExtendGenBuffersARB(void)
{
	GLsizei n = READ_DATA( 8, GLsizei );
	SET_RETURN_PTR( 12 );
	SET_WRITEBACK_PTR( 20 );
	cr_unpackDispatch.GenBuffersARB( n, NULL );
}

static void crUnpackExtendGenFencesNV(void)
{
	GLsizei n = READ_DATA( 8, GLsizei );
	SET_RETURN_PTR( 12 );
	SET_WRITEBACK_PTR( 20 );
	cr_unpackDispatch.GenFencesNV( n, NULL );
}

static void crUnpackExtendGenFramebuffersEXT(void)
{
	GLsizei n = READ_DATA( 8, GLsizei );
	SET_RETURN_PTR( 12 );
	SET_WRITEBACK_PTR( 20 );
	cr_unpackDispatch.GenFramebuffersEXT( n, NULL );
}

static void crUnpackExtendGenLists(void)
{
	GLsizei range = READ_DATA( 8, GLsizei );
	SET_RETURN_PTR( 12 );
	SET_WRITEBACK_PTR( 20 );
	(void) cr_unpackDispatch.GenLists( range );
}

static void crUnpackExtendGenProgramsARB(void)
{
	GLsizei n = READ_DATA( 8, GLsizei );
	SET_RETURN_PTR( 12 );
	SET_WRITEBACK_PTR( 20 );
	cr_unpackDispatch.GenProgramsARB( n, NULL );
}

static void crUnpackExtendGenProgramsNV(void)
{
	GLsizei n = READ_DATA( 8, GLsizei );
	SET_RETURN_PTR( 12 );
	SET_WRITEBACK_PTR( 20 );
	cr_unpackDispatch.GenProgramsNV( n, NULL );
}

static void crUnpackExtendGenQueriesARB(void)
{
	GLsizei n = READ_DATA( 8, GLsizei );
	SET_RETURN_PTR( 12 );
	SET_WRITEBACK_PTR( 20 );
	cr_unpackDispatch.GenQueriesARB( n, NULL );
}

static void crUnpackExtendGenRenderbuffersEXT(void)
{
	GLsizei n = READ_DATA( 8, GLsizei );
	SET_RETURN_PTR( 12 );
	SET_WRITEBACK_PTR( 20 );
	cr_unpackDispatch.GenRenderbuffersEXT( n, NULL );
}

static void crUnpackExtendGenTextures(void)
{
	GLsizei n = READ_DATA( 8, GLsizei );
	SET_RETURN_PTR( 12 );
	SET_WRITEBACK_PTR( 20 );
	cr_unpackDispatch.GenTextures( n, NULL );
}

static void crUnpackExtendGenerateMipmapEXT(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	cr_unpackDispatch.GenerateMipmapEXT( target );
}

static void crUnpackExtendGetBooleanv(void)
{
	GLenum pname = READ_DATA( 8, GLenum );
	SET_RETURN_PTR( 12 );
	SET_WRITEBACK_PTR( 20 );
	cr_unpackDispatch.GetBooleanv( pname, NULL );
}

static void crUnpackExtendGetBufferParameterivARB(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLenum pname = READ_DATA( 12, GLenum );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetBufferParameterivARB( target, pname, NULL );
}

static void crUnpackExtendGetChromiumParametervCR(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLuint index = READ_DATA( 12, GLuint );
	GLenum type = READ_DATA( 16, GLenum );
	GLsizei count = READ_DATA( 20, GLsizei );
	SET_RETURN_PTR( 24 );
	SET_WRITEBACK_PTR( 32 );
	cr_unpackDispatch.GetChromiumParametervCR( target, index, type, count, NULL );
}

static void crUnpackExtendGetClipPlane(void)
{
	GLenum plane = READ_DATA( 8, GLenum );
	SET_RETURN_PTR( 12 );
	SET_WRITEBACK_PTR( 20 );
	cr_unpackDispatch.GetClipPlane( plane, NULL );
}

static void crUnpackExtendGetCombinerInputParameterfvNV(void)
{
	GLenum stage = READ_DATA( 8, GLenum );
	GLenum portion = READ_DATA( 12, GLenum );
	GLenum variable = READ_DATA( 16, GLenum );
	GLenum pname = READ_DATA( 20, GLenum );
	SET_RETURN_PTR( 24 );
	SET_WRITEBACK_PTR( 32 );
	cr_unpackDispatch.GetCombinerInputParameterfvNV( stage, portion, variable, pname, NULL );
}

static void crUnpackExtendGetCombinerInputParameterivNV(void)
{
	GLenum stage = READ_DATA( 8, GLenum );
	GLenum portion = READ_DATA( 12, GLenum );
	GLenum variable = READ_DATA( 16, GLenum );
	GLenum pname = READ_DATA( 20, GLenum );
	SET_RETURN_PTR( 24 );
	SET_WRITEBACK_PTR( 32 );
	cr_unpackDispatch.GetCombinerInputParameterivNV( stage, portion, variable, pname, NULL );
}

static void crUnpackExtendGetCombinerOutputParameterfvNV(void)
{
	GLenum stage = READ_DATA( 8, GLenum );
	GLenum portion = READ_DATA( 12, GLenum );
	GLenum pname = READ_DATA( 16, GLenum );
	SET_RETURN_PTR( 20 );
	SET_WRITEBACK_PTR( 28 );
	cr_unpackDispatch.GetCombinerOutputParameterfvNV( stage, portion, pname, NULL );
}

static void crUnpackExtendGetCombinerOutputParameterivNV(void)
{
	GLenum stage = READ_DATA( 8, GLenum );
	GLenum portion = READ_DATA( 12, GLenum );
	GLenum pname = READ_DATA( 16, GLenum );
	SET_RETURN_PTR( 20 );
	SET_WRITEBACK_PTR( 28 );
	cr_unpackDispatch.GetCombinerOutputParameterivNV( stage, portion, pname, NULL );
}

static void crUnpackExtendGetCombinerStageParameterfvNV(void)
{
	GLenum stage = READ_DATA( 8, GLenum );
	GLenum pname = READ_DATA( 12, GLenum );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetCombinerStageParameterfvNV( stage, pname, NULL );
}

static void crUnpackExtendGetDoublev(void)
{
	GLenum pname = READ_DATA( 8, GLenum );
	SET_RETURN_PTR( 12 );
	SET_WRITEBACK_PTR( 20 );
	cr_unpackDispatch.GetDoublev( pname, NULL );
}

static void crUnpackExtendGetError(void)
{
	SET_RETURN_PTR( 8 );
	SET_WRITEBACK_PTR( 16 );
	(void) cr_unpackDispatch.GetError(  );
}

static void crUnpackExtendGetFenceivNV(void)
{
	GLuint fence = READ_DATA( 8, GLuint );
	GLenum pname = READ_DATA( 12, GLenum );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetFenceivNV( fence, pname, NULL );
}

static void crUnpackExtendGetFinalCombinerInputParameterfvNV(void)
{
	GLenum variable = READ_DATA( 8, GLenum );
	GLenum pname = READ_DATA( 12, GLenum );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetFinalCombinerInputParameterfvNV( variable, pname, NULL );
}

static void crUnpackExtendGetFinalCombinerInputParameterivNV(void)
{
	GLenum variable = READ_DATA( 8, GLenum );
	GLenum pname = READ_DATA( 12, GLenum );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetFinalCombinerInputParameterivNV( variable, pname, NULL );
}

static void crUnpackExtendGetFloatv(void)
{
	GLenum pname = READ_DATA( 8, GLenum );
	SET_RETURN_PTR( 12 );
	SET_WRITEBACK_PTR( 20 );
	cr_unpackDispatch.GetFloatv( pname, NULL );
}

static void crUnpackExtendGetFramebufferAttachmentParameterivEXT(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLenum attachment = READ_DATA( 12, GLenum );
	GLenum pname = READ_DATA( 16, GLenum );
	SET_RETURN_PTR( 20 );
	SET_WRITEBACK_PTR( 28 );
	cr_unpackDispatch.GetFramebufferAttachmentParameterivEXT( target, attachment, pname, NULL );
}

static void crUnpackExtendGetHandleARB(void)
{
	GLenum pname = READ_DATA( 8, GLenum );
	SET_RETURN_PTR( 12 );
	SET_WRITEBACK_PTR( 20 );
	(void) cr_unpackDispatch.GetHandleARB( pname );
}

static void crUnpackExtendGetIntegerv(void)
{
	GLenum pname = READ_DATA( 8, GLenum );
	SET_RETURN_PTR( 12 );
	SET_WRITEBACK_PTR( 20 );
	cr_unpackDispatch.GetIntegerv( pname, NULL );
}

static void crUnpackExtendGetLightfv(void)
{
	GLenum light = READ_DATA( 8, GLenum );
	GLenum pname = READ_DATA( 12, GLenum );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetLightfv( light, pname, NULL );
}

static void crUnpackExtendGetLightiv(void)
{
	GLenum light = READ_DATA( 8, GLenum );
	GLenum pname = READ_DATA( 12, GLenum );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetLightiv( light, pname, NULL );
}

static void crUnpackExtendGetMapdv(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLenum query = READ_DATA( 12, GLenum );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetMapdv( target, query, NULL );
}

static void crUnpackExtendGetMapfv(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLenum query = READ_DATA( 12, GLenum );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetMapfv( target, query, NULL );
}

static void crUnpackExtendGetMapiv(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLenum query = READ_DATA( 12, GLenum );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetMapiv( target, query, NULL );
}

static void crUnpackExtendGetMaterialfv(void)
{
	GLenum face = READ_DATA( 8, GLenum );
	GLenum pname = READ_DATA( 12, GLenum );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetMaterialfv( face, pname, NULL );
}

static void crUnpackExtendGetMaterialiv(void)
{
	GLenum face = READ_DATA( 8, GLenum );
	GLenum pname = READ_DATA( 12, GLenum );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetMaterialiv( face, pname, NULL );
}

static void crUnpackExtendGetObjectParameterfvARB(void)
{
	VBoxGLhandleARB obj = READ_DATA( 8, VBoxGLhandleARB );
	GLenum pname = READ_DATA( 12, GLenum );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetObjectParameterfvARB( obj, pname, NULL );
}

static void crUnpackExtendGetObjectParameterivARB(void)
{
	VBoxGLhandleARB obj = READ_DATA( 8, VBoxGLhandleARB );
	GLenum pname = READ_DATA( 12, GLenum );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetObjectParameterivARB( obj, pname, NULL );
}

static void crUnpackExtendGetPointerv(void)
{
	GLenum pname = READ_DATA( 8, GLenum );
	SET_RETURN_PTR( 12 );
	SET_WRITEBACK_PTR( 20 );
	cr_unpackDispatch.GetPointerv( pname, NULL );
}

static void crUnpackExtendGetProgramEnvParameterdvARB(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLuint index = READ_DATA( 12, GLuint );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetProgramEnvParameterdvARB( target, index, NULL );
}

static void crUnpackExtendGetProgramEnvParameterfvARB(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLuint index = READ_DATA( 12, GLuint );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetProgramEnvParameterfvARB( target, index, NULL );
}

static void crUnpackExtendGetProgramLocalParameterdvARB(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLuint index = READ_DATA( 12, GLuint );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetProgramLocalParameterdvARB( target, index, NULL );
}

static void crUnpackExtendGetProgramLocalParameterfvARB(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLuint index = READ_DATA( 12, GLuint );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetProgramLocalParameterfvARB( target, index, NULL );
}

static void crUnpackExtendGetProgramParameterdvNV(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLuint index = READ_DATA( 12, GLuint );
	GLenum pname = READ_DATA( 16, GLenum );
	SET_RETURN_PTR( 20 );
	SET_WRITEBACK_PTR( 28 );
	cr_unpackDispatch.GetProgramParameterdvNV( target, index, pname, NULL );
}

static void crUnpackExtendGetProgramParameterfvNV(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLuint index = READ_DATA( 12, GLuint );
	GLenum pname = READ_DATA( 16, GLenum );
	SET_RETURN_PTR( 20 );
	SET_WRITEBACK_PTR( 28 );
	cr_unpackDispatch.GetProgramParameterfvNV( target, index, pname, NULL );
}

static void crUnpackExtendGetProgramStringNV(void)
{
	GLuint id = READ_DATA( 8, GLuint );
	GLenum pname = READ_DATA( 12, GLenum );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetProgramStringNV( id, pname, NULL );
}

static void crUnpackExtendGetProgramiv(void)
{
	GLuint program = READ_DATA( 8, GLuint );
	GLenum pname = READ_DATA( 12, GLenum );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetProgramiv( program, pname, NULL );
}

static void crUnpackExtendGetProgramivARB(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLenum pname = READ_DATA( 12, GLenum );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetProgramivARB( target, pname, NULL );
}

static void crUnpackExtendGetProgramivNV(void)
{
	GLuint id = READ_DATA( 8, GLuint );
	GLenum pname = READ_DATA( 12, GLenum );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetProgramivNV( id, pname, NULL );
}

static void crUnpackExtendGetQueryObjectivARB(void)
{
	GLuint id = READ_DATA( 8, GLuint );
	GLenum pname = READ_DATA( 12, GLenum );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetQueryObjectivARB( id, pname, NULL );
}

static void crUnpackExtendGetQueryObjectuivARB(void)
{
	GLuint id = READ_DATA( 8, GLuint );
	GLenum pname = READ_DATA( 12, GLenum );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetQueryObjectuivARB( id, pname, NULL );
}

static void crUnpackExtendGetQueryivARB(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLenum pname = READ_DATA( 12, GLenum );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetQueryivARB( target, pname, NULL );
}

static void crUnpackExtendGetRenderbufferParameterivEXT(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLenum pname = READ_DATA( 12, GLenum );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetRenderbufferParameterivEXT( target, pname, NULL );
}

static void crUnpackExtendGetShaderiv(void)
{
	GLuint shader = READ_DATA( 8, GLuint );
	GLenum pname = READ_DATA( 12, GLenum );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetShaderiv( shader, pname, NULL );
}

static void crUnpackExtendGetString(void)
{
	GLenum name = READ_DATA( 8, GLenum );
	SET_RETURN_PTR( 12 );
	SET_WRITEBACK_PTR( 20 );
	(void) cr_unpackDispatch.GetString( name );
}

static void crUnpackExtendGetTexEnvfv(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLenum pname = READ_DATA( 12, GLenum );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetTexEnvfv( target, pname, NULL );
}

static void crUnpackExtendGetTexEnviv(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLenum pname = READ_DATA( 12, GLenum );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetTexEnviv( target, pname, NULL );
}

static void crUnpackExtendGetTexGendv(void)
{
	GLenum coord = READ_DATA( 8, GLenum );
	GLenum pname = READ_DATA( 12, GLenum );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetTexGendv( coord, pname, NULL );
}

static void crUnpackExtendGetTexGenfv(void)
{
	GLenum coord = READ_DATA( 8, GLenum );
	GLenum pname = READ_DATA( 12, GLenum );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetTexGenfv( coord, pname, NULL );
}

static void crUnpackExtendGetTexGeniv(void)
{
	GLenum coord = READ_DATA( 8, GLenum );
	GLenum pname = READ_DATA( 12, GLenum );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetTexGeniv( coord, pname, NULL );
}

static void crUnpackExtendGetTexLevelParameterfv(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLint level = READ_DATA( 12, GLint );
	GLenum pname = READ_DATA( 16, GLenum );
	SET_RETURN_PTR( 20 );
	SET_WRITEBACK_PTR( 28 );
	cr_unpackDispatch.GetTexLevelParameterfv( target, level, pname, NULL );
}

static void crUnpackExtendGetTexLevelParameteriv(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLint level = READ_DATA( 12, GLint );
	GLenum pname = READ_DATA( 16, GLenum );
	SET_RETURN_PTR( 20 );
	SET_WRITEBACK_PTR( 28 );
	cr_unpackDispatch.GetTexLevelParameteriv( target, level, pname, NULL );
}

static void crUnpackExtendGetTexParameterfv(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLenum pname = READ_DATA( 12, GLenum );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetTexParameterfv( target, pname, NULL );
}

static void crUnpackExtendGetTexParameteriv(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLenum pname = READ_DATA( 12, GLenum );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetTexParameteriv( target, pname, NULL );
}

static void crUnpackExtendGetTrackMatrixivNV(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLuint address = READ_DATA( 12, GLuint );
	GLenum pname = READ_DATA( 16, GLenum );
	SET_RETURN_PTR( 20 );
	SET_WRITEBACK_PTR( 28 );
	cr_unpackDispatch.GetTrackMatrixivNV( target, address, pname, NULL );
}

static void crUnpackExtendGetUniformfv(void)
{
	GLuint program = READ_DATA( 8, GLuint );
	GLint location = READ_DATA( 12, GLint );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetUniformfv( program, location, NULL );
}

static void crUnpackExtendGetUniformiv(void)
{
	GLuint program = READ_DATA( 8, GLuint );
	GLint location = READ_DATA( 12, GLint );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetUniformiv( program, location, NULL );
}

static void crUnpackExtendGetVertexAttribPointervARB(void)
{
	GLuint index = READ_DATA( 8, GLuint );
	GLenum pname = READ_DATA( 12, GLenum );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetVertexAttribPointervARB( index, pname, NULL );
}

static void crUnpackExtendGetVertexAttribPointervNV(void)
{
	GLuint index = READ_DATA( 8, GLuint );
	GLenum pname = READ_DATA( 12, GLenum );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetVertexAttribPointervNV( index, pname, NULL );
}

static void crUnpackExtendGetVertexAttribdvARB(void)
{
	GLuint index = READ_DATA( 8, GLuint );
	GLenum pname = READ_DATA( 12, GLenum );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetVertexAttribdvARB( index, pname, NULL );
}

static void crUnpackExtendGetVertexAttribdvNV(void)
{
	GLuint index = READ_DATA( 8, GLuint );
	GLenum pname = READ_DATA( 12, GLenum );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetVertexAttribdvNV( index, pname, NULL );
}

static void crUnpackExtendGetVertexAttribfvARB(void)
{
	GLuint index = READ_DATA( 8, GLuint );
	GLenum pname = READ_DATA( 12, GLenum );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetVertexAttribfvARB( index, pname, NULL );
}

static void crUnpackExtendGetVertexAttribfvNV(void)
{
	GLuint index = READ_DATA( 8, GLuint );
	GLenum pname = READ_DATA( 12, GLenum );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetVertexAttribfvNV( index, pname, NULL );
}

static void crUnpackExtendGetVertexAttribivARB(void)
{
	GLuint index = READ_DATA( 8, GLuint );
	GLenum pname = READ_DATA( 12, GLenum );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetVertexAttribivARB( index, pname, NULL );
}

static void crUnpackExtendGetVertexAttribivNV(void)
{
	GLuint index = READ_DATA( 8, GLuint );
	GLenum pname = READ_DATA( 12, GLenum );
	SET_RETURN_PTR( 16 );
	SET_WRITEBACK_PTR( 24 );
	cr_unpackDispatch.GetVertexAttribivNV( index, pname, NULL );
}

static void crUnpackExtendHint(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLenum mode = READ_DATA( 12, GLenum );
	cr_unpackDispatch.Hint( target, mode );
}

static void crUnpackExtendIsBufferARB(void)
{
	GLuint buffer = READ_DATA( 8, GLuint );
	SET_RETURN_PTR( 12 );
	SET_WRITEBACK_PTR( 20 );
	(void) cr_unpackDispatch.IsBufferARB( buffer );
}

static void crUnpackExtendIsEnabled(void)
{
	GLenum cap = READ_DATA( 8, GLenum );
	SET_RETURN_PTR( 12 );
	SET_WRITEBACK_PTR( 20 );
	(void) cr_unpackDispatch.IsEnabled( cap );
}

static void crUnpackExtendIsFenceNV(void)
{
	GLuint fence = READ_DATA( 8, GLuint );
	SET_RETURN_PTR( 12 );
	SET_WRITEBACK_PTR( 20 );
	(void) cr_unpackDispatch.IsFenceNV( fence );
}

static void crUnpackExtendIsFramebufferEXT(void)
{
	GLuint framebuffer = READ_DATA( 8, GLuint );
	SET_RETURN_PTR( 12 );
	SET_WRITEBACK_PTR( 20 );
	(void) cr_unpackDispatch.IsFramebufferEXT( framebuffer );
}

static void crUnpackExtendIsList(void)
{
	GLuint list = READ_DATA( 8, GLuint );
	SET_RETURN_PTR( 12 );
	SET_WRITEBACK_PTR( 20 );
	(void) cr_unpackDispatch.IsList( list );
}

static void crUnpackExtendIsProgram(void)
{
	GLuint program = READ_DATA( 8, GLuint );
	SET_RETURN_PTR( 12 );
	SET_WRITEBACK_PTR( 20 );
	(void) cr_unpackDispatch.IsProgram( program );
}

static void crUnpackExtendIsProgramARB(void)
{
	GLuint program = READ_DATA( 8, GLuint );
	SET_RETURN_PTR( 12 );
	SET_WRITEBACK_PTR( 20 );
	(void) cr_unpackDispatch.IsProgramARB( program );
}

static void crUnpackExtendIsQueryARB(void)
{
	GLuint id = READ_DATA( 8, GLuint );
	SET_RETURN_PTR( 12 );
	SET_WRITEBACK_PTR( 20 );
	(void) cr_unpackDispatch.IsQueryARB( id );
}

static void crUnpackExtendIsRenderbufferEXT(void)
{
	GLuint renderbuffer = READ_DATA( 8, GLuint );
	SET_RETURN_PTR( 12 );
	SET_WRITEBACK_PTR( 20 );
	(void) cr_unpackDispatch.IsRenderbufferEXT( renderbuffer );
}

static void crUnpackExtendIsShader(void)
{
	GLuint shader = READ_DATA( 8, GLuint );
	SET_RETURN_PTR( 12 );
	SET_WRITEBACK_PTR( 20 );
	(void) cr_unpackDispatch.IsShader( shader );
}

static void crUnpackExtendIsTexture(void)
{
	GLuint texture = READ_DATA( 8, GLuint );
	SET_RETURN_PTR( 12 );
	SET_WRITEBACK_PTR( 20 );
	(void) cr_unpackDispatch.IsTexture( texture );
}

static void crUnpackExtendLinkProgram(void)
{
	GLuint program = READ_DATA( 8, GLuint );
	cr_unpackDispatch.LinkProgram( program );
}

static void crUnpackExtendListBase(void)
{
	GLuint base = READ_DATA( 8, GLuint );
	cr_unpackDispatch.ListBase( base );
}

static void crUnpackExtendLogicOp(void)
{
	GLenum opcode = READ_DATA( 8, GLenum );
	cr_unpackDispatch.LogicOp( opcode );
}

static void crUnpackExtendMakeCurrent(void)
{
	GLint window = READ_DATA( 8, GLint );
	GLint nativeWindow = READ_DATA( 12, GLint );
	GLint ctx = READ_DATA( 16, GLint );
	cr_unpackDispatch.MakeCurrent( window, nativeWindow, ctx );
}

static void crUnpackExtendNewList(void)
{
	GLuint list = READ_DATA( 8, GLuint );
	GLenum mode = READ_DATA( 12, GLenum );
	cr_unpackDispatch.NewList( list, mode );
}

static void crUnpackExtendPointParameterfARB(void)
{
	GLenum pname = READ_DATA( 8, GLenum );
	GLfloat param = READ_DATA( 12, GLfloat );
	cr_unpackDispatch.PointParameterfARB( pname, param );
}

static void crUnpackExtendPointParameteri(void)
{
	GLenum pname = READ_DATA( 8, GLenum );
	GLint param = READ_DATA( 12, GLint );
	cr_unpackDispatch.PointParameteri( pname, param );
}

static void crUnpackExtendPopAttrib(void)
{
	cr_unpackDispatch.PopAttrib(  );
}

static void crUnpackExtendPopClientAttrib(void)
{
	cr_unpackDispatch.PopClientAttrib(  );
}

static void crUnpackExtendProgramEnvParameter4dARB(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLuint index = READ_DATA( 12, GLuint );
	GLdouble x = READ_DOUBLE( 16 );
	GLdouble y = READ_DOUBLE( 24 );
	GLdouble z = READ_DOUBLE( 32 );
	GLdouble w = READ_DOUBLE( 40 );
	cr_unpackDispatch.ProgramEnvParameter4dARB( target, index, x, y, z, w );
}

static void crUnpackExtendProgramEnvParameter4fARB(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLuint index = READ_DATA( 12, GLuint );
	GLfloat x = READ_DATA( 16, GLfloat );
	GLfloat y = READ_DATA( 20, GLfloat );
	GLfloat z = READ_DATA( 24, GLfloat );
	GLfloat w = READ_DATA( 28, GLfloat );
	cr_unpackDispatch.ProgramEnvParameter4fARB( target, index, x, y, z, w );
}

static void crUnpackExtendProgramLocalParameter4dARB(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLuint index = READ_DATA( 12, GLuint );
	GLdouble x = READ_DOUBLE( 16 );
	GLdouble y = READ_DOUBLE( 24 );
	GLdouble z = READ_DOUBLE( 32 );
	GLdouble w = READ_DOUBLE( 40 );
	cr_unpackDispatch.ProgramLocalParameter4dARB( target, index, x, y, z, w );
}

static void crUnpackExtendProgramLocalParameter4fARB(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLuint index = READ_DATA( 12, GLuint );
	GLfloat x = READ_DATA( 16, GLfloat );
	GLfloat y = READ_DATA( 20, GLfloat );
	GLfloat z = READ_DATA( 24, GLfloat );
	GLfloat w = READ_DATA( 28, GLfloat );
	cr_unpackDispatch.ProgramLocalParameter4fARB( target, index, x, y, z, w );
}

static void crUnpackExtendProgramParameter4dNV(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLuint index = READ_DATA( 12, GLuint );
	GLdouble x = READ_DOUBLE( 16 );
	GLdouble y = READ_DOUBLE( 24 );
	GLdouble z = READ_DOUBLE( 32 );
	GLdouble w = READ_DOUBLE( 40 );
	cr_unpackDispatch.ProgramParameter4dNV( target, index, x, y, z, w );
}

static void crUnpackExtendProgramParameter4fNV(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLuint index = READ_DATA( 12, GLuint );
	GLfloat x = READ_DATA( 16, GLfloat );
	GLfloat y = READ_DATA( 20, GLfloat );
	GLfloat z = READ_DATA( 24, GLfloat );
	GLfloat w = READ_DATA( 28, GLfloat );
	cr_unpackDispatch.ProgramParameter4fNV( target, index, x, y, z, w );
}

static void crUnpackExtendPushAttrib(void)
{
	GLbitfield mask = READ_DATA( 8, GLbitfield );
	cr_unpackDispatch.PushAttrib( mask );
}

static void crUnpackExtendPushClientAttrib(void)
{
	GLbitfield mask = READ_DATA( 8, GLbitfield );
	cr_unpackDispatch.PushClientAttrib( mask );
}

static void crUnpackExtendReadBuffer(void)
{
	GLenum mode = READ_DATA( 8, GLenum );
	cr_unpackDispatch.ReadBuffer( mode );
}

static void crUnpackExtendRenderMode(void)
{
	GLenum mode = READ_DATA( 8, GLenum );
	SET_RETURN_PTR( 12 );
	SET_WRITEBACK_PTR( 20 );
	(void) cr_unpackDispatch.RenderMode( mode );
}

static void crUnpackExtendRenderbufferStorageEXT(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLenum internalformat = READ_DATA( 12, GLenum );
	GLsizei width = READ_DATA( 16, GLsizei );
	GLsizei height = READ_DATA( 20, GLsizei );
	cr_unpackDispatch.RenderbufferStorageEXT( target, internalformat, width, height );
}

static void crUnpackExtendSampleCoverageARB(void)
{
	GLclampf value = READ_DATA( 8, GLclampf );
	GLboolean invert = READ_DATA( 12, GLboolean );
	cr_unpackDispatch.SampleCoverageARB( value, invert );
}

static void crUnpackExtendSemaphoreCreateCR(void)
{
	GLuint name = READ_DATA( 8, GLuint );
	GLuint count = READ_DATA( 12, GLuint );
	cr_unpackDispatch.SemaphoreCreateCR( name, count );
}

static void crUnpackExtendSemaphoreDestroyCR(void)
{
	GLuint name = READ_DATA( 8, GLuint );
	cr_unpackDispatch.SemaphoreDestroyCR( name );
}

static void crUnpackExtendSemaphorePCR(void)
{
	GLuint name = READ_DATA( 8, GLuint );
	cr_unpackDispatch.SemaphorePCR( name );
}

static void crUnpackExtendSemaphoreVCR(void)
{
	GLuint name = READ_DATA( 8, GLuint );
	cr_unpackDispatch.SemaphoreVCR( name );
}

static void crUnpackExtendSetFenceNV(void)
{
	GLuint fence = READ_DATA( 8, GLuint );
	GLenum condition = READ_DATA( 12, GLenum );
	cr_unpackDispatch.SetFenceNV( fence, condition );
}

static void crUnpackExtendStencilFuncSeparate(void)
{
	GLenum frontfunc = READ_DATA( 8, GLenum );
	GLenum backfunc = READ_DATA( 12, GLenum );
	GLint ref = READ_DATA( 16, GLint );
	GLuint mask = READ_DATA( 20, GLuint );
	cr_unpackDispatch.StencilFuncSeparate( frontfunc, backfunc, ref, mask );
}

static void crUnpackExtendStencilMaskSeparate(void)
{
	GLenum face = READ_DATA( 8, GLenum );
	GLuint mask = READ_DATA( 12, GLuint );
	cr_unpackDispatch.StencilMaskSeparate( face, mask );
}

static void crUnpackExtendStencilOpSeparate(void)
{
	GLenum face = READ_DATA( 8, GLenum );
	GLenum fail = READ_DATA( 12, GLenum );
	GLenum zfail = READ_DATA( 16, GLenum );
	GLenum zpass = READ_DATA( 20, GLenum );
	cr_unpackDispatch.StencilOpSeparate( face, fail, zfail, zpass );
}

static void crUnpackExtendSwapBuffers(void)
{
	GLint window = READ_DATA( 8, GLint );
	GLint flags = READ_DATA( 12, GLint );
	cr_unpackDispatch.SwapBuffers( window, flags );
}

static void crUnpackExtendTestFenceNV(void)
{
	GLuint fence = READ_DATA( 8, GLuint );
	SET_RETURN_PTR( 12 );
	SET_WRITEBACK_PTR( 20 );
	(void) cr_unpackDispatch.TestFenceNV( fence );
}

static void crUnpackExtendTrackMatrixNV(void)
{
	GLenum target = READ_DATA( 8, GLenum );
	GLuint address = READ_DATA( 12, GLuint );
	GLenum matrix = READ_DATA( 16, GLenum );
	GLenum transform = READ_DATA( 20, GLenum );
	cr_unpackDispatch.TrackMatrixNV( target, address, matrix, transform );
}

static void crUnpackExtendUniform1f(void)
{
	GLint location = READ_DATA( 8, GLint );
	GLfloat v0 = READ_DATA( 12, GLfloat );
	cr_unpackDispatch.Uniform1f( location, v0 );
}

static void crUnpackExtendUniform1i(void)
{
	GLint location = READ_DATA( 8, GLint );
	GLint v0 = READ_DATA( 12, GLint );
	cr_unpackDispatch.Uniform1i( location, v0 );
}

static void crUnpackExtendUniform2f(void)
{
	GLint location = READ_DATA( 8, GLint );
	GLfloat v0 = READ_DATA( 12, GLfloat );
	GLfloat v1 = READ_DATA( 16, GLfloat );
	cr_unpackDispatch.Uniform2f( location, v0, v1 );
}

static void crUnpackExtendUniform2i(void)
{
	GLint location = READ_DATA( 8, GLint );
	GLint v0 = READ_DATA( 12, GLint );
	GLint v1 = READ_DATA( 16, GLint );
	cr_unpackDispatch.Uniform2i( location, v0, v1 );
}

static void crUnpackExtendUniform3f(void)
{
	GLint location = READ_DATA( 8, GLint );
	GLfloat v0 = READ_DATA( 12, GLfloat );
	GLfloat v1 = READ_DATA( 16, GLfloat );
	GLfloat v2 = READ_DATA( 20, GLfloat );
	cr_unpackDispatch.Uniform3f( location, v0, v1, v2 );
}

static void crUnpackExtendUniform3i(void)
{
	GLint location = READ_DATA( 8, GLint );
	GLint v0 = READ_DATA( 12, GLint );
	GLint v1 = READ_DATA( 16, GLint );
	GLint v2 = READ_DATA( 20, GLint );
	cr_unpackDispatch.Uniform3i( location, v0, v1, v2 );
}

static void crUnpackExtendUniform4f(void)
{
	GLint location = READ_DATA( 8, GLint );
	GLfloat v0 = READ_DATA( 12, GLfloat );
	GLfloat v1 = READ_DATA( 16, GLfloat );
	GLfloat v2 = READ_DATA( 20, GLfloat );
	GLfloat v3 = READ_DATA( 24, GLfloat );
	cr_unpackDispatch.Uniform4f( location, v0, v1, v2, v3 );
}

static void crUnpackExtendUniform4i(void)
{
	GLint location = READ_DATA( 8, GLint );
	GLint v0 = READ_DATA( 12, GLint );
	GLint v1 = READ_DATA( 16, GLint );
	GLint v2 = READ_DATA( 20, GLint );
	GLint v3 = READ_DATA( 24, GLint );
	cr_unpackDispatch.Uniform4i( location, v0, v1, v2, v3 );
}

static void crUnpackExtendUseProgram(void)
{
	GLuint program = READ_DATA( 8, GLuint );
	cr_unpackDispatch.UseProgram( program );
}

static void crUnpackExtendValidateProgram(void)
{
	GLuint program = READ_DATA( 8, GLuint );
	cr_unpackDispatch.ValidateProgram( program );
}

static void crUnpackExtendVertexArrayRangeNV(void)
{
	GLsizei length = READ_DATA( 8, GLsizei );
	crError( "VertexArrayRangeNV needs to be special cased!" );
	cr_unpackDispatch.VertexArrayRangeNV( length, NULL );
}

static void crUnpackExtendWindowDestroy(void)
{
	GLint window = READ_DATA( 8, GLint );
	cr_unpackDispatch.WindowDestroy( window );
}

static void crUnpackExtendWindowPos2dARB(void)
{
	GLdouble x = READ_DOUBLE( 8 );
	GLdouble y = READ_DOUBLE( 16 );
	cr_unpackDispatch.WindowPos2dARB( x, y );
}

static void crUnpackExtendWindowPos2dvARB(void)
{
	crError( "WindowPos2dvARB needs to be special cased!" );
	cr_unpackDispatch.WindowPos2dvARB( NULL );
}

static void crUnpackExtendWindowPos2fARB(void)
{
	GLfloat x = READ_DATA( 8, GLfloat );
	GLfloat y = READ_DATA( 12, GLfloat );
	cr_unpackDispatch.WindowPos2fARB( x, y );
}

static void crUnpackExtendWindowPos2fvARB(void)
{
	crError( "WindowPos2fvARB needs to be special cased!" );
	cr_unpackDispatch.WindowPos2fvARB( NULL );
}

static void crUnpackExtendWindowPos2iARB(void)
{
	GLint x = READ_DATA( 8, GLint );
	GLint y = READ_DATA( 12, GLint );
	cr_unpackDispatch.WindowPos2iARB( x, y );
}

static void crUnpackExtendWindowPos2ivARB(void)
{
	crError( "WindowPos2ivARB needs to be special cased!" );
	cr_unpackDispatch.WindowPos2ivARB( NULL );
}

static void crUnpackExtendWindowPos2sARB(void)
{
	GLshort x = READ_DATA( 8, GLshort );
	GLshort y = READ_DATA( 10, GLshort );
	cr_unpackDispatch.WindowPos2sARB( x, y );
}

static void crUnpackExtendWindowPos2svARB(void)
{
	crError( "WindowPos2svARB needs to be special cased!" );
	cr_unpackDispatch.WindowPos2svARB( NULL );
}

static void crUnpackExtendWindowPos3dARB(void)
{
	GLdouble x = READ_DOUBLE( 8 );
	GLdouble y = READ_DOUBLE( 16 );
	GLdouble z = READ_DOUBLE( 24 );
	cr_unpackDispatch.WindowPos3dARB( x, y, z );
}

static void crUnpackExtendWindowPos3dvARB(void)
{
	crError( "WindowPos3dvARB needs to be special cased!" );
	cr_unpackDispatch.WindowPos3dvARB( NULL );
}

static void crUnpackExtendWindowPos3fARB(void)
{
	GLfloat x = READ_DATA( 8, GLfloat );
	GLfloat y = READ_DATA( 12, GLfloat );
	GLfloat z = READ_DATA( 16, GLfloat );
	cr_unpackDispatch.WindowPos3fARB( x, y, z );
}

static void crUnpackExtendWindowPos3fvARB(void)
{
	crError( "WindowPos3fvARB needs to be special cased!" );
	cr_unpackDispatch.WindowPos3fvARB( NULL );
}

static void crUnpackExtendWindowPos3iARB(void)
{
	GLint x = READ_DATA( 8, GLint );
	GLint y = READ_DATA( 12, GLint );
	GLint z = READ_DATA( 16, GLint );
	cr_unpackDispatch.WindowPos3iARB( x, y, z );
}

static void crUnpackExtendWindowPos3ivARB(void)
{
	crError( "WindowPos3ivARB needs to be special cased!" );
	cr_unpackDispatch.WindowPos3ivARB( NULL );
}

static void crUnpackExtendWindowPos3sARB(void)
{
	GLshort x = READ_DATA( 8, GLshort );
	GLshort y = READ_DATA( 10, GLshort );
	GLshort z = READ_DATA( 12, GLshort );
	cr_unpackDispatch.WindowPos3sARB( x, y, z );
}

static void crUnpackExtendWindowPos3svARB(void)
{
	crError( "WindowPos3svARB needs to be special cased!" );
	cr_unpackDispatch.WindowPos3svARB( NULL );
}

static void crUnpackExtendWindowPosition(void)
{
	GLint window = READ_DATA( 8, GLint );
	GLint x = READ_DATA( 12, GLint );
	GLint y = READ_DATA( 16, GLint );
	cr_unpackDispatch.WindowPosition( window, x, y );
}

static void crUnpackExtendWindowShow(void)
{
	GLint window = READ_DATA( 8, GLint );
	GLint flag = READ_DATA( 12, GLint );
	cr_unpackDispatch.WindowShow( window, flag );
}

static void crUnpackExtendWindowSize(void)
{
	GLint window = READ_DATA( 8, GLint );
	GLint w = READ_DATA( 12, GLint );
	GLint h = READ_DATA( 16, GLint );
	cr_unpackDispatch.WindowSize( window, w, h );
}

static void crUnpackExtend(void)
{
	GLenum extend_opcode = READ_DATA( 4, GLenum );

	/*crDebug("Unpacking extended opcode \%d", extend_opcode);*/
	switch( extend_opcode )
	{
		case CR_ACCUM_EXTEND_OPCODE:
			crUnpackExtendAccum( );
			break;
		case CR_ACTIVESTENCILFACEEXT_EXTEND_OPCODE:
			crUnpackExtendActiveStencilFaceEXT( );
			break;
		case CR_ACTIVETEXTUREARB_EXTEND_OPCODE:
			crUnpackExtendActiveTextureARB( );
			break;
		case CR_AREPROGRAMSRESIDENTNV_EXTEND_OPCODE:
			crUnpackExtendAreProgramsResidentNV( );
			break;
		case CR_ARETEXTURESRESIDENT_EXTEND_OPCODE:
			crUnpackExtendAreTexturesResident( );
			break;
		case CR_ATTACHSHADER_EXTEND_OPCODE:
			crUnpackExtendAttachShader( );
			break;
		case CR_BARRIERCREATECR_EXTEND_OPCODE:
			crUnpackExtendBarrierCreateCR( );
			break;
		case CR_BARRIERDESTROYCR_EXTEND_OPCODE:
			crUnpackExtendBarrierDestroyCR( );
			break;
		case CR_BARRIEREXECCR_EXTEND_OPCODE:
			crUnpackExtendBarrierExecCR( );
			break;
		case CR_BEGINQUERYARB_EXTEND_OPCODE:
			crUnpackExtendBeginQueryARB( );
			break;
		case CR_BINDATTRIBLOCATION_EXTEND_OPCODE:
			crUnpackExtendBindAttribLocation( );
			break;
		case CR_BINDBUFFERARB_EXTEND_OPCODE:
			crUnpackExtendBindBufferARB( );
			break;
		case CR_BINDFRAMEBUFFEREXT_EXTEND_OPCODE:
			crUnpackExtendBindFramebufferEXT( );
			break;
		case CR_BINDPROGRAMARB_EXTEND_OPCODE:
			crUnpackExtendBindProgramARB( );
			break;
		case CR_BINDPROGRAMNV_EXTEND_OPCODE:
			crUnpackExtendBindProgramNV( );
			break;
		case CR_BINDRENDERBUFFEREXT_EXTEND_OPCODE:
			crUnpackExtendBindRenderbufferEXT( );
			break;
		case CR_BLENDCOLOREXT_EXTEND_OPCODE:
			crUnpackExtendBlendColorEXT( );
			break;
		case CR_BLENDEQUATIONEXT_EXTEND_OPCODE:
			crUnpackExtendBlendEquationEXT( );
			break;
		case CR_BLENDEQUATIONSEPARATE_EXTEND_OPCODE:
			crUnpackExtendBlendEquationSeparate( );
			break;
		case CR_BLENDFUNCSEPARATEEXT_EXTEND_OPCODE:
			crUnpackExtendBlendFuncSeparateEXT( );
			break;
		case CR_BLITFRAMEBUFFEREXT_EXTEND_OPCODE:
			crUnpackExtendBlitFramebufferEXT( );
			break;
		case CR_BUFFERDATAARB_EXTEND_OPCODE:
			crUnpackExtendBufferDataARB( );
			break;
		case CR_BUFFERSUBDATAARB_EXTEND_OPCODE:
			crUnpackExtendBufferSubDataARB( );
			break;
		case CR_CHECKFRAMEBUFFERSTATUSEXT_EXTEND_OPCODE:
			crUnpackExtendCheckFramebufferStatusEXT( );
			break;
		case CR_CHROMIUMPARAMETERFCR_EXTEND_OPCODE:
			crUnpackExtendChromiumParameterfCR( );
			break;
		case CR_CHROMIUMPARAMETERICR_EXTEND_OPCODE:
			crUnpackExtendChromiumParameteriCR( );
			break;
		case CR_CHROMIUMPARAMETERVCR_EXTEND_OPCODE:
			crUnpackExtendChromiumParametervCR( );
			break;
		case CR_CLEARACCUM_EXTEND_OPCODE:
			crUnpackExtendClearAccum( );
			break;
		case CR_CLEARCOLOR_EXTEND_OPCODE:
			crUnpackExtendClearColor( );
			break;
		case CR_CLEARDEPTH_EXTEND_OPCODE:
			crUnpackExtendClearDepth( );
			break;
		case CR_CLEARINDEX_EXTEND_OPCODE:
			crUnpackExtendClearIndex( );
			break;
		case CR_CLEARSTENCIL_EXTEND_OPCODE:
			crUnpackExtendClearStencil( );
			break;
		case CR_CLIENTACTIVETEXTUREARB_EXTEND_OPCODE:
			crUnpackExtendClientActiveTextureARB( );
			break;
		case CR_COLORPOINTER_EXTEND_OPCODE:
			crUnpackExtendColorPointer( );
			break;
		case CR_COMBINERINPUTNV_EXTEND_OPCODE:
			crUnpackExtendCombinerInputNV( );
			break;
		case CR_COMBINEROUTPUTNV_EXTEND_OPCODE:
			crUnpackExtendCombinerOutputNV( );
			break;
		case CR_COMBINERPARAMETERFNV_EXTEND_OPCODE:
			crUnpackExtendCombinerParameterfNV( );
			break;
		case CR_COMBINERPARAMETERFVNV_EXTEND_OPCODE:
			crUnpackExtendCombinerParameterfvNV( );
			break;
		case CR_COMBINERPARAMETERINV_EXTEND_OPCODE:
			crUnpackExtendCombinerParameteriNV( );
			break;
		case CR_COMBINERPARAMETERIVNV_EXTEND_OPCODE:
			crUnpackExtendCombinerParameterivNV( );
			break;
		case CR_COMBINERSTAGEPARAMETERFVNV_EXTEND_OPCODE:
			crUnpackExtendCombinerStageParameterfvNV( );
			break;
		case CR_COMPILESHADER_EXTEND_OPCODE:
			crUnpackExtendCompileShader( );
			break;
		case CR_COMPRESSEDTEXIMAGE1DARB_EXTEND_OPCODE:
			crUnpackExtendCompressedTexImage1DARB( );
			break;
		case CR_COMPRESSEDTEXIMAGE2DARB_EXTEND_OPCODE:
			crUnpackExtendCompressedTexImage2DARB( );
			break;
		case CR_COMPRESSEDTEXIMAGE3DARB_EXTEND_OPCODE:
			crUnpackExtendCompressedTexImage3DARB( );
			break;
		case CR_COMPRESSEDTEXSUBIMAGE1DARB_EXTEND_OPCODE:
			crUnpackExtendCompressedTexSubImage1DARB( );
			break;
		case CR_COMPRESSEDTEXSUBIMAGE2DARB_EXTEND_OPCODE:
			crUnpackExtendCompressedTexSubImage2DARB( );
			break;
		case CR_COMPRESSEDTEXSUBIMAGE3DARB_EXTEND_OPCODE:
			crUnpackExtendCompressedTexSubImage3DARB( );
			break;
		case CR_CREATECONTEXT_EXTEND_OPCODE:
			crUnpackExtendCreateContext( );
			break;
		case CR_CREATEPROGRAM_EXTEND_OPCODE:
			crUnpackExtendCreateProgram( );
			break;
		case CR_CREATESHADER_EXTEND_OPCODE:
			crUnpackExtendCreateShader( );
			break;
		case CR_DELETEBUFFERSARB_EXTEND_OPCODE:
			crUnpackExtendDeleteBuffersARB( );
			break;
		case CR_DELETEFENCESNV_EXTEND_OPCODE:
			crUnpackExtendDeleteFencesNV( );
			break;
		case CR_DELETEFRAMEBUFFERSEXT_EXTEND_OPCODE:
			crUnpackExtendDeleteFramebuffersEXT( );
			break;
		case CR_DELETELISTS_EXTEND_OPCODE:
			crUnpackExtendDeleteLists( );
			break;
		case CR_DELETEOBJECTARB_EXTEND_OPCODE:
			crUnpackExtendDeleteObjectARB( );
			break;
		case CR_DELETEPROGRAM_EXTEND_OPCODE:
			crUnpackExtendDeleteProgram( );
			break;
		case CR_DELETEPROGRAMSARB_EXTEND_OPCODE:
			crUnpackExtendDeleteProgramsARB( );
			break;
		case CR_DELETEQUERIESARB_EXTEND_OPCODE:
			crUnpackExtendDeleteQueriesARB( );
			break;
		case CR_DELETERENDERBUFFERSEXT_EXTEND_OPCODE:
			crUnpackExtendDeleteRenderbuffersEXT( );
			break;
		case CR_DELETESHADER_EXTEND_OPCODE:
			crUnpackExtendDeleteShader( );
			break;
		case CR_DESTROYCONTEXT_EXTEND_OPCODE:
			crUnpackExtendDestroyContext( );
			break;
		case CR_DETACHSHADER_EXTEND_OPCODE:
			crUnpackExtendDetachShader( );
			break;
		case CR_DISABLEVERTEXATTRIBARRAYARB_EXTEND_OPCODE:
			crUnpackExtendDisableVertexAttribArrayARB( );
			break;
		case CR_DRAWBUFFER_EXTEND_OPCODE:
			crUnpackExtendDrawBuffer( );
			break;
		case CR_DRAWBUFFERS_EXTEND_OPCODE:
			crUnpackExtendDrawBuffers( );
			break;
		case CR_DRAWELEMENTS_EXTEND_OPCODE:
			crUnpackExtendDrawElements( );
			break;
		case CR_DRAWRANGEELEMENTS_EXTEND_OPCODE:
			crUnpackExtendDrawRangeElements( );
			break;
		case CR_EDGEFLAGPOINTER_EXTEND_OPCODE:
			crUnpackExtendEdgeFlagPointer( );
			break;
		case CR_ENABLEVERTEXATTRIBARRAYARB_EXTEND_OPCODE:
			crUnpackExtendEnableVertexAttribArrayARB( );
			break;
		case CR_ENDLIST_EXTEND_OPCODE:
			crUnpackExtendEndList( );
			break;
		case CR_ENDQUERYARB_EXTEND_OPCODE:
			crUnpackExtendEndQueryARB( );
			break;
		case CR_EXECUTEPROGRAMNV_EXTEND_OPCODE:
			crUnpackExtendExecuteProgramNV( );
			break;
		case CR_FINALCOMBINERINPUTNV_EXTEND_OPCODE:
			crUnpackExtendFinalCombinerInputNV( );
			break;
		case CR_FINISHFENCENV_EXTEND_OPCODE:
			crUnpackExtendFinishFenceNV( );
			break;
		case CR_FLUSHVERTEXARRAYRANGENV_EXTEND_OPCODE:
			crUnpackExtendFlushVertexArrayRangeNV( );
			break;
		case CR_FOGCOORDPOINTEREXT_EXTEND_OPCODE:
			crUnpackExtendFogCoordPointerEXT( );
			break;
		case CR_FRAMEBUFFERRENDERBUFFEREXT_EXTEND_OPCODE:
			crUnpackExtendFramebufferRenderbufferEXT( );
			break;
		case CR_FRAMEBUFFERTEXTURE1DEXT_EXTEND_OPCODE:
			crUnpackExtendFramebufferTexture1DEXT( );
			break;
		case CR_FRAMEBUFFERTEXTURE2DEXT_EXTEND_OPCODE:
			crUnpackExtendFramebufferTexture2DEXT( );
			break;
		case CR_FRAMEBUFFERTEXTURE3DEXT_EXTEND_OPCODE:
			crUnpackExtendFramebufferTexture3DEXT( );
			break;
		case CR_GENBUFFERSARB_EXTEND_OPCODE:
			crUnpackExtendGenBuffersARB( );
			break;
		case CR_GENFENCESNV_EXTEND_OPCODE:
			crUnpackExtendGenFencesNV( );
			break;
		case CR_GENFRAMEBUFFERSEXT_EXTEND_OPCODE:
			crUnpackExtendGenFramebuffersEXT( );
			break;
		case CR_GENLISTS_EXTEND_OPCODE:
			crUnpackExtendGenLists( );
			break;
		case CR_GENPROGRAMSARB_EXTEND_OPCODE:
			crUnpackExtendGenProgramsARB( );
			break;
		case CR_GENPROGRAMSNV_EXTEND_OPCODE:
			crUnpackExtendGenProgramsNV( );
			break;
		case CR_GENQUERIESARB_EXTEND_OPCODE:
			crUnpackExtendGenQueriesARB( );
			break;
		case CR_GENRENDERBUFFERSEXT_EXTEND_OPCODE:
			crUnpackExtendGenRenderbuffersEXT( );
			break;
		case CR_GENTEXTURES_EXTEND_OPCODE:
			crUnpackExtendGenTextures( );
			break;
		case CR_GENERATEMIPMAPEXT_EXTEND_OPCODE:
			crUnpackExtendGenerateMipmapEXT( );
			break;
		case CR_GETACTIVEATTRIB_EXTEND_OPCODE:
			crUnpackExtendGetActiveAttrib( );
			break;
		case CR_GETACTIVEUNIFORM_EXTEND_OPCODE:
			crUnpackExtendGetActiveUniform( );
			break;
		case CR_GETATTACHEDOBJECTSARB_EXTEND_OPCODE:
			crUnpackExtendGetAttachedObjectsARB( );
			break;
		case CR_GETATTACHEDSHADERS_EXTEND_OPCODE:
			crUnpackExtendGetAttachedShaders( );
			break;
		case CR_GETATTRIBLOCATION_EXTEND_OPCODE:
			crUnpackExtendGetAttribLocation( );
			break;
		case CR_GETBOOLEANV_EXTEND_OPCODE:
			crUnpackExtendGetBooleanv( );
			break;
		case CR_GETBUFFERPARAMETERIVARB_EXTEND_OPCODE:
			crUnpackExtendGetBufferParameterivARB( );
			break;
		case CR_GETBUFFERSUBDATAARB_EXTEND_OPCODE:
			crUnpackExtendGetBufferSubDataARB( );
			break;
		case CR_GETCHROMIUMPARAMETERVCR_EXTEND_OPCODE:
			crUnpackExtendGetChromiumParametervCR( );
			break;
		case CR_GETCLIPPLANE_EXTEND_OPCODE:
			crUnpackExtendGetClipPlane( );
			break;
		case CR_GETCOMBINERINPUTPARAMETERFVNV_EXTEND_OPCODE:
			crUnpackExtendGetCombinerInputParameterfvNV( );
			break;
		case CR_GETCOMBINERINPUTPARAMETERIVNV_EXTEND_OPCODE:
			crUnpackExtendGetCombinerInputParameterivNV( );
			break;
		case CR_GETCOMBINEROUTPUTPARAMETERFVNV_EXTEND_OPCODE:
			crUnpackExtendGetCombinerOutputParameterfvNV( );
			break;
		case CR_GETCOMBINEROUTPUTPARAMETERIVNV_EXTEND_OPCODE:
			crUnpackExtendGetCombinerOutputParameterivNV( );
			break;
		case CR_GETCOMBINERSTAGEPARAMETERFVNV_EXTEND_OPCODE:
			crUnpackExtendGetCombinerStageParameterfvNV( );
			break;
		case CR_GETCOMPRESSEDTEXIMAGEARB_EXTEND_OPCODE:
			crUnpackExtendGetCompressedTexImageARB( );
			break;
		case CR_GETDOUBLEV_EXTEND_OPCODE:
			crUnpackExtendGetDoublev( );
			break;
		case CR_GETERROR_EXTEND_OPCODE:
			crUnpackExtendGetError( );
			break;
		case CR_GETFENCEIVNV_EXTEND_OPCODE:
			crUnpackExtendGetFenceivNV( );
			break;
		case CR_GETFINALCOMBINERINPUTPARAMETERFVNV_EXTEND_OPCODE:
			crUnpackExtendGetFinalCombinerInputParameterfvNV( );
			break;
		case CR_GETFINALCOMBINERINPUTPARAMETERIVNV_EXTEND_OPCODE:
			crUnpackExtendGetFinalCombinerInputParameterivNV( );
			break;
		case CR_GETFLOATV_EXTEND_OPCODE:
			crUnpackExtendGetFloatv( );
			break;
		case CR_GETFRAMEBUFFERATTACHMENTPARAMETERIVEXT_EXTEND_OPCODE:
			crUnpackExtendGetFramebufferAttachmentParameterivEXT( );
			break;
		case CR_GETHANDLEARB_EXTEND_OPCODE:
			crUnpackExtendGetHandleARB( );
			break;
		case CR_GETINFOLOGARB_EXTEND_OPCODE:
			crUnpackExtendGetInfoLogARB( );
			break;
		case CR_GETINTEGERV_EXTEND_OPCODE:
			crUnpackExtendGetIntegerv( );
			break;
		case CR_GETLIGHTFV_EXTEND_OPCODE:
			crUnpackExtendGetLightfv( );
			break;
		case CR_GETLIGHTIV_EXTEND_OPCODE:
			crUnpackExtendGetLightiv( );
			break;
		case CR_GETMAPDV_EXTEND_OPCODE:
			crUnpackExtendGetMapdv( );
			break;
		case CR_GETMAPFV_EXTEND_OPCODE:
			crUnpackExtendGetMapfv( );
			break;
		case CR_GETMAPIV_EXTEND_OPCODE:
			crUnpackExtendGetMapiv( );
			break;
		case CR_GETMATERIALFV_EXTEND_OPCODE:
			crUnpackExtendGetMaterialfv( );
			break;
		case CR_GETMATERIALIV_EXTEND_OPCODE:
			crUnpackExtendGetMaterialiv( );
			break;
		case CR_GETOBJECTPARAMETERFVARB_EXTEND_OPCODE:
			crUnpackExtendGetObjectParameterfvARB( );
			break;
		case CR_GETOBJECTPARAMETERIVARB_EXTEND_OPCODE:
			crUnpackExtendGetObjectParameterivARB( );
			break;
		case CR_GETPIXELMAPFV_EXTEND_OPCODE:
			crUnpackExtendGetPixelMapfv( );
			break;
		case CR_GETPIXELMAPUIV_EXTEND_OPCODE:
			crUnpackExtendGetPixelMapuiv( );
			break;
		case CR_GETPIXELMAPUSV_EXTEND_OPCODE:
			crUnpackExtendGetPixelMapusv( );
			break;
		case CR_GETPOINTERV_EXTEND_OPCODE:
			crUnpackExtendGetPointerv( );
			break;
		case CR_GETPOLYGONSTIPPLE_EXTEND_OPCODE:
			crUnpackExtendGetPolygonStipple( );
			break;
		case CR_GETPROGRAMENVPARAMETERDVARB_EXTEND_OPCODE:
			crUnpackExtendGetProgramEnvParameterdvARB( );
			break;
		case CR_GETPROGRAMENVPARAMETERFVARB_EXTEND_OPCODE:
			crUnpackExtendGetProgramEnvParameterfvARB( );
			break;
		case CR_GETPROGRAMINFOLOG_EXTEND_OPCODE:
			crUnpackExtendGetProgramInfoLog( );
			break;
		case CR_GETPROGRAMLOCALPARAMETERDVARB_EXTEND_OPCODE:
			crUnpackExtendGetProgramLocalParameterdvARB( );
			break;
		case CR_GETPROGRAMLOCALPARAMETERFVARB_EXTEND_OPCODE:
			crUnpackExtendGetProgramLocalParameterfvARB( );
			break;
		case CR_GETPROGRAMNAMEDPARAMETERDVNV_EXTEND_OPCODE:
			crUnpackExtendGetProgramNamedParameterdvNV( );
			break;
		case CR_GETPROGRAMNAMEDPARAMETERFVNV_EXTEND_OPCODE:
			crUnpackExtendGetProgramNamedParameterfvNV( );
			break;
		case CR_GETPROGRAMPARAMETERDVNV_EXTEND_OPCODE:
			crUnpackExtendGetProgramParameterdvNV( );
			break;
		case CR_GETPROGRAMPARAMETERFVNV_EXTEND_OPCODE:
			crUnpackExtendGetProgramParameterfvNV( );
			break;
		case CR_GETPROGRAMSTRINGARB_EXTEND_OPCODE:
			crUnpackExtendGetProgramStringARB( );
			break;
		case CR_GETPROGRAMSTRINGNV_EXTEND_OPCODE:
			crUnpackExtendGetProgramStringNV( );
			break;
		case CR_GETPROGRAMIV_EXTEND_OPCODE:
			crUnpackExtendGetProgramiv( );
			break;
		case CR_GETPROGRAMIVARB_EXTEND_OPCODE:
			crUnpackExtendGetProgramivARB( );
			break;
		case CR_GETPROGRAMIVNV_EXTEND_OPCODE:
			crUnpackExtendGetProgramivNV( );
			break;
		case CR_GETQUERYOBJECTIVARB_EXTEND_OPCODE:
			crUnpackExtendGetQueryObjectivARB( );
			break;
		case CR_GETQUERYOBJECTUIVARB_EXTEND_OPCODE:
			crUnpackExtendGetQueryObjectuivARB( );
			break;
		case CR_GETQUERYIVARB_EXTEND_OPCODE:
			crUnpackExtendGetQueryivARB( );
			break;
		case CR_GETRENDERBUFFERPARAMETERIVEXT_EXTEND_OPCODE:
			crUnpackExtendGetRenderbufferParameterivEXT( );
			break;
		case CR_GETSHADERINFOLOG_EXTEND_OPCODE:
			crUnpackExtendGetShaderInfoLog( );
			break;
		case CR_GETSHADERSOURCE_EXTEND_OPCODE:
			crUnpackExtendGetShaderSource( );
			break;
		case CR_GETSHADERIV_EXTEND_OPCODE:
			crUnpackExtendGetShaderiv( );
			break;
		case CR_GETSTRING_EXTEND_OPCODE:
			crUnpackExtendGetString( );
			break;
		case CR_GETTEXENVFV_EXTEND_OPCODE:
			crUnpackExtendGetTexEnvfv( );
			break;
		case CR_GETTEXENVIV_EXTEND_OPCODE:
			crUnpackExtendGetTexEnviv( );
			break;
		case CR_GETTEXGENDV_EXTEND_OPCODE:
			crUnpackExtendGetTexGendv( );
			break;
		case CR_GETTEXGENFV_EXTEND_OPCODE:
			crUnpackExtendGetTexGenfv( );
			break;
		case CR_GETTEXGENIV_EXTEND_OPCODE:
			crUnpackExtendGetTexGeniv( );
			break;
		case CR_GETTEXIMAGE_EXTEND_OPCODE:
			crUnpackExtendGetTexImage( );
			break;
		case CR_GETTEXLEVELPARAMETERFV_EXTEND_OPCODE:
			crUnpackExtendGetTexLevelParameterfv( );
			break;
		case CR_GETTEXLEVELPARAMETERIV_EXTEND_OPCODE:
			crUnpackExtendGetTexLevelParameteriv( );
			break;
		case CR_GETTEXPARAMETERFV_EXTEND_OPCODE:
			crUnpackExtendGetTexParameterfv( );
			break;
		case CR_GETTEXPARAMETERIV_EXTEND_OPCODE:
			crUnpackExtendGetTexParameteriv( );
			break;
		case CR_GETTRACKMATRIXIVNV_EXTEND_OPCODE:
			crUnpackExtendGetTrackMatrixivNV( );
			break;
		case CR_GETUNIFORMLOCATION_EXTEND_OPCODE:
			crUnpackExtendGetUniformLocation( );
			break;
		case CR_GETUNIFORMFV_EXTEND_OPCODE:
			crUnpackExtendGetUniformfv( );
			break;
		case CR_GETUNIFORMIV_EXTEND_OPCODE:
			crUnpackExtendGetUniformiv( );
			break;
		case CR_GETUNIFORMSLOCATIONS_EXTEND_OPCODE:
			crUnpackExtendGetUniformsLocations( );
			break;
		case CR_GETVERTEXATTRIBPOINTERVARB_EXTEND_OPCODE:
			crUnpackExtendGetVertexAttribPointervARB( );
			break;
		case CR_GETVERTEXATTRIBPOINTERVNV_EXTEND_OPCODE:
			crUnpackExtendGetVertexAttribPointervNV( );
			break;
		case CR_GETVERTEXATTRIBDVARB_EXTEND_OPCODE:
			crUnpackExtendGetVertexAttribdvARB( );
			break;
		case CR_GETVERTEXATTRIBDVNV_EXTEND_OPCODE:
			crUnpackExtendGetVertexAttribdvNV( );
			break;
		case CR_GETVERTEXATTRIBFVARB_EXTEND_OPCODE:
			crUnpackExtendGetVertexAttribfvARB( );
			break;
		case CR_GETVERTEXATTRIBFVNV_EXTEND_OPCODE:
			crUnpackExtendGetVertexAttribfvNV( );
			break;
		case CR_GETVERTEXATTRIBIVARB_EXTEND_OPCODE:
			crUnpackExtendGetVertexAttribivARB( );
			break;
		case CR_GETVERTEXATTRIBIVNV_EXTEND_OPCODE:
			crUnpackExtendGetVertexAttribivNV( );
			break;
		case CR_HINT_EXTEND_OPCODE:
			crUnpackExtendHint( );
			break;
		case CR_INDEXPOINTER_EXTEND_OPCODE:
			crUnpackExtendIndexPointer( );
			break;
		case CR_INTERLEAVEDARRAYS_EXTEND_OPCODE:
			crUnpackExtendInterleavedArrays( );
			break;
		case CR_ISBUFFERARB_EXTEND_OPCODE:
			crUnpackExtendIsBufferARB( );
			break;
		case CR_ISENABLED_EXTEND_OPCODE:
			crUnpackExtendIsEnabled( );
			break;
		case CR_ISFENCENV_EXTEND_OPCODE:
			crUnpackExtendIsFenceNV( );
			break;
		case CR_ISFRAMEBUFFEREXT_EXTEND_OPCODE:
			crUnpackExtendIsFramebufferEXT( );
			break;
		case CR_ISLIST_EXTEND_OPCODE:
			crUnpackExtendIsList( );
			break;
		case CR_ISPROGRAM_EXTEND_OPCODE:
			crUnpackExtendIsProgram( );
			break;
		case CR_ISPROGRAMARB_EXTEND_OPCODE:
			crUnpackExtendIsProgramARB( );
			break;
		case CR_ISQUERYARB_EXTEND_OPCODE:
			crUnpackExtendIsQueryARB( );
			break;
		case CR_ISRENDERBUFFEREXT_EXTEND_OPCODE:
			crUnpackExtendIsRenderbufferEXT( );
			break;
		case CR_ISSHADER_EXTEND_OPCODE:
			crUnpackExtendIsShader( );
			break;
		case CR_ISTEXTURE_EXTEND_OPCODE:
			crUnpackExtendIsTexture( );
			break;
		case CR_LINKPROGRAM_EXTEND_OPCODE:
			crUnpackExtendLinkProgram( );
			break;
		case CR_LISTBASE_EXTEND_OPCODE:
			crUnpackExtendListBase( );
			break;
		case CR_LOADPROGRAMNV_EXTEND_OPCODE:
			crUnpackExtendLoadProgramNV( );
			break;
		case CR_LOADTRANSPOSEMATRIXDARB_EXTEND_OPCODE:
			crUnpackExtendLoadTransposeMatrixdARB( );
			break;
		case CR_LOADTRANSPOSEMATRIXFARB_EXTEND_OPCODE:
			crUnpackExtendLoadTransposeMatrixfARB( );
			break;
		case CR_LOCKARRAYSEXT_EXTEND_OPCODE:
			crUnpackExtendLockArraysEXT( );
			break;
		case CR_LOGICOP_EXTEND_OPCODE:
			crUnpackExtendLogicOp( );
			break;
		case CR_MAKECURRENT_EXTEND_OPCODE:
			crUnpackExtendMakeCurrent( );
			break;
		case CR_MULTTRANSPOSEMATRIXDARB_EXTEND_OPCODE:
			crUnpackExtendMultTransposeMatrixdARB( );
			break;
		case CR_MULTTRANSPOSEMATRIXFARB_EXTEND_OPCODE:
			crUnpackExtendMultTransposeMatrixfARB( );
			break;
		case CR_NEWLIST_EXTEND_OPCODE:
			crUnpackExtendNewList( );
			break;
		case CR_NORMALPOINTER_EXTEND_OPCODE:
			crUnpackExtendNormalPointer( );
			break;
		case CR_POINTPARAMETERFARB_EXTEND_OPCODE:
			crUnpackExtendPointParameterfARB( );
			break;
		case CR_POINTPARAMETERFVARB_EXTEND_OPCODE:
			crUnpackExtendPointParameterfvARB( );
			break;
		case CR_POINTPARAMETERI_EXTEND_OPCODE:
			crUnpackExtendPointParameteri( );
			break;
		case CR_POINTPARAMETERIV_EXTEND_OPCODE:
			crUnpackExtendPointParameteriv( );
			break;
		case CR_POPATTRIB_EXTEND_OPCODE:
			crUnpackExtendPopAttrib( );
			break;
		case CR_POPCLIENTATTRIB_EXTEND_OPCODE:
			crUnpackExtendPopClientAttrib( );
			break;
		case CR_PROGRAMENVPARAMETER4DARB_EXTEND_OPCODE:
			crUnpackExtendProgramEnvParameter4dARB( );
			break;
		case CR_PROGRAMENVPARAMETER4DVARB_EXTEND_OPCODE:
			crUnpackExtendProgramEnvParameter4dvARB( );
			break;
		case CR_PROGRAMENVPARAMETER4FARB_EXTEND_OPCODE:
			crUnpackExtendProgramEnvParameter4fARB( );
			break;
		case CR_PROGRAMENVPARAMETER4FVARB_EXTEND_OPCODE:
			crUnpackExtendProgramEnvParameter4fvARB( );
			break;
		case CR_PROGRAMLOCALPARAMETER4DARB_EXTEND_OPCODE:
			crUnpackExtendProgramLocalParameter4dARB( );
			break;
		case CR_PROGRAMLOCALPARAMETER4DVARB_EXTEND_OPCODE:
			crUnpackExtendProgramLocalParameter4dvARB( );
			break;
		case CR_PROGRAMLOCALPARAMETER4FARB_EXTEND_OPCODE:
			crUnpackExtendProgramLocalParameter4fARB( );
			break;
		case CR_PROGRAMLOCALPARAMETER4FVARB_EXTEND_OPCODE:
			crUnpackExtendProgramLocalParameter4fvARB( );
			break;
		case CR_PROGRAMNAMEDPARAMETER4DNV_EXTEND_OPCODE:
			crUnpackExtendProgramNamedParameter4dNV( );
			break;
		case CR_PROGRAMNAMEDPARAMETER4DVNV_EXTEND_OPCODE:
			crUnpackExtendProgramNamedParameter4dvNV( );
			break;
		case CR_PROGRAMNAMEDPARAMETER4FNV_EXTEND_OPCODE:
			crUnpackExtendProgramNamedParameter4fNV( );
			break;
		case CR_PROGRAMNAMEDPARAMETER4FVNV_EXTEND_OPCODE:
			crUnpackExtendProgramNamedParameter4fvNV( );
			break;
		case CR_PROGRAMPARAMETER4DNV_EXTEND_OPCODE:
			crUnpackExtendProgramParameter4dNV( );
			break;
		case CR_PROGRAMPARAMETER4DVNV_EXTEND_OPCODE:
			crUnpackExtendProgramParameter4dvNV( );
			break;
		case CR_PROGRAMPARAMETER4FNV_EXTEND_OPCODE:
			crUnpackExtendProgramParameter4fNV( );
			break;
		case CR_PROGRAMPARAMETER4FVNV_EXTEND_OPCODE:
			crUnpackExtendProgramParameter4fvNV( );
			break;
		case CR_PROGRAMPARAMETERS4DVNV_EXTEND_OPCODE:
			crUnpackExtendProgramParameters4dvNV( );
			break;
		case CR_PROGRAMPARAMETERS4FVNV_EXTEND_OPCODE:
			crUnpackExtendProgramParameters4fvNV( );
			break;
		case CR_PROGRAMSTRINGARB_EXTEND_OPCODE:
			crUnpackExtendProgramStringARB( );
			break;
		case CR_PUSHATTRIB_EXTEND_OPCODE:
			crUnpackExtendPushAttrib( );
			break;
		case CR_PUSHCLIENTATTRIB_EXTEND_OPCODE:
			crUnpackExtendPushClientAttrib( );
			break;
		case CR_READBUFFER_EXTEND_OPCODE:
			crUnpackExtendReadBuffer( );
			break;
		case CR_RENDERMODE_EXTEND_OPCODE:
			crUnpackExtendRenderMode( );
			break;
		case CR_RENDERBUFFERSTORAGEEXT_EXTEND_OPCODE:
			crUnpackExtendRenderbufferStorageEXT( );
			break;
		case CR_REQUESTRESIDENTPROGRAMSNV_EXTEND_OPCODE:
			crUnpackExtendRequestResidentProgramsNV( );
			break;
		case CR_SAMPLECOVERAGEARB_EXTEND_OPCODE:
			crUnpackExtendSampleCoverageARB( );
			break;
		case CR_SECONDARYCOLORPOINTEREXT_EXTEND_OPCODE:
			crUnpackExtendSecondaryColorPointerEXT( );
			break;
		case CR_SEMAPHORECREATECR_EXTEND_OPCODE:
			crUnpackExtendSemaphoreCreateCR( );
			break;
		case CR_SEMAPHOREDESTROYCR_EXTEND_OPCODE:
			crUnpackExtendSemaphoreDestroyCR( );
			break;
		case CR_SEMAPHOREPCR_EXTEND_OPCODE:
			crUnpackExtendSemaphorePCR( );
			break;
		case CR_SEMAPHOREVCR_EXTEND_OPCODE:
			crUnpackExtendSemaphoreVCR( );
			break;
		case CR_SETFENCENV_EXTEND_OPCODE:
			crUnpackExtendSetFenceNV( );
			break;
		case CR_SHADERSOURCE_EXTEND_OPCODE:
			crUnpackExtendShaderSource( );
			break;
		case CR_STENCILFUNCSEPARATE_EXTEND_OPCODE:
			crUnpackExtendStencilFuncSeparate( );
			break;
		case CR_STENCILMASKSEPARATE_EXTEND_OPCODE:
			crUnpackExtendStencilMaskSeparate( );
			break;
		case CR_STENCILOPSEPARATE_EXTEND_OPCODE:
			crUnpackExtendStencilOpSeparate( );
			break;
		case CR_SWAPBUFFERS_EXTEND_OPCODE:
			crUnpackExtendSwapBuffers( );
			break;
		case CR_TESTFENCENV_EXTEND_OPCODE:
			crUnpackExtendTestFenceNV( );
			break;
		case CR_TEXCOORDPOINTER_EXTEND_OPCODE:
			crUnpackExtendTexCoordPointer( );
			break;
		case CR_TRACKMATRIXNV_EXTEND_OPCODE:
			crUnpackExtendTrackMatrixNV( );
			break;
		case CR_UNIFORM1F_EXTEND_OPCODE:
			crUnpackExtendUniform1f( );
			break;
		case CR_UNIFORM1FV_EXTEND_OPCODE:
			crUnpackExtendUniform1fv( );
			break;
		case CR_UNIFORM1I_EXTEND_OPCODE:
			crUnpackExtendUniform1i( );
			break;
		case CR_UNIFORM1IV_EXTEND_OPCODE:
			crUnpackExtendUniform1iv( );
			break;
		case CR_UNIFORM2F_EXTEND_OPCODE:
			crUnpackExtendUniform2f( );
			break;
		case CR_UNIFORM2FV_EXTEND_OPCODE:
			crUnpackExtendUniform2fv( );
			break;
		case CR_UNIFORM2I_EXTEND_OPCODE:
			crUnpackExtendUniform2i( );
			break;
		case CR_UNIFORM2IV_EXTEND_OPCODE:
			crUnpackExtendUniform2iv( );
			break;
		case CR_UNIFORM3F_EXTEND_OPCODE:
			crUnpackExtendUniform3f( );
			break;
		case CR_UNIFORM3FV_EXTEND_OPCODE:
			crUnpackExtendUniform3fv( );
			break;
		case CR_UNIFORM3I_EXTEND_OPCODE:
			crUnpackExtendUniform3i( );
			break;
		case CR_UNIFORM3IV_EXTEND_OPCODE:
			crUnpackExtendUniform3iv( );
			break;
		case CR_UNIFORM4F_EXTEND_OPCODE:
			crUnpackExtendUniform4f( );
			break;
		case CR_UNIFORM4FV_EXTEND_OPCODE:
			crUnpackExtendUniform4fv( );
			break;
		case CR_UNIFORM4I_EXTEND_OPCODE:
			crUnpackExtendUniform4i( );
			break;
		case CR_UNIFORM4IV_EXTEND_OPCODE:
			crUnpackExtendUniform4iv( );
			break;
		case CR_UNIFORMMATRIX2FV_EXTEND_OPCODE:
			crUnpackExtendUniformMatrix2fv( );
			break;
		case CR_UNIFORMMATRIX2X3FV_EXTEND_OPCODE:
			crUnpackExtendUniformMatrix2x3fv( );
			break;
		case CR_UNIFORMMATRIX2X4FV_EXTEND_OPCODE:
			crUnpackExtendUniformMatrix2x4fv( );
			break;
		case CR_UNIFORMMATRIX3FV_EXTEND_OPCODE:
			crUnpackExtendUniformMatrix3fv( );
			break;
		case CR_UNIFORMMATRIX3X2FV_EXTEND_OPCODE:
			crUnpackExtendUniformMatrix3x2fv( );
			break;
		case CR_UNIFORMMATRIX3X4FV_EXTEND_OPCODE:
			crUnpackExtendUniformMatrix3x4fv( );
			break;
		case CR_UNIFORMMATRIX4FV_EXTEND_OPCODE:
			crUnpackExtendUniformMatrix4fv( );
			break;
		case CR_UNIFORMMATRIX4X2FV_EXTEND_OPCODE:
			crUnpackExtendUniformMatrix4x2fv( );
			break;
		case CR_UNIFORMMATRIX4X3FV_EXTEND_OPCODE:
			crUnpackExtendUniformMatrix4x3fv( );
			break;
		case CR_UNLOCKARRAYSEXT_EXTEND_OPCODE:
			crUnpackExtendUnlockArraysEXT( );
			break;
		case CR_USEPROGRAM_EXTEND_OPCODE:
			crUnpackExtendUseProgram( );
			break;
		case CR_VBOXTEXPRESENT_EXTEND_OPCODE:
			crUnpackExtendVBoxTexPresent( );
			break;
		case CR_VALIDATEPROGRAM_EXTEND_OPCODE:
			crUnpackExtendValidateProgram( );
			break;
		case CR_VERTEXARRAYRANGENV_EXTEND_OPCODE:
			crUnpackExtendVertexArrayRangeNV( );
			break;
		case CR_VERTEXATTRIBPOINTERARB_EXTEND_OPCODE:
			crUnpackExtendVertexAttribPointerARB( );
			break;
		case CR_VERTEXATTRIBPOINTERNV_EXTEND_OPCODE:
			crUnpackExtendVertexAttribPointerNV( );
			break;
		case CR_VERTEXPOINTER_EXTEND_OPCODE:
			crUnpackExtendVertexPointer( );
			break;
		case CR_WINDOWCREATE_EXTEND_OPCODE:
			crUnpackExtendWindowCreate( );
			break;
		case CR_WINDOWDESTROY_EXTEND_OPCODE:
			crUnpackExtendWindowDestroy( );
			break;
		case CR_WINDOWPOS2DARB_EXTEND_OPCODE:
			crUnpackExtendWindowPos2dARB( );
			break;
		case CR_WINDOWPOS2DVARB_EXTEND_OPCODE:
			crUnpackExtendWindowPos2dvARB( );
			break;
		case CR_WINDOWPOS2FARB_EXTEND_OPCODE:
			crUnpackExtendWindowPos2fARB( );
			break;
		case CR_WINDOWPOS2FVARB_EXTEND_OPCODE:
			crUnpackExtendWindowPos2fvARB( );
			break;
		case CR_WINDOWPOS2IARB_EXTEND_OPCODE:
			crUnpackExtendWindowPos2iARB( );
			break;
		case CR_WINDOWPOS2IVARB_EXTEND_OPCODE:
			crUnpackExtendWindowPos2ivARB( );
			break;
		case CR_WINDOWPOS2SARB_EXTEND_OPCODE:
			crUnpackExtendWindowPos2sARB( );
			break;
		case CR_WINDOWPOS2SVARB_EXTEND_OPCODE:
			crUnpackExtendWindowPos2svARB( );
			break;
		case CR_WINDOWPOS3DARB_EXTEND_OPCODE:
			crUnpackExtendWindowPos3dARB( );
			break;
		case CR_WINDOWPOS3DVARB_EXTEND_OPCODE:
			crUnpackExtendWindowPos3dvARB( );
			break;
		case CR_WINDOWPOS3FARB_EXTEND_OPCODE:
			crUnpackExtendWindowPos3fARB( );
			break;
		case CR_WINDOWPOS3FVARB_EXTEND_OPCODE:
			crUnpackExtendWindowPos3fvARB( );
			break;
		case CR_WINDOWPOS3IARB_EXTEND_OPCODE:
			crUnpackExtendWindowPos3iARB( );
			break;
		case CR_WINDOWPOS3IVARB_EXTEND_OPCODE:
			crUnpackExtendWindowPos3ivARB( );
			break;
		case CR_WINDOWPOS3SARB_EXTEND_OPCODE:
			crUnpackExtendWindowPos3sARB( );
			break;
		case CR_WINDOWPOS3SVARB_EXTEND_OPCODE:
			crUnpackExtendWindowPos3svARB( );
			break;
		case CR_WINDOWPOSITION_EXTEND_OPCODE:
			crUnpackExtendWindowPosition( );
			break;
		case CR_WINDOWSHOW_EXTEND_OPCODE:
			crUnpackExtendWindowShow( );
			break;
		case CR_WINDOWSIZE_EXTEND_OPCODE:
			crUnpackExtendWindowSize( );
			break;
		case CR_WINDOWVISIBLEREGION_EXTEND_OPCODE:
			crUnpackExtendWindowVisibleRegion( );
			break;
		case CR_WRITEBACK_EXTEND_OPCODE:
			crUnpackExtendWriteback( );
			break;
		case CR_ZPIXCR_EXTEND_OPCODE:
			crUnpackExtendZPixCR( );
			break;
       default:
            crError( "Unknown extended opcode: %d", (int) extend_opcode );
            break;
    }
    INCR_VAR_PTR();
}
static void crUnpackExtendDbg(void)
{
	GLenum extend_opcode = READ_DATA( 4, GLenum );

	/*crDebug("Unpacking extended opcode \%d", extend_opcode);*/
	switch( extend_opcode )
	{
		case CR_ACCUM_EXTEND_OPCODE:
			crDebug("Unpack: CR_ACCUM_EXTEND_OPCODE");
			crUnpackExtendAccum( );
			break;
		case CR_ACTIVESTENCILFACEEXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_ACTIVESTENCILFACEEXT_EXTEND_OPCODE");
			crUnpackExtendActiveStencilFaceEXT( );
			break;
		case CR_ACTIVETEXTUREARB_EXTEND_OPCODE:
			crUnpackExtendActiveTextureARB( );
			break;
		case CR_AREPROGRAMSRESIDENTNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_AREPROGRAMSRESIDENTNV_EXTEND_OPCODE");
			crUnpackExtendAreProgramsResidentNV( );
			break;
		case CR_ARETEXTURESRESIDENT_EXTEND_OPCODE:
			crDebug("Unpack: CR_ARETEXTURESRESIDENT_EXTEND_OPCODE");
			crUnpackExtendAreTexturesResident( );
			break;
		case CR_ATTACHSHADER_EXTEND_OPCODE:
			crDebug("Unpack: CR_ATTACHSHADER_EXTEND_OPCODE");
			crUnpackExtendAttachShader( );
			break;
		case CR_BARRIERCREATECR_EXTEND_OPCODE:
			crDebug("Unpack: CR_BARRIERCREATECR_EXTEND_OPCODE");
			crUnpackExtendBarrierCreateCR( );
			break;
		case CR_BARRIERDESTROYCR_EXTEND_OPCODE:
			crDebug("Unpack: CR_BARRIERDESTROYCR_EXTEND_OPCODE");
			crUnpackExtendBarrierDestroyCR( );
			break;
		case CR_BARRIEREXECCR_EXTEND_OPCODE:
			crDebug("Unpack: CR_BARRIEREXECCR_EXTEND_OPCODE");
			crUnpackExtendBarrierExecCR( );
			break;
		case CR_BEGINQUERYARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_BEGINQUERYARB_EXTEND_OPCODE");
			crUnpackExtendBeginQueryARB( );
			break;
		case CR_BINDATTRIBLOCATION_EXTEND_OPCODE:
			crDebug("Unpack: CR_BINDATTRIBLOCATION_EXTEND_OPCODE");
			crUnpackExtendBindAttribLocation( );
			break;
		case CR_BINDBUFFERARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_BINDBUFFERARB_EXTEND_OPCODE");
			crUnpackExtendBindBufferARB( );
			break;
		case CR_BINDFRAMEBUFFEREXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_BINDFRAMEBUFFEREXT_EXTEND_OPCODE");
			crUnpackExtendBindFramebufferEXT( );
			break;
		case CR_BINDPROGRAMARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_BINDPROGRAMARB_EXTEND_OPCODE");
			crUnpackExtendBindProgramARB( );
			break;
		case CR_BINDPROGRAMNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_BINDPROGRAMNV_EXTEND_OPCODE");
			crUnpackExtendBindProgramNV( );
			break;
		case CR_BINDRENDERBUFFEREXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_BINDRENDERBUFFEREXT_EXTEND_OPCODE");
			crUnpackExtendBindRenderbufferEXT( );
			break;
		case CR_BLENDCOLOREXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_BLENDCOLOREXT_EXTEND_OPCODE");
			crUnpackExtendBlendColorEXT( );
			break;
		case CR_BLENDEQUATIONEXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_BLENDEQUATIONEXT_EXTEND_OPCODE");
			crUnpackExtendBlendEquationEXT( );
			break;
		case CR_BLENDEQUATIONSEPARATE_EXTEND_OPCODE:
			crDebug("Unpack: CR_BLENDEQUATIONSEPARATE_EXTEND_OPCODE");
			crUnpackExtendBlendEquationSeparate( );
			break;
		case CR_BLENDFUNCSEPARATEEXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_BLENDFUNCSEPARATEEXT_EXTEND_OPCODE");
			crUnpackExtendBlendFuncSeparateEXT( );
			break;
		case CR_BLITFRAMEBUFFEREXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_BLITFRAMEBUFFEREXT_EXTEND_OPCODE");
			crUnpackExtendBlitFramebufferEXT( );
			break;
		case CR_BUFFERDATAARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_BUFFERDATAARB_EXTEND_OPCODE");
			crUnpackExtendBufferDataARB( );
			break;
		case CR_BUFFERSUBDATAARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_BUFFERSUBDATAARB_EXTEND_OPCODE");
			crUnpackExtendBufferSubDataARB( );
			break;
		case CR_CHECKFRAMEBUFFERSTATUSEXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_CHECKFRAMEBUFFERSTATUSEXT_EXTEND_OPCODE");
			crUnpackExtendCheckFramebufferStatusEXT( );
			break;
		case CR_CHROMIUMPARAMETERFCR_EXTEND_OPCODE:
			crDebug("Unpack: CR_CHROMIUMPARAMETERFCR_EXTEND_OPCODE");
			crUnpackExtendChromiumParameterfCR( );
			break;
		case CR_CHROMIUMPARAMETERICR_EXTEND_OPCODE:
			crDebug("Unpack: CR_CHROMIUMPARAMETERICR_EXTEND_OPCODE");
			crUnpackExtendChromiumParameteriCR( );
			break;
		case CR_CHROMIUMPARAMETERVCR_EXTEND_OPCODE:
			crDebug("Unpack: CR_CHROMIUMPARAMETERVCR_EXTEND_OPCODE");
			crUnpackExtendChromiumParametervCR( );
			break;
		case CR_CLEARACCUM_EXTEND_OPCODE:
			crDebug("Unpack: CR_CLEARACCUM_EXTEND_OPCODE");
			crUnpackExtendClearAccum( );
			break;
		case CR_CLEARCOLOR_EXTEND_OPCODE:
			crDebug("Unpack: CR_CLEARCOLOR_EXTEND_OPCODE");
			crUnpackExtendClearColor( );
			break;
		case CR_CLEARDEPTH_EXTEND_OPCODE:
			crDebug("Unpack: CR_CLEARDEPTH_EXTEND_OPCODE");
			crUnpackExtendClearDepth( );
			break;
		case CR_CLEARINDEX_EXTEND_OPCODE:
			crDebug("Unpack: CR_CLEARINDEX_EXTEND_OPCODE");
			crUnpackExtendClearIndex( );
			break;
		case CR_CLEARSTENCIL_EXTEND_OPCODE:
			crDebug("Unpack: CR_CLEARSTENCIL_EXTEND_OPCODE");
			crUnpackExtendClearStencil( );
			break;
		case CR_CLIENTACTIVETEXTUREARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_CLIENTACTIVETEXTUREARB_EXTEND_OPCODE");
			crUnpackExtendClientActiveTextureARB( );
			break;
		case CR_COLORPOINTER_EXTEND_OPCODE:
			crDebug("Unpack: CR_COLORPOINTER_EXTEND_OPCODE");
			crUnpackExtendColorPointer( );
			break;
		case CR_COMBINERINPUTNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_COMBINERINPUTNV_EXTEND_OPCODE");
			crUnpackExtendCombinerInputNV( );
			break;
		case CR_COMBINEROUTPUTNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_COMBINEROUTPUTNV_EXTEND_OPCODE");
			crUnpackExtendCombinerOutputNV( );
			break;
		case CR_COMBINERPARAMETERFNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_COMBINERPARAMETERFNV_EXTEND_OPCODE");
			crUnpackExtendCombinerParameterfNV( );
			break;
		case CR_COMBINERPARAMETERFVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_COMBINERPARAMETERFVNV_EXTEND_OPCODE");
			crUnpackExtendCombinerParameterfvNV( );
			break;
		case CR_COMBINERPARAMETERINV_EXTEND_OPCODE:
			crDebug("Unpack: CR_COMBINERPARAMETERINV_EXTEND_OPCODE");
			crUnpackExtendCombinerParameteriNV( );
			break;
		case CR_COMBINERPARAMETERIVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_COMBINERPARAMETERIVNV_EXTEND_OPCODE");
			crUnpackExtendCombinerParameterivNV( );
			break;
		case CR_COMBINERSTAGEPARAMETERFVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_COMBINERSTAGEPARAMETERFVNV_EXTEND_OPCODE");
			crUnpackExtendCombinerStageParameterfvNV( );
			break;
		case CR_COMPILESHADER_EXTEND_OPCODE:
			crDebug("Unpack: CR_COMPILESHADER_EXTEND_OPCODE");
			crUnpackExtendCompileShader( );
			break;
		case CR_COMPRESSEDTEXIMAGE1DARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_COMPRESSEDTEXIMAGE1DARB_EXTEND_OPCODE");
			crUnpackExtendCompressedTexImage1DARB( );
			break;
		case CR_COMPRESSEDTEXIMAGE2DARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_COMPRESSEDTEXIMAGE2DARB_EXTEND_OPCODE");
			crUnpackExtendCompressedTexImage2DARB( );
			break;
		case CR_COMPRESSEDTEXIMAGE3DARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_COMPRESSEDTEXIMAGE3DARB_EXTEND_OPCODE");
			crUnpackExtendCompressedTexImage3DARB( );
			break;
		case CR_COMPRESSEDTEXSUBIMAGE1DARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_COMPRESSEDTEXSUBIMAGE1DARB_EXTEND_OPCODE");
			crUnpackExtendCompressedTexSubImage1DARB( );
			break;
		case CR_COMPRESSEDTEXSUBIMAGE2DARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_COMPRESSEDTEXSUBIMAGE2DARB_EXTEND_OPCODE");
			crUnpackExtendCompressedTexSubImage2DARB( );
			break;
		case CR_COMPRESSEDTEXSUBIMAGE3DARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_COMPRESSEDTEXSUBIMAGE3DARB_EXTEND_OPCODE");
			crUnpackExtendCompressedTexSubImage3DARB( );
			break;
		case CR_CREATECONTEXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_CREATECONTEXT_EXTEND_OPCODE");
			crUnpackExtendCreateContext( );
			break;
		case CR_CREATEPROGRAM_EXTEND_OPCODE:
			crDebug("Unpack: CR_CREATEPROGRAM_EXTEND_OPCODE");
			crUnpackExtendCreateProgram( );
			break;
		case CR_CREATESHADER_EXTEND_OPCODE:
			crDebug("Unpack: CR_CREATESHADER_EXTEND_OPCODE");
			crUnpackExtendCreateShader( );
			break;
		case CR_DELETEBUFFERSARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_DELETEBUFFERSARB_EXTEND_OPCODE");
			crUnpackExtendDeleteBuffersARB( );
			break;
		case CR_DELETEFENCESNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_DELETEFENCESNV_EXTEND_OPCODE");
			crUnpackExtendDeleteFencesNV( );
			break;
		case CR_DELETEFRAMEBUFFERSEXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_DELETEFRAMEBUFFERSEXT_EXTEND_OPCODE");
			crUnpackExtendDeleteFramebuffersEXT( );
			break;
		case CR_DELETELISTS_EXTEND_OPCODE:
			crDebug("Unpack: CR_DELETELISTS_EXTEND_OPCODE");
			crUnpackExtendDeleteLists( );
			break;
		case CR_DELETEOBJECTARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_DELETEOBJECTARB_EXTEND_OPCODE");
			crUnpackExtendDeleteObjectARB( );
			break;
		case CR_DELETEPROGRAM_EXTEND_OPCODE:
			crDebug("Unpack: CR_DELETEPROGRAM_EXTEND_OPCODE");
			crUnpackExtendDeleteProgram( );
			break;
		case CR_DELETEPROGRAMSARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_DELETEPROGRAMSARB_EXTEND_OPCODE");
			crUnpackExtendDeleteProgramsARB( );
			break;
		case CR_DELETEQUERIESARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_DELETEQUERIESARB_EXTEND_OPCODE");
			crUnpackExtendDeleteQueriesARB( );
			break;
		case CR_DELETERENDERBUFFERSEXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_DELETERENDERBUFFERSEXT_EXTEND_OPCODE");
			crUnpackExtendDeleteRenderbuffersEXT( );
			break;
		case CR_DELETESHADER_EXTEND_OPCODE:
			crDebug("Unpack: CR_DELETESHADER_EXTEND_OPCODE");
			crUnpackExtendDeleteShader( );
			break;
		case CR_DESTROYCONTEXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_DESTROYCONTEXT_EXTEND_OPCODE");
			crUnpackExtendDestroyContext( );
			break;
		case CR_DETACHSHADER_EXTEND_OPCODE:
			crDebug("Unpack: CR_DETACHSHADER_EXTEND_OPCODE");
			crUnpackExtendDetachShader( );
			break;
		case CR_DISABLEVERTEXATTRIBARRAYARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_DISABLEVERTEXATTRIBARRAYARB_EXTEND_OPCODE");
			crUnpackExtendDisableVertexAttribArrayARB( );
			break;
		case CR_DRAWBUFFER_EXTEND_OPCODE:
			crDebug("Unpack: CR_DRAWBUFFER_EXTEND_OPCODE");
			crUnpackExtendDrawBuffer( );
			break;
		case CR_DRAWBUFFERS_EXTEND_OPCODE:
			crDebug("Unpack: CR_DRAWBUFFERS_EXTEND_OPCODE");
			crUnpackExtendDrawBuffers( );
			break;
		case CR_DRAWELEMENTS_EXTEND_OPCODE:
			crDebug("Unpack: CR_DRAWELEMENTS_EXTEND_OPCODE");
			crUnpackExtendDrawElements( );
			break;
		case CR_DRAWRANGEELEMENTS_EXTEND_OPCODE:
			crDebug("Unpack: CR_DRAWRANGEELEMENTS_EXTEND_OPCODE");
			crUnpackExtendDrawRangeElements( );
			break;
		case CR_EDGEFLAGPOINTER_EXTEND_OPCODE:
			crDebug("Unpack: CR_EDGEFLAGPOINTER_EXTEND_OPCODE");
			crUnpackExtendEdgeFlagPointer( );
			break;
		case CR_ENABLEVERTEXATTRIBARRAYARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_ENABLEVERTEXATTRIBARRAYARB_EXTEND_OPCODE");
			crUnpackExtendEnableVertexAttribArrayARB( );
			break;
		case CR_ENDLIST_EXTEND_OPCODE:
			crDebug("Unpack: CR_ENDLIST_EXTEND_OPCODE");
			crUnpackExtendEndList( );
			break;
		case CR_ENDQUERYARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_ENDQUERYARB_EXTEND_OPCODE");
			crUnpackExtendEndQueryARB( );
			break;
		case CR_EXECUTEPROGRAMNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_EXECUTEPROGRAMNV_EXTEND_OPCODE");
			crUnpackExtendExecuteProgramNV( );
			break;
		case CR_FINALCOMBINERINPUTNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_FINALCOMBINERINPUTNV_EXTEND_OPCODE");
			crUnpackExtendFinalCombinerInputNV( );
			break;
		case CR_FINISHFENCENV_EXTEND_OPCODE:
			crDebug("Unpack: CR_FINISHFENCENV_EXTEND_OPCODE");
			crUnpackExtendFinishFenceNV( );
			break;
		case CR_FLUSHVERTEXARRAYRANGENV_EXTEND_OPCODE:
			crDebug("Unpack: CR_FLUSHVERTEXARRAYRANGENV_EXTEND_OPCODE");
			crUnpackExtendFlushVertexArrayRangeNV( );
			break;
		case CR_FOGCOORDPOINTEREXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_FOGCOORDPOINTEREXT_EXTEND_OPCODE");
			crUnpackExtendFogCoordPointerEXT( );
			break;
		case CR_FRAMEBUFFERRENDERBUFFEREXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_FRAMEBUFFERRENDERBUFFEREXT_EXTEND_OPCODE");
			crUnpackExtendFramebufferRenderbufferEXT( );
			break;
		case CR_FRAMEBUFFERTEXTURE1DEXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_FRAMEBUFFERTEXTURE1DEXT_EXTEND_OPCODE");
			crUnpackExtendFramebufferTexture1DEXT( );
			break;
		case CR_FRAMEBUFFERTEXTURE2DEXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_FRAMEBUFFERTEXTURE2DEXT_EXTEND_OPCODE");
			crUnpackExtendFramebufferTexture2DEXT( );
			break;
		case CR_FRAMEBUFFERTEXTURE3DEXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_FRAMEBUFFERTEXTURE3DEXT_EXTEND_OPCODE");
			crUnpackExtendFramebufferTexture3DEXT( );
			break;
		case CR_GENBUFFERSARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GENBUFFERSARB_EXTEND_OPCODE");
			crUnpackExtendGenBuffersARB( );
			break;
		case CR_GENFENCESNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GENFENCESNV_EXTEND_OPCODE");
			crUnpackExtendGenFencesNV( );
			break;
		case CR_GENFRAMEBUFFERSEXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_GENFRAMEBUFFERSEXT_EXTEND_OPCODE");
			crUnpackExtendGenFramebuffersEXT( );
			break;
		case CR_GENLISTS_EXTEND_OPCODE:
			crDebug("Unpack: CR_GENLISTS_EXTEND_OPCODE");
			crUnpackExtendGenLists( );
			break;
		case CR_GENPROGRAMSARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GENPROGRAMSARB_EXTEND_OPCODE");
			crUnpackExtendGenProgramsARB( );
			break;
		case CR_GENPROGRAMSNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GENPROGRAMSNV_EXTEND_OPCODE");
			crUnpackExtendGenProgramsNV( );
			break;
		case CR_GENQUERIESARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GENQUERIESARB_EXTEND_OPCODE");
			crUnpackExtendGenQueriesARB( );
			break;
		case CR_GENRENDERBUFFERSEXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_GENRENDERBUFFERSEXT_EXTEND_OPCODE");
			crUnpackExtendGenRenderbuffersEXT( );
			break;
		case CR_GENTEXTURES_EXTEND_OPCODE:
			crDebug("Unpack: CR_GENTEXTURES_EXTEND_OPCODE");
			crUnpackExtendGenTextures( );
			break;
		case CR_GENERATEMIPMAPEXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_GENERATEMIPMAPEXT_EXTEND_OPCODE");
			crUnpackExtendGenerateMipmapEXT( );
			break;
		case CR_GETACTIVEATTRIB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETACTIVEATTRIB_EXTEND_OPCODE");
			crUnpackExtendGetActiveAttrib( );
			break;
		case CR_GETACTIVEUNIFORM_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETACTIVEUNIFORM_EXTEND_OPCODE");
			crUnpackExtendGetActiveUniform( );
			break;
		case CR_GETATTACHEDOBJECTSARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETATTACHEDOBJECTSARB_EXTEND_OPCODE");
			crUnpackExtendGetAttachedObjectsARB( );
			break;
		case CR_GETATTACHEDSHADERS_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETATTACHEDSHADERS_EXTEND_OPCODE");
			crUnpackExtendGetAttachedShaders( );
			break;
		case CR_GETATTRIBLOCATION_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETATTRIBLOCATION_EXTEND_OPCODE");
			crUnpackExtendGetAttribLocation( );
			break;
		case CR_GETBOOLEANV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETBOOLEANV_EXTEND_OPCODE");
			crUnpackExtendGetBooleanv( );
			break;
		case CR_GETBUFFERPARAMETERIVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETBUFFERPARAMETERIVARB_EXTEND_OPCODE");
			crUnpackExtendGetBufferParameterivARB( );
			break;
		case CR_GETBUFFERSUBDATAARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETBUFFERSUBDATAARB_EXTEND_OPCODE");
			crUnpackExtendGetBufferSubDataARB( );
			break;
		case CR_GETCHROMIUMPARAMETERVCR_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETCHROMIUMPARAMETERVCR_EXTEND_OPCODE");
			crUnpackExtendGetChromiumParametervCR( );
			break;
		case CR_GETCLIPPLANE_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETCLIPPLANE_EXTEND_OPCODE");
			crUnpackExtendGetClipPlane( );
			break;
		case CR_GETCOMBINERINPUTPARAMETERFVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETCOMBINERINPUTPARAMETERFVNV_EXTEND_OPCODE");
			crUnpackExtendGetCombinerInputParameterfvNV( );
			break;
		case CR_GETCOMBINERINPUTPARAMETERIVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETCOMBINERINPUTPARAMETERIVNV_EXTEND_OPCODE");
			crUnpackExtendGetCombinerInputParameterivNV( );
			break;
		case CR_GETCOMBINEROUTPUTPARAMETERFVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETCOMBINEROUTPUTPARAMETERFVNV_EXTEND_OPCODE");
			crUnpackExtendGetCombinerOutputParameterfvNV( );
			break;
		case CR_GETCOMBINEROUTPUTPARAMETERIVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETCOMBINEROUTPUTPARAMETERIVNV_EXTEND_OPCODE");
			crUnpackExtendGetCombinerOutputParameterivNV( );
			break;
		case CR_GETCOMBINERSTAGEPARAMETERFVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETCOMBINERSTAGEPARAMETERFVNV_EXTEND_OPCODE");
			crUnpackExtendGetCombinerStageParameterfvNV( );
			break;
		case CR_GETCOMPRESSEDTEXIMAGEARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETCOMPRESSEDTEXIMAGEARB_EXTEND_OPCODE");
			crUnpackExtendGetCompressedTexImageARB( );
			break;
		case CR_GETDOUBLEV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETDOUBLEV_EXTEND_OPCODE");
			crUnpackExtendGetDoublev( );
			break;
		case CR_GETERROR_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETERROR_EXTEND_OPCODE");
			crUnpackExtendGetError( );
			break;
		case CR_GETFENCEIVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETFENCEIVNV_EXTEND_OPCODE");
			crUnpackExtendGetFenceivNV( );
			break;
		case CR_GETFINALCOMBINERINPUTPARAMETERFVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETFINALCOMBINERINPUTPARAMETERFVNV_EXTEND_OPCODE");
			crUnpackExtendGetFinalCombinerInputParameterfvNV( );
			break;
		case CR_GETFINALCOMBINERINPUTPARAMETERIVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETFINALCOMBINERINPUTPARAMETERIVNV_EXTEND_OPCODE");
			crUnpackExtendGetFinalCombinerInputParameterivNV( );
			break;
		case CR_GETFLOATV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETFLOATV_EXTEND_OPCODE");
			crUnpackExtendGetFloatv( );
			break;
		case CR_GETFRAMEBUFFERATTACHMENTPARAMETERIVEXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETFRAMEBUFFERATTACHMENTPARAMETERIVEXT_EXTEND_OPCODE");
			crUnpackExtendGetFramebufferAttachmentParameterivEXT( );
			break;
		case CR_GETHANDLEARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETHANDLEARB_EXTEND_OPCODE");
			crUnpackExtendGetHandleARB( );
			break;
		case CR_GETINFOLOGARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETINFOLOGARB_EXTEND_OPCODE");
			crUnpackExtendGetInfoLogARB( );
			break;
		case CR_GETINTEGERV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETINTEGERV_EXTEND_OPCODE");
			crUnpackExtendGetIntegerv( );
			break;
		case CR_GETLIGHTFV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETLIGHTFV_EXTEND_OPCODE");
			crUnpackExtendGetLightfv( );
			break;
		case CR_GETLIGHTIV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETLIGHTIV_EXTEND_OPCODE");
			crUnpackExtendGetLightiv( );
			break;
		case CR_GETMAPDV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETMAPDV_EXTEND_OPCODE");
			crUnpackExtendGetMapdv( );
			break;
		case CR_GETMAPFV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETMAPFV_EXTEND_OPCODE");
			crUnpackExtendGetMapfv( );
			break;
		case CR_GETMAPIV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETMAPIV_EXTEND_OPCODE");
			crUnpackExtendGetMapiv( );
			break;
		case CR_GETMATERIALFV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETMATERIALFV_EXTEND_OPCODE");
			crUnpackExtendGetMaterialfv( );
			break;
		case CR_GETMATERIALIV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETMATERIALIV_EXTEND_OPCODE");
			crUnpackExtendGetMaterialiv( );
			break;
		case CR_GETOBJECTPARAMETERFVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETOBJECTPARAMETERFVARB_EXTEND_OPCODE");
			crUnpackExtendGetObjectParameterfvARB( );
			break;
		case CR_GETOBJECTPARAMETERIVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETOBJECTPARAMETERIVARB_EXTEND_OPCODE");
			crUnpackExtendGetObjectParameterivARB( );
			break;
		case CR_GETPIXELMAPFV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETPIXELMAPFV_EXTEND_OPCODE");
			crUnpackExtendGetPixelMapfv( );
			break;
		case CR_GETPIXELMAPUIV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETPIXELMAPUIV_EXTEND_OPCODE");
			crUnpackExtendGetPixelMapuiv( );
			break;
		case CR_GETPIXELMAPUSV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETPIXELMAPUSV_EXTEND_OPCODE");
			crUnpackExtendGetPixelMapusv( );
			break;
		case CR_GETPOINTERV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETPOINTERV_EXTEND_OPCODE");
			crUnpackExtendGetPointerv( );
			break;
		case CR_GETPOLYGONSTIPPLE_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETPOLYGONSTIPPLE_EXTEND_OPCODE");
			crUnpackExtendGetPolygonStipple( );
			break;
		case CR_GETPROGRAMENVPARAMETERDVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETPROGRAMENVPARAMETERDVARB_EXTEND_OPCODE");
			crUnpackExtendGetProgramEnvParameterdvARB( );
			break;
		case CR_GETPROGRAMENVPARAMETERFVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETPROGRAMENVPARAMETERFVARB_EXTEND_OPCODE");
			crUnpackExtendGetProgramEnvParameterfvARB( );
			break;
		case CR_GETPROGRAMINFOLOG_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETPROGRAMINFOLOG_EXTEND_OPCODE");
			crUnpackExtendGetProgramInfoLog( );
			break;
		case CR_GETPROGRAMLOCALPARAMETERDVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETPROGRAMLOCALPARAMETERDVARB_EXTEND_OPCODE");
			crUnpackExtendGetProgramLocalParameterdvARB( );
			break;
		case CR_GETPROGRAMLOCALPARAMETERFVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETPROGRAMLOCALPARAMETERFVARB_EXTEND_OPCODE");
			crUnpackExtendGetProgramLocalParameterfvARB( );
			break;
		case CR_GETPROGRAMNAMEDPARAMETERDVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETPROGRAMNAMEDPARAMETERDVNV_EXTEND_OPCODE");
			crUnpackExtendGetProgramNamedParameterdvNV( );
			break;
		case CR_GETPROGRAMNAMEDPARAMETERFVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETPROGRAMNAMEDPARAMETERFVNV_EXTEND_OPCODE");
			crUnpackExtendGetProgramNamedParameterfvNV( );
			break;
		case CR_GETPROGRAMPARAMETERDVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETPROGRAMPARAMETERDVNV_EXTEND_OPCODE");
			crUnpackExtendGetProgramParameterdvNV( );
			break;
		case CR_GETPROGRAMPARAMETERFVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETPROGRAMPARAMETERFVNV_EXTEND_OPCODE");
			crUnpackExtendGetProgramParameterfvNV( );
			break;
		case CR_GETPROGRAMSTRINGARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETPROGRAMSTRINGARB_EXTEND_OPCODE");
			crUnpackExtendGetProgramStringARB( );
			break;
		case CR_GETPROGRAMSTRINGNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETPROGRAMSTRINGNV_EXTEND_OPCODE");
			crUnpackExtendGetProgramStringNV( );
			break;
		case CR_GETPROGRAMIV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETPROGRAMIV_EXTEND_OPCODE");
			crUnpackExtendGetProgramiv( );
			break;
		case CR_GETPROGRAMIVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETPROGRAMIVARB_EXTEND_OPCODE");
			crUnpackExtendGetProgramivARB( );
			break;
		case CR_GETPROGRAMIVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETPROGRAMIVNV_EXTEND_OPCODE");
			crUnpackExtendGetProgramivNV( );
			break;
		case CR_GETQUERYOBJECTIVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETQUERYOBJECTIVARB_EXTEND_OPCODE");
			crUnpackExtendGetQueryObjectivARB( );
			break;
		case CR_GETQUERYOBJECTUIVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETQUERYOBJECTUIVARB_EXTEND_OPCODE");
			crUnpackExtendGetQueryObjectuivARB( );
			break;
		case CR_GETQUERYIVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETQUERYIVARB_EXTEND_OPCODE");
			crUnpackExtendGetQueryivARB( );
			break;
		case CR_GETRENDERBUFFERPARAMETERIVEXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETRENDERBUFFERPARAMETERIVEXT_EXTEND_OPCODE");
			crUnpackExtendGetRenderbufferParameterivEXT( );
			break;
		case CR_GETSHADERINFOLOG_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETSHADERINFOLOG_EXTEND_OPCODE");
			crUnpackExtendGetShaderInfoLog( );
			break;
		case CR_GETSHADERSOURCE_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETSHADERSOURCE_EXTEND_OPCODE");
			crUnpackExtendGetShaderSource( );
			break;
		case CR_GETSHADERIV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETSHADERIV_EXTEND_OPCODE");
			crUnpackExtendGetShaderiv( );
			break;
		case CR_GETSTRING_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETSTRING_EXTEND_OPCODE");
			crUnpackExtendGetString( );
			break;
		case CR_GETTEXENVFV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETTEXENVFV_EXTEND_OPCODE");
			crUnpackExtendGetTexEnvfv( );
			break;
		case CR_GETTEXENVIV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETTEXENVIV_EXTEND_OPCODE");
			crUnpackExtendGetTexEnviv( );
			break;
		case CR_GETTEXGENDV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETTEXGENDV_EXTEND_OPCODE");
			crUnpackExtendGetTexGendv( );
			break;
		case CR_GETTEXGENFV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETTEXGENFV_EXTEND_OPCODE");
			crUnpackExtendGetTexGenfv( );
			break;
		case CR_GETTEXGENIV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETTEXGENIV_EXTEND_OPCODE");
			crUnpackExtendGetTexGeniv( );
			break;
		case CR_GETTEXIMAGE_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETTEXIMAGE_EXTEND_OPCODE");
			crUnpackExtendGetTexImage( );
			break;
		case CR_GETTEXLEVELPARAMETERFV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETTEXLEVELPARAMETERFV_EXTEND_OPCODE");
			crUnpackExtendGetTexLevelParameterfv( );
			break;
		case CR_GETTEXLEVELPARAMETERIV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETTEXLEVELPARAMETERIV_EXTEND_OPCODE");
			crUnpackExtendGetTexLevelParameteriv( );
			break;
		case CR_GETTEXPARAMETERFV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETTEXPARAMETERFV_EXTEND_OPCODE");
			crUnpackExtendGetTexParameterfv( );
			break;
		case CR_GETTEXPARAMETERIV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETTEXPARAMETERIV_EXTEND_OPCODE");
			crUnpackExtendGetTexParameteriv( );
			break;
		case CR_GETTRACKMATRIXIVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETTRACKMATRIXIVNV_EXTEND_OPCODE");
			crUnpackExtendGetTrackMatrixivNV( );
			break;
		case CR_GETUNIFORMLOCATION_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETUNIFORMLOCATION_EXTEND_OPCODE");
			crUnpackExtendGetUniformLocation( );
			break;
		case CR_GETUNIFORMFV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETUNIFORMFV_EXTEND_OPCODE");
			crUnpackExtendGetUniformfv( );
			break;
		case CR_GETUNIFORMIV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETUNIFORMIV_EXTEND_OPCODE");
			crUnpackExtendGetUniformiv( );
			break;
		case CR_GETUNIFORMSLOCATIONS_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETUNIFORMSLOCATIONS_EXTEND_OPCODE");
			crUnpackExtendGetUniformsLocations( );
			break;
		case CR_GETVERTEXATTRIBPOINTERVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETVERTEXATTRIBPOINTERVARB_EXTEND_OPCODE");
			crUnpackExtendGetVertexAttribPointervARB( );
			break;
		case CR_GETVERTEXATTRIBPOINTERVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETVERTEXATTRIBPOINTERVNV_EXTEND_OPCODE");
			crUnpackExtendGetVertexAttribPointervNV( );
			break;
		case CR_GETVERTEXATTRIBDVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETVERTEXATTRIBDVARB_EXTEND_OPCODE");
			crUnpackExtendGetVertexAttribdvARB( );
			break;
		case CR_GETVERTEXATTRIBDVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETVERTEXATTRIBDVNV_EXTEND_OPCODE");
			crUnpackExtendGetVertexAttribdvNV( );
			break;
		case CR_GETVERTEXATTRIBFVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETVERTEXATTRIBFVARB_EXTEND_OPCODE");
			crUnpackExtendGetVertexAttribfvARB( );
			break;
		case CR_GETVERTEXATTRIBFVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETVERTEXATTRIBFVNV_EXTEND_OPCODE");
			crUnpackExtendGetVertexAttribfvNV( );
			break;
		case CR_GETVERTEXATTRIBIVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETVERTEXATTRIBIVARB_EXTEND_OPCODE");
			crUnpackExtendGetVertexAttribivARB( );
			break;
		case CR_GETVERTEXATTRIBIVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_GETVERTEXATTRIBIVNV_EXTEND_OPCODE");
			crUnpackExtendGetVertexAttribivNV( );
			break;
		case CR_HINT_EXTEND_OPCODE:
			crDebug("Unpack: CR_HINT_EXTEND_OPCODE");
			crUnpackExtendHint( );
			break;
		case CR_INDEXPOINTER_EXTEND_OPCODE:
			crDebug("Unpack: CR_INDEXPOINTER_EXTEND_OPCODE");
			crUnpackExtendIndexPointer( );
			break;
		case CR_INTERLEAVEDARRAYS_EXTEND_OPCODE:
			crDebug("Unpack: CR_INTERLEAVEDARRAYS_EXTEND_OPCODE");
			crUnpackExtendInterleavedArrays( );
			break;
		case CR_ISBUFFERARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_ISBUFFERARB_EXTEND_OPCODE");
			crUnpackExtendIsBufferARB( );
			break;
		case CR_ISENABLED_EXTEND_OPCODE:
			crDebug("Unpack: CR_ISENABLED_EXTEND_OPCODE");
			crUnpackExtendIsEnabled( );
			break;
		case CR_ISFENCENV_EXTEND_OPCODE:
			crDebug("Unpack: CR_ISFENCENV_EXTEND_OPCODE");
			crUnpackExtendIsFenceNV( );
			break;
		case CR_ISFRAMEBUFFEREXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_ISFRAMEBUFFEREXT_EXTEND_OPCODE");
			crUnpackExtendIsFramebufferEXT( );
			break;
		case CR_ISLIST_EXTEND_OPCODE:
			crDebug("Unpack: CR_ISLIST_EXTEND_OPCODE");
			crUnpackExtendIsList( );
			break;
		case CR_ISPROGRAM_EXTEND_OPCODE:
			crDebug("Unpack: CR_ISPROGRAM_EXTEND_OPCODE");
			crUnpackExtendIsProgram( );
			break;
		case CR_ISPROGRAMARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_ISPROGRAMARB_EXTEND_OPCODE");
			crUnpackExtendIsProgramARB( );
			break;
		case CR_ISQUERYARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_ISQUERYARB_EXTEND_OPCODE");
			crUnpackExtendIsQueryARB( );
			break;
		case CR_ISRENDERBUFFEREXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_ISRENDERBUFFEREXT_EXTEND_OPCODE");
			crUnpackExtendIsRenderbufferEXT( );
			break;
		case CR_ISSHADER_EXTEND_OPCODE:
			crDebug("Unpack: CR_ISSHADER_EXTEND_OPCODE");
			crUnpackExtendIsShader( );
			break;
		case CR_ISTEXTURE_EXTEND_OPCODE:
			crDebug("Unpack: CR_ISTEXTURE_EXTEND_OPCODE");
			crUnpackExtendIsTexture( );
			break;
		case CR_LINKPROGRAM_EXTEND_OPCODE:
			crDebug("Unpack: CR_LINKPROGRAM_EXTEND_OPCODE");
			crUnpackExtendLinkProgram( );
			break;
		case CR_LISTBASE_EXTEND_OPCODE:
			crDebug("Unpack: CR_LISTBASE_EXTEND_OPCODE");
			crUnpackExtendListBase( );
			break;
		case CR_LOADPROGRAMNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_LOADPROGRAMNV_EXTEND_OPCODE");
			crUnpackExtendLoadProgramNV( );
			break;
		case CR_LOADTRANSPOSEMATRIXDARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_LOADTRANSPOSEMATRIXDARB_EXTEND_OPCODE");
			crUnpackExtendLoadTransposeMatrixdARB( );
			break;
		case CR_LOADTRANSPOSEMATRIXFARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_LOADTRANSPOSEMATRIXFARB_EXTEND_OPCODE");
			crUnpackExtendLoadTransposeMatrixfARB( );
			break;
		case CR_LOCKARRAYSEXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_LOCKARRAYSEXT_EXTEND_OPCODE");
			crUnpackExtendLockArraysEXT( );
			break;
		case CR_LOGICOP_EXTEND_OPCODE:
			crDebug("Unpack: CR_LOGICOP_EXTEND_OPCODE");
			crUnpackExtendLogicOp( );
			break;
		case CR_MAKECURRENT_EXTEND_OPCODE:
			crDebug("Unpack: CR_MAKECURRENT_EXTEND_OPCODE");
			crUnpackExtendMakeCurrent( );
			break;
		case CR_MULTTRANSPOSEMATRIXDARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_MULTTRANSPOSEMATRIXDARB_EXTEND_OPCODE");
			crUnpackExtendMultTransposeMatrixdARB( );
			break;
		case CR_MULTTRANSPOSEMATRIXFARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_MULTTRANSPOSEMATRIXFARB_EXTEND_OPCODE");
			crUnpackExtendMultTransposeMatrixfARB( );
			break;
		case CR_NEWLIST_EXTEND_OPCODE:
			crDebug("Unpack: CR_NEWLIST_EXTEND_OPCODE");
			crUnpackExtendNewList( );
			break;
		case CR_NORMALPOINTER_EXTEND_OPCODE:
			crDebug("Unpack: CR_NORMALPOINTER_EXTEND_OPCODE");
			crUnpackExtendNormalPointer( );
			break;
		case CR_POINTPARAMETERFARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_POINTPARAMETERFARB_EXTEND_OPCODE");
			crUnpackExtendPointParameterfARB( );
			break;
		case CR_POINTPARAMETERFVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_POINTPARAMETERFVARB_EXTEND_OPCODE");
			crUnpackExtendPointParameterfvARB( );
			break;
		case CR_POINTPARAMETERI_EXTEND_OPCODE:
			crDebug("Unpack: CR_POINTPARAMETERI_EXTEND_OPCODE");
			crUnpackExtendPointParameteri( );
			break;
		case CR_POINTPARAMETERIV_EXTEND_OPCODE:
			crDebug("Unpack: CR_POINTPARAMETERIV_EXTEND_OPCODE");
			crUnpackExtendPointParameteriv( );
			break;
		case CR_POPATTRIB_EXTEND_OPCODE:
			crDebug("Unpack: CR_POPATTRIB_EXTEND_OPCODE");
			crUnpackExtendPopAttrib( );
			break;
		case CR_POPCLIENTATTRIB_EXTEND_OPCODE:
			crDebug("Unpack: CR_POPCLIENTATTRIB_EXTEND_OPCODE");
			crUnpackExtendPopClientAttrib( );
			break;
		case CR_PROGRAMENVPARAMETER4DARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_PROGRAMENVPARAMETER4DARB_EXTEND_OPCODE");
			crUnpackExtendProgramEnvParameter4dARB( );
			break;
		case CR_PROGRAMENVPARAMETER4DVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_PROGRAMENVPARAMETER4DVARB_EXTEND_OPCODE");
			crUnpackExtendProgramEnvParameter4dvARB( );
			break;
		case CR_PROGRAMENVPARAMETER4FARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_PROGRAMENVPARAMETER4FARB_EXTEND_OPCODE");
			crUnpackExtendProgramEnvParameter4fARB( );
			break;
		case CR_PROGRAMENVPARAMETER4FVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_PROGRAMENVPARAMETER4FVARB_EXTEND_OPCODE");
			crUnpackExtendProgramEnvParameter4fvARB( );
			break;
		case CR_PROGRAMLOCALPARAMETER4DARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_PROGRAMLOCALPARAMETER4DARB_EXTEND_OPCODE");
			crUnpackExtendProgramLocalParameter4dARB( );
			break;
		case CR_PROGRAMLOCALPARAMETER4DVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_PROGRAMLOCALPARAMETER4DVARB_EXTEND_OPCODE");
			crUnpackExtendProgramLocalParameter4dvARB( );
			break;
		case CR_PROGRAMLOCALPARAMETER4FARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_PROGRAMLOCALPARAMETER4FARB_EXTEND_OPCODE");
			crUnpackExtendProgramLocalParameter4fARB( );
			break;
		case CR_PROGRAMLOCALPARAMETER4FVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_PROGRAMLOCALPARAMETER4FVARB_EXTEND_OPCODE");
			crUnpackExtendProgramLocalParameter4fvARB( );
			break;
		case CR_PROGRAMNAMEDPARAMETER4DNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_PROGRAMNAMEDPARAMETER4DNV_EXTEND_OPCODE");
			crUnpackExtendProgramNamedParameter4dNV( );
			break;
		case CR_PROGRAMNAMEDPARAMETER4DVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_PROGRAMNAMEDPARAMETER4DVNV_EXTEND_OPCODE");
			crUnpackExtendProgramNamedParameter4dvNV( );
			break;
		case CR_PROGRAMNAMEDPARAMETER4FNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_PROGRAMNAMEDPARAMETER4FNV_EXTEND_OPCODE");
			crUnpackExtendProgramNamedParameter4fNV( );
			break;
		case CR_PROGRAMNAMEDPARAMETER4FVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_PROGRAMNAMEDPARAMETER4FVNV_EXTEND_OPCODE");
			crUnpackExtendProgramNamedParameter4fvNV( );
			break;
		case CR_PROGRAMPARAMETER4DNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_PROGRAMPARAMETER4DNV_EXTEND_OPCODE");
			crUnpackExtendProgramParameter4dNV( );
			break;
		case CR_PROGRAMPARAMETER4DVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_PROGRAMPARAMETER4DVNV_EXTEND_OPCODE");
			crUnpackExtendProgramParameter4dvNV( );
			break;
		case CR_PROGRAMPARAMETER4FNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_PROGRAMPARAMETER4FNV_EXTEND_OPCODE");
			crUnpackExtendProgramParameter4fNV( );
			break;
		case CR_PROGRAMPARAMETER4FVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_PROGRAMPARAMETER4FVNV_EXTEND_OPCODE");
			crUnpackExtendProgramParameter4fvNV( );
			break;
		case CR_PROGRAMPARAMETERS4DVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_PROGRAMPARAMETERS4DVNV_EXTEND_OPCODE");
			crUnpackExtendProgramParameters4dvNV( );
			break;
		case CR_PROGRAMPARAMETERS4FVNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_PROGRAMPARAMETERS4FVNV_EXTEND_OPCODE");
			crUnpackExtendProgramParameters4fvNV( );
			break;
		case CR_PROGRAMSTRINGARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_PROGRAMSTRINGARB_EXTEND_OPCODE");
			crUnpackExtendProgramStringARB( );
			break;
		case CR_PUSHATTRIB_EXTEND_OPCODE:
			crDebug("Unpack: CR_PUSHATTRIB_EXTEND_OPCODE");
			crUnpackExtendPushAttrib( );
			break;
		case CR_PUSHCLIENTATTRIB_EXTEND_OPCODE:
			crDebug("Unpack: CR_PUSHCLIENTATTRIB_EXTEND_OPCODE");
			crUnpackExtendPushClientAttrib( );
			break;
		case CR_READBUFFER_EXTEND_OPCODE:
			crDebug("Unpack: CR_READBUFFER_EXTEND_OPCODE");
			crUnpackExtendReadBuffer( );
			break;
		case CR_RENDERMODE_EXTEND_OPCODE:
			crDebug("Unpack: CR_RENDERMODE_EXTEND_OPCODE");
			crUnpackExtendRenderMode( );
			break;
		case CR_RENDERBUFFERSTORAGEEXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_RENDERBUFFERSTORAGEEXT_EXTEND_OPCODE");
			crUnpackExtendRenderbufferStorageEXT( );
			break;
		case CR_REQUESTRESIDENTPROGRAMSNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_REQUESTRESIDENTPROGRAMSNV_EXTEND_OPCODE");
			crUnpackExtendRequestResidentProgramsNV( );
			break;
		case CR_SAMPLECOVERAGEARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_SAMPLECOVERAGEARB_EXTEND_OPCODE");
			crUnpackExtendSampleCoverageARB( );
			break;
		case CR_SECONDARYCOLORPOINTEREXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_SECONDARYCOLORPOINTEREXT_EXTEND_OPCODE");
			crUnpackExtendSecondaryColorPointerEXT( );
			break;
		case CR_SEMAPHORECREATECR_EXTEND_OPCODE:
			crDebug("Unpack: CR_SEMAPHORECREATECR_EXTEND_OPCODE");
			crUnpackExtendSemaphoreCreateCR( );
			break;
		case CR_SEMAPHOREDESTROYCR_EXTEND_OPCODE:
			crDebug("Unpack: CR_SEMAPHOREDESTROYCR_EXTEND_OPCODE");
			crUnpackExtendSemaphoreDestroyCR( );
			break;
		case CR_SEMAPHOREPCR_EXTEND_OPCODE:
			crDebug("Unpack: CR_SEMAPHOREPCR_EXTEND_OPCODE");
			crUnpackExtendSemaphorePCR( );
			break;
		case CR_SEMAPHOREVCR_EXTEND_OPCODE:
			crDebug("Unpack: CR_SEMAPHOREVCR_EXTEND_OPCODE");
			crUnpackExtendSemaphoreVCR( );
			break;
		case CR_SETFENCENV_EXTEND_OPCODE:
			crDebug("Unpack: CR_SETFENCENV_EXTEND_OPCODE");
			crUnpackExtendSetFenceNV( );
			break;
		case CR_SHADERSOURCE_EXTEND_OPCODE:
			crDebug("Unpack: CR_SHADERSOURCE_EXTEND_OPCODE");
			crUnpackExtendShaderSource( );
			break;
		case CR_STENCILFUNCSEPARATE_EXTEND_OPCODE:
			crDebug("Unpack: CR_STENCILFUNCSEPARATE_EXTEND_OPCODE");
			crUnpackExtendStencilFuncSeparate( );
			break;
		case CR_STENCILMASKSEPARATE_EXTEND_OPCODE:
			crDebug("Unpack: CR_STENCILMASKSEPARATE_EXTEND_OPCODE");
			crUnpackExtendStencilMaskSeparate( );
			break;
		case CR_STENCILOPSEPARATE_EXTEND_OPCODE:
			crDebug("Unpack: CR_STENCILOPSEPARATE_EXTEND_OPCODE");
			crUnpackExtendStencilOpSeparate( );
			break;
		case CR_SWAPBUFFERS_EXTEND_OPCODE:
			crDebug("Unpack: CR_SWAPBUFFERS_EXTEND_OPCODE");
			crUnpackExtendSwapBuffers( );
			break;
		case CR_TESTFENCENV_EXTEND_OPCODE:
			crDebug("Unpack: CR_TESTFENCENV_EXTEND_OPCODE");
			crUnpackExtendTestFenceNV( );
			break;
		case CR_TEXCOORDPOINTER_EXTEND_OPCODE:
			crDebug("Unpack: CR_TEXCOORDPOINTER_EXTEND_OPCODE");
			crUnpackExtendTexCoordPointer( );
			break;
		case CR_TRACKMATRIXNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_TRACKMATRIXNV_EXTEND_OPCODE");
			crUnpackExtendTrackMatrixNV( );
			break;
		case CR_UNIFORM1F_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORM1F_EXTEND_OPCODE");
			crUnpackExtendUniform1f( );
			break;
		case CR_UNIFORM1FV_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORM1FV_EXTEND_OPCODE");
			crUnpackExtendUniform1fv( );
			break;
		case CR_UNIFORM1I_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORM1I_EXTEND_OPCODE");
			crUnpackExtendUniform1i( );
			break;
		case CR_UNIFORM1IV_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORM1IV_EXTEND_OPCODE");
			crUnpackExtendUniform1iv( );
			break;
		case CR_UNIFORM2F_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORM2F_EXTEND_OPCODE");
			crUnpackExtendUniform2f( );
			break;
		case CR_UNIFORM2FV_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORM2FV_EXTEND_OPCODE");
			crUnpackExtendUniform2fv( );
			break;
		case CR_UNIFORM2I_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORM2I_EXTEND_OPCODE");
			crUnpackExtendUniform2i( );
			break;
		case CR_UNIFORM2IV_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORM2IV_EXTEND_OPCODE");
			crUnpackExtendUniform2iv( );
			break;
		case CR_UNIFORM3F_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORM3F_EXTEND_OPCODE");
			crUnpackExtendUniform3f( );
			break;
		case CR_UNIFORM3FV_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORM3FV_EXTEND_OPCODE");
			crUnpackExtendUniform3fv( );
			break;
		case CR_UNIFORM3I_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORM3I_EXTEND_OPCODE");
			crUnpackExtendUniform3i( );
			break;
		case CR_UNIFORM3IV_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORM3IV_EXTEND_OPCODE");
			crUnpackExtendUniform3iv( );
			break;
		case CR_UNIFORM4F_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORM4F_EXTEND_OPCODE");
			crUnpackExtendUniform4f( );
			break;
		case CR_UNIFORM4FV_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORM4FV_EXTEND_OPCODE");
			crUnpackExtendUniform4fv( );
			break;
		case CR_UNIFORM4I_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORM4I_EXTEND_OPCODE");
			crUnpackExtendUniform4i( );
			break;
		case CR_UNIFORM4IV_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORM4IV_EXTEND_OPCODE");
			crUnpackExtendUniform4iv( );
			break;
		case CR_UNIFORMMATRIX2FV_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORMMATRIX2FV_EXTEND_OPCODE");
			crUnpackExtendUniformMatrix2fv( );
			break;
		case CR_UNIFORMMATRIX2X3FV_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORMMATRIX2X3FV_EXTEND_OPCODE");
			crUnpackExtendUniformMatrix2x3fv( );
			break;
		case CR_UNIFORMMATRIX2X4FV_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORMMATRIX2X4FV_EXTEND_OPCODE");
			crUnpackExtendUniformMatrix2x4fv( );
			break;
		case CR_UNIFORMMATRIX3FV_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORMMATRIX3FV_EXTEND_OPCODE");
			crUnpackExtendUniformMatrix3fv( );
			break;
		case CR_UNIFORMMATRIX3X2FV_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORMMATRIX3X2FV_EXTEND_OPCODE");
			crUnpackExtendUniformMatrix3x2fv( );
			break;
		case CR_UNIFORMMATRIX3X4FV_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORMMATRIX3X4FV_EXTEND_OPCODE");
			crUnpackExtendUniformMatrix3x4fv( );
			break;
		case CR_UNIFORMMATRIX4FV_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORMMATRIX4FV_EXTEND_OPCODE");
			crUnpackExtendUniformMatrix4fv( );
			break;
		case CR_UNIFORMMATRIX4X2FV_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORMMATRIX4X2FV_EXTEND_OPCODE");
			crUnpackExtendUniformMatrix4x2fv( );
			break;
		case CR_UNIFORMMATRIX4X3FV_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNIFORMMATRIX4X3FV_EXTEND_OPCODE");
			crUnpackExtendUniformMatrix4x3fv( );
			break;
		case CR_UNLOCKARRAYSEXT_EXTEND_OPCODE:
			crDebug("Unpack: CR_UNLOCKARRAYSEXT_EXTEND_OPCODE");
			crUnpackExtendUnlockArraysEXT( );
			break;
		case CR_USEPROGRAM_EXTEND_OPCODE:
			crDebug("Unpack: CR_USEPROGRAM_EXTEND_OPCODE");
			crUnpackExtendUseProgram( );
			break;
		case CR_VBOXTEXPRESENT_EXTEND_OPCODE:
			crDebug("Unpack: CR_VBOXTEXPRESENT_EXTEND_OPCODE");
			crUnpackExtendVBoxTexPresent( );
			break;
		case CR_VALIDATEPROGRAM_EXTEND_OPCODE:
			crDebug("Unpack: CR_VALIDATEPROGRAM_EXTEND_OPCODE");
			crUnpackExtendValidateProgram( );
			break;
		case CR_VERTEXARRAYRANGENV_EXTEND_OPCODE:
			crDebug("Unpack: CR_VERTEXARRAYRANGENV_EXTEND_OPCODE");
			crUnpackExtendVertexArrayRangeNV( );
			break;
		case CR_VERTEXATTRIBPOINTERARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_VERTEXATTRIBPOINTERARB_EXTEND_OPCODE");
			crUnpackExtendVertexAttribPointerARB( );
			break;
		case CR_VERTEXATTRIBPOINTERNV_EXTEND_OPCODE:
			crDebug("Unpack: CR_VERTEXATTRIBPOINTERNV_EXTEND_OPCODE");
			crUnpackExtendVertexAttribPointerNV( );
			break;
		case CR_VERTEXPOINTER_EXTEND_OPCODE:
			crDebug("Unpack: CR_VERTEXPOINTER_EXTEND_OPCODE");
			crUnpackExtendVertexPointer( );
			break;
		case CR_WINDOWCREATE_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWCREATE_EXTEND_OPCODE");
			crUnpackExtendWindowCreate( );
			break;
		case CR_WINDOWDESTROY_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWDESTROY_EXTEND_OPCODE");
			crUnpackExtendWindowDestroy( );
			break;
		case CR_WINDOWPOS2DARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWPOS2DARB_EXTEND_OPCODE");
			crUnpackExtendWindowPos2dARB( );
			break;
		case CR_WINDOWPOS2DVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWPOS2DVARB_EXTEND_OPCODE");
			crUnpackExtendWindowPos2dvARB( );
			break;
		case CR_WINDOWPOS2FARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWPOS2FARB_EXTEND_OPCODE");
			crUnpackExtendWindowPos2fARB( );
			break;
		case CR_WINDOWPOS2FVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWPOS2FVARB_EXTEND_OPCODE");
			crUnpackExtendWindowPos2fvARB( );
			break;
		case CR_WINDOWPOS2IARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWPOS2IARB_EXTEND_OPCODE");
			crUnpackExtendWindowPos2iARB( );
			break;
		case CR_WINDOWPOS2IVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWPOS2IVARB_EXTEND_OPCODE");
			crUnpackExtendWindowPos2ivARB( );
			break;
		case CR_WINDOWPOS2SARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWPOS2SARB_EXTEND_OPCODE");
			crUnpackExtendWindowPos2sARB( );
			break;
		case CR_WINDOWPOS2SVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWPOS2SVARB_EXTEND_OPCODE");
			crUnpackExtendWindowPos2svARB( );
			break;
		case CR_WINDOWPOS3DARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWPOS3DARB_EXTEND_OPCODE");
			crUnpackExtendWindowPos3dARB( );
			break;
		case CR_WINDOWPOS3DVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWPOS3DVARB_EXTEND_OPCODE");
			crUnpackExtendWindowPos3dvARB( );
			break;
		case CR_WINDOWPOS3FARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWPOS3FARB_EXTEND_OPCODE");
			crUnpackExtendWindowPos3fARB( );
			break;
		case CR_WINDOWPOS3FVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWPOS3FVARB_EXTEND_OPCODE");
			crUnpackExtendWindowPos3fvARB( );
			break;
		case CR_WINDOWPOS3IARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWPOS3IARB_EXTEND_OPCODE");
			crUnpackExtendWindowPos3iARB( );
			break;
		case CR_WINDOWPOS3IVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWPOS3IVARB_EXTEND_OPCODE");
			crUnpackExtendWindowPos3ivARB( );
			break;
		case CR_WINDOWPOS3SARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWPOS3SARB_EXTEND_OPCODE");
			crUnpackExtendWindowPos3sARB( );
			break;
		case CR_WINDOWPOS3SVARB_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWPOS3SVARB_EXTEND_OPCODE");
			crUnpackExtendWindowPos3svARB( );
			break;
		case CR_WINDOWPOSITION_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWPOSITION_EXTEND_OPCODE");
			crUnpackExtendWindowPosition( );
			break;
		case CR_WINDOWSHOW_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWSHOW_EXTEND_OPCODE");
			crUnpackExtendWindowShow( );
			break;
		case CR_WINDOWSIZE_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWSIZE_EXTEND_OPCODE");
			crUnpackExtendWindowSize( );
			break;
		case CR_WINDOWVISIBLEREGION_EXTEND_OPCODE:
			crDebug("Unpack: CR_WINDOWVISIBLEREGION_EXTEND_OPCODE");
			crUnpackExtendWindowVisibleRegion( );
			break;
		case CR_WRITEBACK_EXTEND_OPCODE:
			crDebug("Unpack: CR_WRITEBACK_EXTEND_OPCODE");
			crUnpackExtendWriteback( );
			break;
		case CR_ZPIXCR_EXTEND_OPCODE:
			crDebug("Unpack: CR_ZPIXCR_EXTEND_OPCODE");
			crUnpackExtendZPixCR( );
			break;
       default:
            crError( "Unknown extended opcode: %d", (int) extend_opcode );
            break;
    }
    INCR_VAR_PTR();
}
